// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/AccidentSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/accident_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x40, 0x45, 0xc0, 0x9a, 0x24, 0x26, 0x35, 0x46,
      0xea, 0xa4, 0xa9, 0xb4, 0xc8, 0xfb, 0xe1, 0x33,
      0x96, 0x17, 0x39, 0x23, 0x6e, 0x5b, 0x56, 0x4d,
      0x8d, 0xe0, 0x36, 0x29, 0x53, 0x6f, 0x0e, 0xd0,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/AccidentSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__TYPE_NAME, 45, 45},
      {etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# AccidentSubCauseCode ::= INTEGER {\n"
  "#     unavailable                         (0),\n"
  "#     multiVehicleAccident                (1),\n"
  "#     heavyAccident                       (2),\n"
  "#     accidentInvolvingLorry              (3),\n"
  "#     accidentInvolvingBus                (4),\n"
  "#     accidentInvolvingHazardousMaterials (5),\n"
  "#     accidentOnOppositeLane              (6),\n"
  "#     unsecuredAccident                   (7),\n"
  "#     assistanceRequested                 (8)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the value of the sub cause code of the @ref CauseCode `accident`.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - 0 - `unavailable`                        - in case the information on the sub cause of the accident is unavailable,\n"
  "# * - 1 - `multiVehicleAccident`               - in case more than two vehicles are involved in accident,\n"
  "# * - 2 - `heavyAccident`                      - in case the airbag of the vehicle involved in the accident is triggered, \n"
  "# *                                              the accident requires important rescue and/or recovery work,\n"
  "# * - 3 - `accidentInvolvingLorry`             - in case the accident involves a lorry,\n"
  "# * - 4 - `accidentInvolvingBus`               - in case the accident involves a bus,\n"
  "# * - 5 - `accidentInvolvingHazardousMaterials`- in case the accident involves hazardous material,\n"
  "# * - 6 - `accidentOnOppositeLane`             - in case the accident happens on opposite lanes,\n"
  "# * - 7 - `unsecuredAccident`                  - in case the accident is not secured,\n"
  "# * - 8 - `assistanceRequested`                - in case rescue and assistance are requested,\n"
  "# * - 9-255                                    - reserved for future usage. \n"
  "# *\n"
  "# * @category: Traffic information\n"
  "# * @revision: V1.3.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 MULTI_VEHICLE_ACCIDENT = 1\n"
  "uint8 HEAVY_ACCIDENT = 2\n"
  "uint8 ACCIDENT_INVOLVING_LORRY = 3\n"
  "uint8 ACCIDENT_INVOLVING_BUS = 4\n"
  "uint8 ACCIDENT_INVOLVING_HAZARDOUS_MATERIALS = 5\n"
  "uint8 ACCIDENT_ON_OPPOSITE_LANE = 6\n"
  "uint8 UNSECURED_ACCIDENT = 7\n"
  "uint8 ASSISTANCE_REQUESTED = 8";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__TYPE_NAME, 45, 45},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3736, 3736},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__AccidentSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
