// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/AngularSpeedConfidence.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/angular_speed_confidence__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xd7, 0x7f, 0x51, 0x7c, 0x3e, 0xbb, 0x2a, 0x90,
      0x5e, 0x0a, 0x44, 0x87, 0xfd, 0xad, 0xd2, 0x88,
      0x93, 0xf1, 0x73, 0xf4, 0x37, 0x07, 0x2f, 0x83,
      0x78, 0x99, 0x46, 0xdc, 0xf1, 0x7c, 0x22, 0xe2,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/AngularSpeedConfidence";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__TYPE_NAME, 47, 47},
      {etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# AngularSpeedConfidence ::= ENUMERATED {\n"
  "#     degSec-01   (0), \n"
  "#     degSec-02   (1),  \n"
  "#     degSec-05   (2), \n"
  "#     degSec-10   (3), \n"
  "#     degSec-20   (4),  \n"
  "#     degSec-50   (5), \n"
  "#     outOfRange  (6),   \n"
  "#     unavailable (7)   \n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# * \n"
  "# * This DE indicates the angular speed confidence value which represents the estimated absolute accuracy of an angular speed value with a default confidence level of 95 %.\n"
  "# * If required, the confidence level can be defined by the corresponding standards applying this DE.\n"
  "# * For correlation computation, maximum interval levels can be assumed.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - 0 - `degSec-01`   - if the accuracy is equal to or less than 1 degree/second,\n"
  "# * - 1 - `degSec-02`   - if the accuracy is equal to or less than 2 degrees/second and greater than 1 degree/second,\n"
  "# * - 2 - `degSec-05`   - if the accuracy is equal to or less than 5 degrees/second and greater than 2 degrees/second,\n"
  "# * - 3 - `degSec-10`   - if the accuracy is equal to or less than 10 degrees/second and greater than 5 degrees/second,\n"
  "# * - 4 - `degSec-20`   - if the accuracy is equal to or less than 20 degrees/second and greater than 10 degrees/second,\n"
  "# * - 5 - `degSec-50`   - if the accuracy is equal to or less than 50 degrees/second and greater than 20 degrees/second,\n"
  "# * - 6 - `outOfRange`  - if the accuracy is out of range, i.e. greater than 50 degrees/second,\n"
  "# * - 7 - `unavailable` - if the accuracy information is unavailable.\n"
  "# * \n"
  "# * @category: Kinematic information\n"
  "# * @revision: Created in V2.1.1\n"
  "#\n"
  "\n"
  "uint8 value\n"
  "uint8 DEG_SEC_01 = 0\n"
  "uint8 DEG_SEC_02 = 1\n"
  "uint8 DEG_SEC_05 = 2\n"
  "uint8 DEG_SEC_10 = 3\n"
  "uint8 DEG_SEC_20 = 4\n"
  "uint8 DEG_SEC_50 = 5\n"
  "uint8 OUT_OF_RANGE = 6\n"
  "uint8 UNAVAILABLE = 7\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__TYPE_NAME, 47, 47},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3390, 3390},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__AngularSpeedConfidence__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
