﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/BarometricPressure.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/barometric_pressure.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__BAROMETRIC_PRESSURE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__BAROMETRIC_PRESSURE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__BarometricPressure__MIN = 2999
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__BarometricPressure__MAX = 12002
};

/// Constant 'OUT_OF_RANGELOWER'.
enum
{
  etsi_its_vam_ts_msgs__msg__BarometricPressure__OUT_OF_RANGELOWER = 2999
};

/// Constant 'OUT_OF_RANGE_UPPER'.
enum
{
  etsi_its_vam_ts_msgs__msg__BarometricPressure__OUT_OF_RANGE_UPPER = 12001
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__BarometricPressure__UNAVAILABLE = 12002
};

/// Struct defined in msg/BarometricPressure in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__BarometricPressure
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// BarometricPressure ::= INTEGER{
  ///  outOfRangelower        (2999),
  ///  outOfRangeUpper        (12001),
  ///  unavailable            (12002)
  /// } (2999..12002)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the measured uncompensated atmospheric pressure.
  /// *
  /// * The value shall be set to:
  /// * - `2999` indicates that the applicable value is less than 29990 Pa,
  /// * - `n` (`n > 2999` and `n <= 12000`) indicates that the applicable value is equal to or less than n x 10 Pa and greater than (n-1) x 10 Pa,
  /// * - `12001` indicates that the values is greater than 120000 Pa,
  /// * - `12002` indicates that the information is not available.
  /// *
  /// * @category: Basic information
  /// * @unit: 10 Pascal
  /// * @revision: Created in V2.1.1
  uint16_t value;
} etsi_its_vam_ts_msgs__msg__BarometricPressure;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__BarometricPressure.
typedef struct etsi_its_vam_ts_msgs__msg__BarometricPressure__Sequence
{
  etsi_its_vam_ts_msgs__msg__BarometricPressure * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__BarometricPressure__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__BAROMETRIC_PRESSURE__STRUCT_H_
