// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/CartesianCoordinateLarge.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/cartesian_coordinate_large__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x34, 0xe0, 0xe7, 0x91, 0x24, 0x7b, 0x36, 0x2d,
      0xb3, 0x3e, 0x15, 0x3f, 0xc4, 0x58, 0xde, 0xc2,
      0x2c, 0xdd, 0xe4, 0x2e, 0x19, 0x36, 0xbc, 0x89,
      0x74, 0x88, 0xf6, 0x94, 0x97, 0xf1, 0x7a, 0x18,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/CartesianCoordinateLarge";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT32,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__TYPE_NAME, 49, 49},
      {etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# CartesianCoordinateLarge::= INTEGER{ \n"
  "#     negativeOutOfRange (-131072),\n"
  "#     positiveOutOfRange (131071)\n"
  "# } (-131072..131071)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DF represents the value of a cartesian coordinate with a range of -1 310,72 metres to +1 310,70 metres.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - `-131072` if the longitudinal offset is out of range, i.e. less than or equal to -1 310,72 metres,\n"
  "# * - `n` (`n > 131 072` and `n < 131 071`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,\n"
  "# * - `131 071` if the longitudinal offset is out of range, i.e. greater than + 1 310,70 metres.\n"
  "# *  \n"
  "# * @unit 0,01 m\n"
  "# * @category: Basic information\n"
  "# * @revision: Created in V2.1.1\n"
  "#\n"
  "\n"
  "int32 value\n"
  "int32 MIN = -131072\n"
  "int32 MAX = 131071\n"
  "int32 NEGATIVE_OUT_OF_RANGE = -131072\n"
  "int32 POSITIVE_OUT_OF_RANGE = 131071";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__TYPE_NAME, 49, 49},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2509, 2509},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__CartesianCoordinateLarge__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
