// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/CauseCode.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/cause_code.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CAUSE_CODE__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CAUSE_CODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'cause_code'
#include "etsi_its_vam_ts_msgs/msg/detail/cause_code_type__struct.hpp"
// Member 'sub_cause_code'
#include "etsi_its_vam_ts_msgs/msg/detail/sub_cause_code_type__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__CauseCode __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__CauseCode __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CauseCode_
{
  using Type = CauseCode_<ContainerAllocator>;

  explicit CauseCode_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cause_code(_init),
    sub_cause_code(_init)
  {
    (void)_init;
  }

  explicit CauseCode_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cause_code(_alloc, _init),
    sub_cause_code(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _cause_code_type =
    etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator>;
  _cause_code_type cause_code;
  using _sub_cause_code_type =
    etsi_its_vam_ts_msgs::msg::SubCauseCodeType_<ContainerAllocator>;
  _sub_cause_code_type sub_cause_code;

  // setters for named parameter idiom
  Type & set__cause_code(
    const etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator> & _arg)
  {
    this->cause_code = _arg;
    return *this;
  }
  Type & set__sub_cause_code(
    const etsi_its_vam_ts_msgs::msg::SubCauseCodeType_<ContainerAllocator> & _arg)
  {
    this->sub_cause_code = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__CauseCode
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__CauseCode
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::CauseCode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CauseCode_ & other) const
  {
    if (this->cause_code != other.cause_code) {
      return false;
    }
    if (this->sub_cause_code != other.sub_cause_code) {
      return false;
    }
    return true;
  }
  bool operator!=(const CauseCode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CauseCode_

// alias to use template instance with default allocator
using CauseCode =
  etsi_its_vam_ts_msgs::msg::CauseCode_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CAUSE_CODE__STRUCT_HPP_
