// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/CauseCodeType.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/cause_code_type.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CAUSE_CODE_TYPE__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CAUSE_CODE_TYPE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__CauseCodeType __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__CauseCodeType __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CauseCodeType_
{
  using Type = CauseCodeType_<ContainerAllocator>;

  explicit CauseCodeType_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit CauseCodeType_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MIN =
    0u;
  static constexpr uint8_t MAX =
    255u;
  static constexpr uint8_t TRAFFIC_CONDITION =
    1u;
  static constexpr uint8_t ACCIDENT =
    2u;
  static constexpr uint8_t ROADWORKS =
    3u;
  static constexpr uint8_t IMPASSABILITY =
    5u;
  static constexpr uint8_t ADVERSE_WEATHER_CONDITION_ADHESION =
    6u;
  static constexpr uint8_t AQUAPLANING =
    7u;
  static constexpr uint8_t HAZARDOUS_LOCATION_SURFACE_CONDITION =
    9u;
  static constexpr uint8_t HAZARDOUS_LOCATION_OBSTACLE_ON_THE_ROAD =
    10u;
  static constexpr uint8_t HAZARDOUS_LOCATION_ANIMAL_ON_THE_ROAD =
    11u;
  static constexpr uint8_t HUMAN_PRESENCE_ON_THE_ROAD =
    12u;
  static constexpr uint8_t WRONG_WAY_DRIVING =
    14u;
  static constexpr uint8_t RESCUE_AND_RECOVERY_WORK_IN_PROGRESS =
    15u;
  static constexpr uint8_t ADVERSE_WEATHER_CONDITION_EXTREME_WEATHER_CONDITION =
    17u;
  static constexpr uint8_t ADVERSE_WEATHER_CONDITION_VISIBILITY =
    18u;
  static constexpr uint8_t ADVERSE_WEATHER_CONDITION_PRECIPITATION =
    19u;
  static constexpr uint8_t VIOLENCE =
    20u;
  static constexpr uint8_t SLOW_VEHICLE =
    26u;
  static constexpr uint8_t DANGEROUS_END_OF_QUEUE =
    27u;
  static constexpr uint8_t VEHICLE_BREAKDOWN =
    91u;
  static constexpr uint8_t POST_CRASH =
    92u;
  static constexpr uint8_t HUMAN_PROBLEM =
    93u;
  static constexpr uint8_t STATIONARY_VEHICLE =
    94u;
  static constexpr uint8_t EMERGENCY_VEHICLE_APPROACHING =
    95u;
  static constexpr uint8_t HAZARDOUS_LOCATION_DANGEROUS_CURVE =
    96u;
  static constexpr uint8_t COLLISION_RISK =
    97u;
  static constexpr uint8_t SIGNAL_VIOLATION =
    98u;
  static constexpr uint8_t DANGEROUS_SITUATION =
    99u;
  static constexpr uint8_t RAILWAY_LEVEL_CROSSING =
    100u;

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__CauseCodeType
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__CauseCodeType
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::CauseCodeType_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CauseCodeType_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const CauseCodeType_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CauseCodeType_

// alias to use template instance with default allocator
using CauseCodeType =
  etsi_its_vam_ts_msgs::msg::CauseCodeType_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::TRAFFIC_CONDITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::ACCIDENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::ROADWORKS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::IMPASSABILITY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::ADVERSE_WEATHER_CONDITION_ADHESION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::AQUAPLANING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::HAZARDOUS_LOCATION_SURFACE_CONDITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::HAZARDOUS_LOCATION_OBSTACLE_ON_THE_ROAD;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::HAZARDOUS_LOCATION_ANIMAL_ON_THE_ROAD;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::HUMAN_PRESENCE_ON_THE_ROAD;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::WRONG_WAY_DRIVING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::RESCUE_AND_RECOVERY_WORK_IN_PROGRESS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::ADVERSE_WEATHER_CONDITION_EXTREME_WEATHER_CONDITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::ADVERSE_WEATHER_CONDITION_VISIBILITY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::ADVERSE_WEATHER_CONDITION_PRECIPITATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::VIOLENCE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::SLOW_VEHICLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::DANGEROUS_END_OF_QUEUE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::VEHICLE_BREAKDOWN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::POST_CRASH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::HUMAN_PROBLEM;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::STATIONARY_VEHICLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::EMERGENCY_VEHICLE_APPROACHING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::HAZARDOUS_LOCATION_DANGEROUS_CURVE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::COLLISION_RISK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::SIGNAL_VIOLATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::DANGEROUS_SITUATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t CauseCodeType_<ContainerAllocator>::RAILWAY_LEVEL_CROSSING;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CAUSE_CODE_TYPE__STRUCT_HPP_
