// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/ClusterLeaveReason.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/cluster_leave_reason__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x0b, 0x6c, 0xaf, 0x3e, 0x8e, 0x5b, 0x0f, 0xa8,
      0x8c, 0xb7, 0x64, 0x82, 0xf0, 0xe9, 0x02, 0xb7,
      0xd1, 0xc8, 0x2d, 0xf7, 0x6f, 0x50, 0xe7, 0xc0,
      0x0e, 0x86, 0x1e, 0x70, 0x25, 0xfb, 0x90, 0xf5,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/ClusterLeaveReason";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__TYPE_NAME, 43, 43},
      {etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# ClusterLeaveReason ::= ENUMERATED {\n"
  "#     notProvided                   (0), \n"
  "#     clusterLeaderLost             (1),    \n"
  "#     clusterDisbandedByLeader      (2),    \n"
  "#     outOfClusterBoundingBox       (3),    \n"
  "#     outOfClusterSpeedRange        (4),\n"
  "#     joiningAnotherCluster         (5),\n"
  "#     cancelledJoin                 (6),\n"
  "#     failedJoin                    (7),\n"
  "#     safetyCondition               (8),\n"
  "#     max(15)            \n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates the reason why a cluster participant is leaving the cluster.\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0 - `notProvided `                 - if the information is not provided,\n"
  "# * - 1 - `clusterLeaderLost`            - if the cluster leader cannot be found anymore,   \n"
  "# * - 2 - `clusterDisbandedByLeader`     - if the cluster has been disbanded by the leader,\n"
  "# * - 3 - `outOfClusterBoundingBox`      - if the participants moved out of the cluster's bounding box,\n"
  "# * - 4 - `outOfClusterSpeedRange`       - if the cluster speed moved out of a defined range, \n"
  "# * - 5 - `joiningAnotherCluster`        - if the participant is joining another cluster,\n"
  "# * - 6 - `cancelledJoin`                - if the participant is cancelling a joining procedure,\n"
  "# * - 7 - `failedJoin`                   - if the participant failed to join the cluster,\n"
  "# * - 8 - `safetyCondition`              - if a safety condition applies.\n"
  "# * - 9 to 15                            - are reserved for future use                             \n"
  "# *\n"
  "# * @category: Cluster information\n"
  "# * @revision: Created in V2.1.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 NOT_PROVIDED = 0\n"
  "uint8 CLUSTER_LEADER_LOST = 1\n"
  "uint8 CLUSTER_DISBANDED_BY_LEADER = 2\n"
  "uint8 OUT_OF_CLUSTER_BOUNDING_BOX = 3\n"
  "uint8 OUT_OF_CLUSTER_SPEED_RANGE = 4\n"
  "uint8 JOINING_ANOTHER_CLUSTER = 5\n"
  "uint8 CANCELLED_JOIN = 6\n"
  "uint8 FAILED_JOIN = 7\n"
  "uint8 SAFETY_CONDITION = 8\n"
  "uint8 MAX = 15\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__TYPE_NAME, 43, 43},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3513, 3513},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__ClusterLeaveReason__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
