// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/DangerousSituationSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/dangerous_situation_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xaa, 0x0d, 0x97, 0xbb, 0xbd, 0xd9, 0x2f, 0x80,
      0x92, 0xda, 0xb3, 0x65, 0x0b, 0x7d, 0xf4, 0x99,
      0x0f, 0xe7, 0xa8, 0xa6, 0xbd, 0x48, 0x4f, 0x2d,
      0x2b, 0x62, 0xcd, 0x2d, 0xa7, 0xa5, 0x31, 0x3e,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/DangerousSituationSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__TYPE_NAME, 55, 55},
      {etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# DangerousSituationSubCauseCode ::= INTEGER {\n"
  "#     unavailable                     (0), \n"
  "#     emergencyElectronicBrakeEngaged (1), \n"
  "#     preCrashSystemEngaged           (2), \n"
  "#     espEngaged                      (3), \n"
  "#     absEngaged                      (4), \n"
  "#     ebEngaged                       (5), \n"
  "#     brakeWarningEngaged             (6), \n"
  "#     collisionRiskWarningEngaged     (7)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the value of the sub cause codes of the @ref CauseCode `dangerousSituation` \n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0 - `unavailable`                      - in case information on the type of dangerous situation is unavailable,\n"
  "# * - 1 - `emergencyElectronicBrakeEngaged`  - in case emergency electronic brake is engaged,\n"
  "# * - 2 - `preCrashSystemEngaged`            - in case pre-crash system is engaged,\n"
  "# * - 3 - `espEngaged`                       - in case Electronic Stability Program (ESP) system is engaged,\n"
  "# * - 4 - `absEngaged`                       - in case Anti-lock Braking System (ABS) is engaged,\n"
  "# * - 5 - `aebEngaged`                       - in case Autonomous Emergency Braking (AEB) system is engaged,\n"
  "# * - 6 - `brakeWarningEngaged`              - in case brake warning is engaged,\n"
  "# * - 7 - `collisionRiskWarningEngaged`      - in case collision risk warning is engaged,\n"
  "# * - 8-255                                  - reserved for future usage.\n"
  "# *\n"
  "# * @category: Traffic information\n"
  "# * @revision: V1.3.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 EMERGENCY_ELECTRONIC_BRAKE_ENGAGED = 1\n"
  "uint8 PRE_CRASH_SYSTEM_ENGAGED = 2\n"
  "uint8 ESP_ENGAGED = 3\n"
  "uint8 ABS_ENGAGED = 4\n"
  "uint8 EB_ENGAGED = 5\n"
  "uint8 BRAKE_WARNING_ENGAGED = 6\n"
  "uint8 COLLISION_RISK_WARNING_ENGAGED = 7";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__TYPE_NAME, 55, 55},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3402, 3402},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__DangerousSituationSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
