// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/Direction.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/direction__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__Direction__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x54, 0x15, 0xd6, 0xc9, 0x6d, 0xae, 0x9b, 0x43,
      0x5d, 0x23, 0x77, 0x24, 0x29, 0x80, 0x7c, 0xc0,
      0x02, 0xee, 0xb8, 0x20, 0xe1, 0x8c, 0x12, 0x24,
      0xed, 0x4a, 0xc0, 0x7f, 0xd8, 0x3d, 0xe0, 0x61,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__Direction__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/Direction";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__Direction__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__Direction__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__Direction__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__Direction__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__Direction__TYPE_NAME, 34, 34},
      {etsi_its_vam_ts_msgs__msg__Direction__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# Direction::= INTEGER{\n"
  "#     sameDirection     (0),\n"
  "#     oppositeDirection (1),\n"
  "#     bothDirections    (2),\n"
  "#     unavailable       (3)\n"
  "#  } (0..3)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates a direction with respect to a defined reference direction.\n"
  "# * Example: a reference direction may be implicitly defined by the definition of a geographical zone.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - 0 - `sameDirection`     - to indicate the same direction as the reference direction,\n"
  "# * - 1 - `oppositeDirection` - to indicate opposite direction as the reference direction,\n"
  "# * - 2 - `bothDirections`    - to indicate both directions, i.e. the same and the opposite direction,\n"
  "# * - 3 - `unavailable`       - to indicate that the information is unavailable.\n"
  "# *\n"
  "# * @category: GeoReference information\n"
  "# * @revision: Created in V2.1.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 3\n"
  "uint8 SAME_DIRECTION = 0\n"
  "uint8 OPPOSITE_DIRECTION = 1\n"
  "uint8 BOTH_DIRECTIONS = 2\n"
  "uint8 UNAVAILABLE = 3";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__Direction__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__Direction__TYPE_NAME, 34, 34},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2611, 2611},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__Direction__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__Direction__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
