// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/EuVehicleCategoryL.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/eu_vehicle_category_l__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x99, 0x45, 0x92, 0xfa, 0x8b, 0xff, 0x41, 0x0d,
      0x87, 0x01, 0xa6, 0xb6, 0x86, 0x0a, 0xd4, 0x64,
      0xf4, 0x5d, 0xd2, 0x87, 0xfa, 0xea, 0x96, 0x33,
      0xad, 0xc8, 0x77, 0xad, 0x22, 0xcf, 0x5c, 0xda,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/EuVehicleCategoryL";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__TYPE_NAME, 43, 43},
      {etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# EuVehicleCategoryL ::= ENUMERATED { l1, l2, l3, l4, l5, l6, l7 }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents one of the specific categories in the L category: L1, L2, L3, L4, L5, L6, or L7 according to UNECE/TRANS/WP.29/78/Rev.4 [16].\n"
  "# *\n"
  "# *\n"
  "# * @category: Vehicle information\n"
  "# * @revision: V2.1.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 L1 = 0\n"
  "uint8 L2 = 1\n"
  "uint8 L3 = 2\n"
  "uint8 L4 = 3\n"
  "uint8 L5 = 4\n"
  "uint8 L6 = 5\n"
  "uint8 L7 = 6\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__TYPE_NAME, 43, 43},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2041, 2041},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
