﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/EuVehicleCategoryL.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/eu_vehicle_category_l.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__EU_VEHICLE_CATEGORY_L__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__EU_VEHICLE_CATEGORY_L__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'L1'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__L1 = 0
};

/// Constant 'L2'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__L2 = 1
};

/// Constant 'L3'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__L3 = 2
};

/// Constant 'L4'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__L4 = 3
};

/// Constant 'L5'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__L5 = 4
};

/// Constant 'L6'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__L6 = 5
};

/// Constant 'L7'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__L7 = 6
};

/// Struct defined in msg/EuVehicleCategoryL in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// EuVehicleCategoryL ::= ENUMERATED { l1, l2, l3, l4, l5, l6, l7 }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents one of the specific categories in the L category: L1, L2, L3, L4, L5, L6, or L7 according to UNECE/TRANS/WP.29/78/Rev.4.
  /// *
  /// *
  /// * @category: Vehicle information
  /// * @revision: V2.1.1
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL.
typedef struct etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__Sequence
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__EU_VEHICLE_CATEGORY_L__STRUCT_H_
