// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/ExteriorLights.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/exterior_lights__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__ExteriorLights__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x4a, 0x07, 0x6c, 0xd2, 0xb1, 0x5a, 0x54, 0x98,
      0xe9, 0x6d, 0xb0, 0x6b, 0x69, 0xa3, 0xde, 0x9d,
      0x8d, 0x40, 0x61, 0x2d, 0x4e, 0xf2, 0xfd, 0x5f,
      0x77, 0xc6, 0x7e, 0xa1, 0x83, 0x55, 0x47, 0xe3,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__ExteriorLights__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/ExteriorLights";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__ExteriorLights__FIELD_NAME__value[] = "value";
static char etsi_its_vam_ts_msgs__msg__ExteriorLights__FIELD_NAME__bits_unused[] = "bits_unused";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__ExteriorLights__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__ExteriorLights__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {etsi_its_vam_ts_msgs__msg__ExteriorLights__FIELD_NAME__bits_unused, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__ExteriorLights__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__ExteriorLights__TYPE_NAME, 39, 39},
      {etsi_its_vam_ts_msgs__msg__ExteriorLights__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# ExteriorLights ::= BIT STRING {\n"
  "#     lowBeamHeadlightsOn      (0),\n"
  "#     highBeamHeadlightsOn     (1),\n"
  "#     leftTurnSignalOn         (2),\n"
  "#     rightTurnSignalOn        (3),\n"
  "#     daytimeRunningLightsOn   (4),\n"
  "#     reverseLightOn           (5),\n"
  "#     fogLightOn               (6),\n"
  "#     parkingLightsOn          (7)\n"
  "# } (SIZE(8))\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE describes the status of the exterior light switches of a vehicle incl. VRU vehicles.\n"
  "# *\n"
  "# * The corresponding bit shall be set to 1 under the following conditions:\n"
  "# * - 0 - `lowBeamHeadlightsOn`    - when the low beam head light switch is on,\n"
  "# * - 1 - `highBeamHeadlightsOn`   - when the high beam head light switch is on,\n"
  "# * - 2 - `leftTurnSignalOn`       - when the left turnSignal switch is on,\n"
  "# * - 3 - `rightTurnSignalOn`      - when the right turn signal switch is on,\n"
  "# * - 4 - `daytimeRunningLightsOn` - when the daytime running light switch is on,\n"
  "# * - 5 - `reverseLightOn`         - when the reverse light switch is on,\n"
  "# * - 6 - `fogLightOn`             - when the tail fog light switch is on,\n"
  "# * - 7 - `parkingLightsOn`        - when the parking light switch is on.\n"
  "# * \n"
  "# * @note: The value of each bit indicates the state of the switch, which commands the corresponding light.\n"
  "# * The bit corresponding to a specific light is set to `1`, when the corresponding switch is turned on,\n"
  "# * either manually by the driver or automatically by a vehicle system. The bit value does not indicate\n"
  "# * if the corresponding lamps are alight or not.\n"
  "# * \n"
  "# * If a vehicle is not equipped with a certain light or if the light switch status information is not available,\n"
  "# * the corresponding bit shall be set to `0`.\n"
  "# * \n"
  "# * As the bit value indicates only the state of the switch, the turn signal and hazard signal bit values shall not\n"
  "# * alternate with the blinking interval.\n"
  "# * \n"
  "# * For hazard indicator, the `leftTurnSignalOn (2)` and `rightTurnSignalOn (3)` shall be both set to `1`.\n"
  "# * \n"
  "# * @category Vehicle information\n"
  "# * @revision: Description revised in V2.1.1\n"
  "# \n"
  "\n"
  "uint8[] value\n"
  "uint8 bits_unused\n"
  "uint8 SIZE_BITS = 8\n"
  "uint8 BIT_INDEX_LOW_BEAM_HEADLIGHTS_ON = 0\n"
  "uint8 BIT_INDEX_HIGH_BEAM_HEADLIGHTS_ON = 1\n"
  "uint8 BIT_INDEX_LEFT_TURN_SIGNAL_ON = 2\n"
  "uint8 BIT_INDEX_RIGHT_TURN_SIGNAL_ON = 3\n"
  "uint8 BIT_INDEX_DAYTIME_RUNNING_LIGHTS_ON = 4\n"
  "uint8 BIT_INDEX_REVERSE_LIGHT_ON = 5\n"
  "uint8 BIT_INDEX_FOG_LIGHT_ON = 6\n"
  "uint8 BIT_INDEX_PARKING_LIGHTS_ON = 7";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__ExteriorLights__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__ExteriorLights__TYPE_NAME, 39, 39},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 4059, 4059},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__ExteriorLights__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__ExteriorLights__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
