// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_vam_ts_msgs:msg/GeneralizedLanePosition.idl
// generated code does not contain a copyright notice
#include "etsi_its_vam_ts_msgs/msg/detail/generalized_lane_position__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `traffic_lane_position`
#include "etsi_its_vam_ts_msgs/msg/detail/lane_position__functions.h"
// Member `non_traffic_lane_position`
#include "etsi_its_vam_ts_msgs/msg/detail/lane_position_and_type__functions.h"
// Member `traffic_island_position`
#include "etsi_its_vam_ts_msgs/msg/detail/traffic_island_position__functions.h"
// Member `map_position`
#include "etsi_its_vam_ts_msgs/msg/detail/map_position__functions.h"

bool
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__init(etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition * msg)
{
  if (!msg) {
    return false;
  }
  // choice
  // traffic_lane_position
  if (!etsi_its_vam_ts_msgs__msg__LanePosition__init(&msg->traffic_lane_position)) {
    etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__fini(msg);
    return false;
  }
  // non_traffic_lane_position
  if (!etsi_its_vam_ts_msgs__msg__LanePositionAndType__init(&msg->non_traffic_lane_position)) {
    etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__fini(msg);
    return false;
  }
  // traffic_island_position
  if (!etsi_its_vam_ts_msgs__msg__TrafficIslandPosition__init(&msg->traffic_island_position)) {
    etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__fini(msg);
    return false;
  }
  // map_position
  if (!etsi_its_vam_ts_msgs__msg__MapPosition__init(&msg->map_position)) {
    etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__fini(etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition * msg)
{
  if (!msg) {
    return;
  }
  // choice
  // traffic_lane_position
  etsi_its_vam_ts_msgs__msg__LanePosition__fini(&msg->traffic_lane_position);
  // non_traffic_lane_position
  etsi_its_vam_ts_msgs__msg__LanePositionAndType__fini(&msg->non_traffic_lane_position);
  // traffic_island_position
  etsi_its_vam_ts_msgs__msg__TrafficIslandPosition__fini(&msg->traffic_island_position);
  // map_position
  etsi_its_vam_ts_msgs__msg__MapPosition__fini(&msg->map_position);
}

bool
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__are_equal(const etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition * lhs, const etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // choice
  if (lhs->choice != rhs->choice) {
    return false;
  }
  // traffic_lane_position
  if (!etsi_its_vam_ts_msgs__msg__LanePosition__are_equal(
      &(lhs->traffic_lane_position), &(rhs->traffic_lane_position)))
  {
    return false;
  }
  // non_traffic_lane_position
  if (!etsi_its_vam_ts_msgs__msg__LanePositionAndType__are_equal(
      &(lhs->non_traffic_lane_position), &(rhs->non_traffic_lane_position)))
  {
    return false;
  }
  // traffic_island_position
  if (!etsi_its_vam_ts_msgs__msg__TrafficIslandPosition__are_equal(
      &(lhs->traffic_island_position), &(rhs->traffic_island_position)))
  {
    return false;
  }
  // map_position
  if (!etsi_its_vam_ts_msgs__msg__MapPosition__are_equal(
      &(lhs->map_position), &(rhs->map_position)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__copy(
  const etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition * input,
  etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition * output)
{
  if (!input || !output) {
    return false;
  }
  // choice
  output->choice = input->choice;
  // traffic_lane_position
  if (!etsi_its_vam_ts_msgs__msg__LanePosition__copy(
      &(input->traffic_lane_position), &(output->traffic_lane_position)))
  {
    return false;
  }
  // non_traffic_lane_position
  if (!etsi_its_vam_ts_msgs__msg__LanePositionAndType__copy(
      &(input->non_traffic_lane_position), &(output->non_traffic_lane_position)))
  {
    return false;
  }
  // traffic_island_position
  if (!etsi_its_vam_ts_msgs__msg__TrafficIslandPosition__copy(
      &(input->traffic_island_position), &(output->traffic_island_position)))
  {
    return false;
  }
  // map_position
  if (!etsi_its_vam_ts_msgs__msg__MapPosition__copy(
      &(input->map_position), &(output->map_position)))
  {
    return false;
  }
  return true;
}

etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition *
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition * msg = (etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition));
  bool success = etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__destroy(etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence__init(etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition * data = NULL;

  if (size) {
    data = (etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition *)allocator.zero_allocate(size, sizeof(etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence__fini(etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence *
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence * array = (etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence__destroy(etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence__are_equal(const etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence * lhs, const etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence__copy(
  const etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence * input,
  etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition * data =
      (etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
