// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/GeneralizedLanePosition.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/generalized_lane_position.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__TRAITS_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_vam_ts_msgs/msg/detail/generalized_lane_position__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'traffic_lane_position'
#include "etsi_its_vam_ts_msgs/msg/detail/lane_position__traits.hpp"
// Member 'non_traffic_lane_position'
#include "etsi_its_vam_ts_msgs/msg/detail/lane_position_and_type__traits.hpp"
// Member 'traffic_island_position'
#include "etsi_its_vam_ts_msgs/msg/detail/traffic_island_position__traits.hpp"
// Member 'map_position'
#include "etsi_its_vam_ts_msgs/msg/detail/map_position__traits.hpp"

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const GeneralizedLanePosition & msg,
  std::ostream & out)
{
  out << "{";
  // member: choice
  {
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << ", ";
  }

  // member: traffic_lane_position
  {
    out << "traffic_lane_position: ";
    to_flow_style_yaml(msg.traffic_lane_position, out);
    out << ", ";
  }

  // member: non_traffic_lane_position
  {
    out << "non_traffic_lane_position: ";
    to_flow_style_yaml(msg.non_traffic_lane_position, out);
    out << ", ";
  }

  // member: traffic_island_position
  {
    out << "traffic_island_position: ";
    to_flow_style_yaml(msg.traffic_island_position, out);
    out << ", ";
  }

  // member: map_position
  {
    out << "map_position: ";
    to_flow_style_yaml(msg.map_position, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GeneralizedLanePosition & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << "\n";
  }

  // member: traffic_lane_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "traffic_lane_position:\n";
    to_block_style_yaml(msg.traffic_lane_position, out, indentation + 2);
  }

  // member: non_traffic_lane_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "non_traffic_lane_position:\n";
    to_block_style_yaml(msg.non_traffic_lane_position, out, indentation + 2);
  }

  // member: traffic_island_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "traffic_island_position:\n";
    to_block_style_yaml(msg.traffic_island_position, out, indentation + 2);
  }

  // member: map_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "map_position:\n";
    to_block_style_yaml(msg.map_position, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GeneralizedLanePosition & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_vam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition & msg)
{
  return etsi_its_vam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition>()
{
  return "etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition";
}

template<>
inline const char * name<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition>()
{
  return "etsi_its_vam_ts_msgs/msg/GeneralizedLanePosition";
}

template<>
struct has_fixed_size<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition>
  : std::integral_constant<bool, has_fixed_size<etsi_its_vam_ts_msgs::msg::LanePosition>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::LanePositionAndType>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::MapPosition>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::TrafficIslandPosition>::value> {};

template<>
struct has_bounded_size<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition>
  : std::integral_constant<bool, has_bounded_size<etsi_its_vam_ts_msgs::msg::LanePosition>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::LanePositionAndType>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::MapPosition>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::TrafficIslandPosition>::value> {};

template<>
struct is_message<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__TRAITS_HPP_
