﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/InterferenceManagementChannel.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/interference_management_channel.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_CHANNEL__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_CHANNEL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'CENTRE_FREQUENCY_MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__CENTRE_FREQUENCY_MIN = 1ul
};

/// Constant 'CENTRE_FREQUENCY_MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__CENTRE_FREQUENCY_MAX = 99999ul
};

/// Constant 'CHANNEL_WIDTH_MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__CHANNEL_WIDTH_MIN = 0
};

/// Constant 'CHANNEL_WIDTH_MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__CHANNEL_WIDTH_MAX = 9999
};

/// Constant 'EXPONENT_MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__EXPONENT_MIN = 0
};

/// Constant 'EXPONENT_MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__EXPONENT_MAX = 15
};

/// Struct defined in msg/InterferenceManagementChannel in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// InterferenceManagementChannel ::= SEQUENCE {
  ///     centreFrequency    INTEGER (1 .. 99999),
  ///     channelWidth       INTEGER (0 .. 9999),
  ///     exponent           INTEGER (0 .. 15)
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF represents a frequency channel
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field centreFrequency: the centre frequency of the channel in 10^(exp+2) Hz (where exp is exponent)
  /// *
  /// * @field channelWidth: width of the channel in 10^exp Hz (where exp is exponent)
  /// *
  /// * @field exponent: exponent of the power of 10 used in the calculation of the components above.
  /// *
  /// * @category: Communication information
  /// * @revision: created in V2.1.1
  uint32_t centre_frequency;
  uint16_t channel_width;
  uint8_t exponent;
} etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel.
typedef struct etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__Sequence
{
  etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_CHANNEL__STRUCT_H_
