// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/LanePosition.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/lane_position__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__LanePosition__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x9e, 0x8e, 0xbb, 0x6b, 0xa3, 0xc2, 0xeb, 0xc4,
      0xb0, 0x86, 0x39, 0xeb, 0x05, 0x34, 0x6b, 0x3e,
      0xaa, 0xde, 0x21, 0x7b, 0x66, 0x84, 0x1f, 0xf5,
      0x28, 0x0f, 0x26, 0x0c, 0xea, 0x30, 0xd7, 0x3c,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__LanePosition__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/LanePosition";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__LanePosition__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__LanePosition__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__LanePosition__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__LanePosition__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__LanePosition__TYPE_NAME, 37, 37},
      {etsi_its_vam_ts_msgs__msg__LanePosition__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# LanePosition ::= INTEGER {\n"
  "#     offTheRoad           (-1), \n"
  "#     innerHardShoulder    (0), \n"
  "#     outerHardShoulder    (14) \n"
  "# } (-1..14)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. \n"
  "# *\n"
  "# * For right-hand traffic roads, the value shall be set to:\n"
  "# * - `-1` if the position is off, i.e. besides the road,\n"
  "# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,\n"
  "# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,\n"
  "# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).\n"
  "# *\n"
  "# * For left-hand traffic roads, the value shall be set to:\n"
  "# * - `-1` if the position is off, i.e. besides the road,\n"
  "# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,\n"
  "# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,\n"
  "# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).\n"
  "#\n"
  "# *  @note: in practice this means that the position is counted from \"inside\" to \"outside\" no matter which traffic practice is used.\n"
  "# *\n"
  "# * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. \n"
  "# * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), \n"
  "# * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). \n"
  "#\n"
  "# * @category: Road topology information\n"
  "# * @revision: Description revised in V2.1.1\n"
  "#\n"
  "\n"
  "int8 value\n"
  "int8 MIN = -1\n"
  "int8 MAX = 14\n"
  "int8 OFF_THE_ROAD = -1\n"
  "int8 INNER_HARD_SHOULDER = 0\n"
  "int8 OUTER_HARD_SHOULDER = 14";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__LanePosition__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__LanePosition__TYPE_NAME, 37, 37},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3785, 3785},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__LanePosition__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__LanePosition__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
