// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_vam_ts_msgs:msg/LanePositionAndType.idl
// generated code does not contain a copyright notice
#include "etsi_its_vam_ts_msgs/msg/detail/lane_position_and_type__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `transversal_position`
#include "etsi_its_vam_ts_msgs/msg/detail/lane_position__functions.h"
// Member `lane_type`
#include "etsi_its_vam_ts_msgs/msg/detail/lane_type__functions.h"

bool
etsi_its_vam_ts_msgs__msg__LanePositionAndType__init(etsi_its_vam_ts_msgs__msg__LanePositionAndType * msg)
{
  if (!msg) {
    return false;
  }
  // transversal_position
  if (!etsi_its_vam_ts_msgs__msg__LanePosition__init(&msg->transversal_position)) {
    etsi_its_vam_ts_msgs__msg__LanePositionAndType__fini(msg);
    return false;
  }
  // lane_type
  if (!etsi_its_vam_ts_msgs__msg__LaneType__init(&msg->lane_type)) {
    etsi_its_vam_ts_msgs__msg__LanePositionAndType__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_vam_ts_msgs__msg__LanePositionAndType__fini(etsi_its_vam_ts_msgs__msg__LanePositionAndType * msg)
{
  if (!msg) {
    return;
  }
  // transversal_position
  etsi_its_vam_ts_msgs__msg__LanePosition__fini(&msg->transversal_position);
  // lane_type
  etsi_its_vam_ts_msgs__msg__LaneType__fini(&msg->lane_type);
}

bool
etsi_its_vam_ts_msgs__msg__LanePositionAndType__are_equal(const etsi_its_vam_ts_msgs__msg__LanePositionAndType * lhs, const etsi_its_vam_ts_msgs__msg__LanePositionAndType * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // transversal_position
  if (!etsi_its_vam_ts_msgs__msg__LanePosition__are_equal(
      &(lhs->transversal_position), &(rhs->transversal_position)))
  {
    return false;
  }
  // lane_type
  if (!etsi_its_vam_ts_msgs__msg__LaneType__are_equal(
      &(lhs->lane_type), &(rhs->lane_type)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__LanePositionAndType__copy(
  const etsi_its_vam_ts_msgs__msg__LanePositionAndType * input,
  etsi_its_vam_ts_msgs__msg__LanePositionAndType * output)
{
  if (!input || !output) {
    return false;
  }
  // transversal_position
  if (!etsi_its_vam_ts_msgs__msg__LanePosition__copy(
      &(input->transversal_position), &(output->transversal_position)))
  {
    return false;
  }
  // lane_type
  if (!etsi_its_vam_ts_msgs__msg__LaneType__copy(
      &(input->lane_type), &(output->lane_type)))
  {
    return false;
  }
  return true;
}

etsi_its_vam_ts_msgs__msg__LanePositionAndType *
etsi_its_vam_ts_msgs__msg__LanePositionAndType__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__LanePositionAndType * msg = (etsi_its_vam_ts_msgs__msg__LanePositionAndType *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__LanePositionAndType), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_vam_ts_msgs__msg__LanePositionAndType));
  bool success = etsi_its_vam_ts_msgs__msg__LanePositionAndType__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_vam_ts_msgs__msg__LanePositionAndType__destroy(etsi_its_vam_ts_msgs__msg__LanePositionAndType * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_vam_ts_msgs__msg__LanePositionAndType__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence__init(etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__LanePositionAndType * data = NULL;

  if (size) {
    data = (etsi_its_vam_ts_msgs__msg__LanePositionAndType *)allocator.zero_allocate(size, sizeof(etsi_its_vam_ts_msgs__msg__LanePositionAndType), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_vam_ts_msgs__msg__LanePositionAndType__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_vam_ts_msgs__msg__LanePositionAndType__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence__fini(etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_vam_ts_msgs__msg__LanePositionAndType__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence *
etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence * array = (etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence__destroy(etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence__are_equal(const etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence * lhs, const etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__LanePositionAndType__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence__copy(
  const etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence * input,
  etsi_its_vam_ts_msgs__msg__LanePositionAndType__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_vam_ts_msgs__msg__LanePositionAndType);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_vam_ts_msgs__msg__LanePositionAndType * data =
      (etsi_its_vam_ts_msgs__msg__LanePositionAndType *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_vam_ts_msgs__msg__LanePositionAndType__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_vam_ts_msgs__msg__LanePositionAndType__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__LanePositionAndType__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
