// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/LaneType.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/lane_type__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__LaneType__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xa0, 0x26, 0xc4, 0x13, 0x59, 0x1e, 0xdf, 0x08,
      0x3d, 0x26, 0xe2, 0x0e, 0x93, 0x96, 0x72, 0x19,
      0xf1, 0x08, 0xfb, 0x86, 0xc9, 0x6d, 0xa6, 0xfe,
      0x55, 0x67, 0x00, 0x18, 0x0f, 0x32, 0x8e, 0xd4,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__LaneType__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/LaneType";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__LaneType__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__LaneType__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__LaneType__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__LaneType__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__LaneType__TYPE_NAME, 33, 33},
      {etsi_its_vam_ts_msgs__msg__LaneType__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# LaneType::= INTEGER{\n"
  "# \\ttraffic              (0),\n"
  "# \\tthrough\\t             (1),\n"
  "# \\treversible           (2),\n"
  "# \\tacceleration         (3),\n"
  "# \\tdeceleration         (4),\n"
  "# \\tleftHandTurning      (5),\n"
  "# \\trightHandTurning     (6),\n"
  "# \\tdedicatedVehicle     (7),\n"
  "# \\tbus                  (8),\n"
  "# \\ttaxi                 (9),\n"
  "# \\thov                  (10),\n"
  "# \\thot                  (11),\n"
  "# \\tpedestrian           (12),\n"
  "# \\tcycleLane            (13),\n"
  "# \\tmedian               (14),   \n"
  "# \\tstriping             (15),\n"
  "# \\ttrackedVehicle       (16),\n"
  "# \\tparking\\t             (17),\n"
  "# \\temergency            (18),\n"
  "# \\tverge                (19),\n"
  "# \\tminimumRiskManoeuvre (20),\n"
  "# \\tunknown              (31)\n"
  "# }(0..31)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the type of a lane. \n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0\\t- `traffic`            - Lane dedicated to the movement of vehicles,\n"
  "# * - 1\\t- `through`            - Lane dedicated to the movement of vehicles travelling ahead and not turning,\n"
  "# * - 2\\t- `reversible`         - Lane where the direction of traffic can be changed to match the peak flow,\n"
  "# * - 3\\t- `acceleration`\\t   - Lane that allows vehicles entering a road to accelerate to the speed of through traffic before merging with it,\n"
  "# * - 4\\t- `deceleration`       - Lane that allows vehicles exiting a road to decelerate before leaving it,\n"
  "# * - 5\\t- `leftHandTurning`    - Lane reserved for slowing down and making a left turn, so as not to disrupt traffic,\n"
  "# * - 6\\t- `rightHandTurning`   - Lane reserved for slowing down and making a right turn so as not to disrupt traffic,\n"
  "# * - 7\\t- `dedicatedVehicle`   - Lane dedicated to movement of motor vehicles with specific characteristics, such as heavy goods vehicles, etc., \n"
  "# * - 8\\t- `bus`                - Lane dedicated to movement of buses providing public transport,\n"
  "# * - 9\\t- `taxi`               - Lane dedicated to movement of taxis,\n"
  "# * - 10\\t- `hov`                - Carpooling lane or high occupancy vehicle lane,\n"
  "# * - 11\\t- `hot`                - High occupancy vehicle lanes that is allowed to be used without meeting the occupancy criteria by paying a toll,\n"
  "# * - 12\\t- `pedestrian`         - Lanes dedicated to pedestrians such as pedestrian sidewalk paths,\n"
  "# * - 13\\t- `cycleLane`\\t       - Lane dedicated to exclusive or preferred use by bicycles,\n"
  "# * - 14\\t- `median`             - Lane not dedicated to movement of vehicles but representing a median / central reservation  such as the central median, \n"
  "#                                 separating the two directional carriageways of the highway,\n"
  "# * - 15\\t- `striping`\\t       - Lane not dedicated to movement of vehicles but covered with roadway markings,\n"
  "# * - 16\\t- `trackedVehicle`     - Lane dedicated to movement of trains, trams and trolleys,\n"
  "# * - 17\\t- `parking`            - Lanes dedicated to vehicles parking, stopping and loading lanes,\n"
  "# * - 18\\t- `emergency`          - Lane dedicated to vehicles in breakdown or to emergency vehicles also called hard shoulder,\n"
  "# * - 19\\t- `verge`              - Lane representing the verge, i.e. a narrow strip of grass or plants and sometimes also trees located between \n"
  "#                                 the road surface edge and the boundary of a road,\n"
  "# * - 20\\t`minimumRiskManoeuvre` - Lane dedicated to automated vehicles making a minimum risk manoeuvre.\n"
  "# * - values 21 to 30             reserved for future use. \n"
  "# *\n"
  "# * @category: Road topology information\n"
  "# * @revision: Created in V2.1.1\n"
  "#\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 31\n"
  "uint8 TRAFFIC = 0\n"
  "uint8 THROUGH = 1\n"
  "uint8 REVERSIBLE = 2\n"
  "uint8 ACCELERATION = 3\n"
  "uint8 DECELERATION = 4\n"
  "uint8 LEFT_HAND_TURNING = 5\n"
  "uint8 RIGHT_HAND_TURNING = 6\n"
  "uint8 DEDICATED_VEHICLE = 7\n"
  "uint8 BUS = 8\n"
  "uint8 TAXI = 9\n"
  "uint8 HOV = 10\n"
  "uint8 HOT = 11\n"
  "uint8 PEDESTRIAN = 12\n"
  "uint8 CYCLE_LANE = 13\n"
  "uint8 MEDIAN = 14\n"
  "uint8 STRIPING = 15\n"
  "uint8 TRACKED_VEHICLE = 16\n"
  "uint8 PARKING = 17\n"
  "uint8 EMERGENCY = 18\n"
  "uint8 VERGE = 19\n"
  "uint8 MINIMUM_RISK_MANOEUVRE = 20\n"
  "uint8 UNKNOWN = 31";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__LaneType__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__LaneType__TYPE_NAME, 33, 33},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 5585, 5585},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__LaneType__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__LaneType__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
