// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/LongitudinalLanePositionValue.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/longitudinal_lane_position_value__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xb2, 0xba, 0x4a, 0x3a, 0xe7, 0x43, 0xd9, 0x72,
      0x46, 0x0b, 0xd1, 0x69, 0x83, 0x9c, 0x2b, 0x6a,
      0x40, 0x34, 0x70, 0xfa, 0xf9, 0x36, 0xf5, 0x92,
      0x39, 0xd7, 0x7f, 0xb8, 0x60, 0xfe, 0x61, 0xe0,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/LongitudinalLanePositionValue";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__TYPE_NAME, 54, 54},
      {etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# LongitudinalLanePositionValue ::= INTEGER {\n"
  "#     outOfRange(32766),\n"
  "#     unavailable(32767)\n"
  "# }(0..32767)\n"
  "# ------------------------------------------------------------------------------\n"
  "# * \n"
  "# * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,\n"
  "# * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,\n"
  "# * - `32 767` if the longitudinal offset information is not available. \n"
  "# *\n"
  "# * @unit 0,1 metre\n"
  "# * @category: GeoReference information\n"
  "# * @revision: Created in V2.1.1\n"
  "#\n"
  "\n"
  "uint16 value\n"
  "uint16 MIN = 0\n"
  "uint16 MAX = 32767\n"
  "uint16 OUT_OF_RANGE = 32766\n"
  "uint16 UNAVAILABLE = 32767";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__TYPE_NAME, 54, 54},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2446, 2446},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__LongitudinalLanePositionValue__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
