// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/ObjectDimensionConfidence.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/object_dimension_confidence__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x6c, 0xb4, 0x4e, 0x9d, 0xc0, 0x5b, 0x86, 0xa4,
      0x18, 0x28, 0xa3, 0x9a, 0x29, 0x7d, 0x77, 0xd5,
      0x4e, 0xe9, 0x3d, 0x75, 0xb0, 0xfa, 0x65, 0x24,
      0xdd, 0x4d, 0x8c, 0x5b, 0x2c, 0xe9, 0x98, 0x96,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/ObjectDimensionConfidence";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__TYPE_NAME, 50, 50},
      {etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# ObjectDimensionConfidence ::= INTEGER { \n"
  "#     outOfRange              (31),\n"
  "#     unavailable             (32)\n"
  "# } (1..32)\n"
  "# ------------------------------------------------------------------------------\n"
  "# * \n"
  "# * This DE indicates the object dimension confidence value which represents the estimated absolute accuracy of an object dimension value with a default confidence level of 95 %.\n"
  "# * If required, the confidence level can be defined by the corresponding standards applying this DE.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - `n` (`n > 0` and `n < 31`) if the confidence value is equal to or less than n x 0,1 metre, and more than (n-1) x 0,1 metre,\n"
  "# * - `31` if the confidence value is out of range i.e. greater than 3,0 m,\n"
  "# * - `32` if the confidence value is unavailable.\n"
  "# *\n"
  "# * @unit 0,1 m\n"
  "# * @category: Sensing information\n"
  "# * @revision: Created in V2.1.1 \n"
  "#\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 1\n"
  "uint8 MAX = 32\n"
  "uint8 OUT_OF_RANGE = 31\n"
  "uint8 UNAVAILABLE = 32";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__TYPE_NAME, 50, 50},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2532, 2532},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
