﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/ObjectDimensionConfidence.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/object_dimension_confidence.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__OBJECT_DIMENSION_CONFIDENCE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__OBJECT_DIMENSION_CONFIDENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__MIN = 1
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__MAX = 32
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__OUT_OF_RANGE = 31
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__UNAVAILABLE = 32
};

/// Struct defined in msg/ObjectDimensionConfidence in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// ObjectDimensionConfidence ::= INTEGER {
  ///     outOfRange              (31),
  ///     unavailable             (32)
  /// } (1..32)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE indicates the object dimension confidence value which represents the estimated absolute accuracy of an object dimension value with a default confidence level of 95 %.
  /// * If required, the confidence level can be defined by the corresponding standards applying this DE.
  /// *
  /// * The value shall be set to:
  /// * - `n` (`n > 0` and `n < 31`) if the confidence value is equal to or less than n x 0,1 metre, and more than (n-1) x 0,1 metre,
  /// * - `31` if the confidence value is out of range i.e. greater than 3,0 m,
  /// * - `32` if the confidence value is unavailable.
  /// *
  /// * @unit 0,1 m
  /// * @category: Sensing information
  /// * @revision: Created in V2.1.1
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence.
typedef struct etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__Sequence
{
  etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__ObjectDimensionConfidence__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__OBJECT_DIMENSION_CONFIDENCE__STRUCT_H_
