﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/ObjectDimensionValue.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/object_dimension_value.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__OBJECT_DIMENSION_VALUE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__OBJECT_DIMENSION_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__ObjectDimensionValue__MIN = 1
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__ObjectDimensionValue__MAX = 256
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_vam_ts_msgs__msg__ObjectDimensionValue__OUT_OF_RANGE = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__ObjectDimensionValue__UNAVAILABLE = 256
};

/// Struct defined in msg/ObjectDimensionValue in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__ObjectDimensionValue
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// ObjectDimensionValue ::= INTEGER {
  ///     outOfRange              (255),
  ///     unavailable             (256)
  /// }(1..256)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents a single dimension of an object.
  /// *
  /// * The value shall be set to:
  /// * - `n` (`n > 0` and `n < 255`) if the  accuracy is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
  /// * - `255` if the accuracy is out of range i.e. greater than 25,4 m,
  /// * - `256` if the data is unavailable.
  /// *
  /// * @unit 0,1 m
  /// * @category: Basic information
  /// * @revision: Created in V2.1.1
  uint16_t value;
} etsi_its_vam_ts_msgs__msg__ObjectDimensionValue;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__ObjectDimensionValue.
typedef struct etsi_its_vam_ts_msgs__msg__ObjectDimensionValue__Sequence
{
  etsi_its_vam_ts_msgs__msg__ObjectDimensionValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__ObjectDimensionValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__OBJECT_DIMENSION_VALUE__STRUCT_H_
