﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/PathPointPredicted.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/path_point_predicted.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__PATH_POINT_PREDICTED__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__PATH_POINT_PREDICTED__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'DELTA_ALTITUDE_DEFAULT'.
enum
{
  etsi_its_vam_ts_msgs__msg__PathPointPredicted__DELTA_ALTITUDE_DEFAULT = 12800
};

// Include directives for member types
// Member 'delta_latitude'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_latitude__struct.h"
// Member 'delta_longitude'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_longitude__struct.h"
// Member 'horizontal_position_confidence'
#include "etsi_its_vam_ts_msgs/msg/detail/pos_confidence_ellipse__struct.h"
// Member 'delta_altitude'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_altitude__struct.h"
// Member 'altitude_confidence'
#include "etsi_its_vam_ts_msgs/msg/detail/altitude_confidence__struct.h"
// Member 'path_delta_time'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_tenth_of_second__struct.h"

/// Struct defined in msg/PathPointPredicted in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__PathPointPredicted
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// PathPointPredicted::= SEQUENCE {
  ///   deltaLatitude                 DeltaLatitude,
  ///   deltaLongitude                DeltaLongitude,
  ///   horizontalPositionConfidence  PosConfidenceEllipse OPTIONAL,
  ///   deltaAltitude                 DeltaAltitude DEFAULT unavailable,
  ///   altitudeConfidence            AltitudeConfidence DEFAULT unavailable,
  ///   pathDeltaTime                 DeltaTimeTenthOfSecond,
  ///   ...
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF  defines a predicted offset waypoint position within a path.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field deltaLatitude: an offset latitude with regards to a pre-defined reference position.
  /// *
  /// * @field deltaLongitude: an offset longitude with regards to a pre-defined reference position.
  /// *
  /// * @field horizontalPositionConfidence: the confidence value associated to the horizontal geographical position.
  /// *
  /// * @field deltaAltitude: an offset altitude with regards to a pre-defined reference position.
  /// *
  /// * @field altitudeConfidence: the confidence value associated to the altitude value of the geographical position.
  /// *
  /// * @field pathDeltaTime: The  travel time separated from the waypoint to the predefined reference position.
  /// *
  /// * @category GeoReference information
  /// * @revision: semantics updated in V2.1.1
  etsi_its_vam_ts_msgs__msg__DeltaLatitude delta_latitude;
  etsi_its_vam_ts_msgs__msg__DeltaLongitude delta_longitude;
  etsi_its_vam_ts_msgs__msg__PosConfidenceEllipse horizontal_position_confidence;
  bool horizontal_position_confidence_is_present;
  etsi_its_vam_ts_msgs__msg__DeltaAltitude delta_altitude;
  etsi_its_vam_ts_msgs__msg__AltitudeConfidence altitude_confidence;
  etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond path_delta_time;
} etsi_its_vam_ts_msgs__msg__PathPointPredicted;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__PathPointPredicted.
typedef struct etsi_its_vam_ts_msgs__msg__PathPointPredicted__Sequence
{
  etsi_its_vam_ts_msgs__msg__PathPointPredicted * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__PathPointPredicted__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__PATH_POINT_PREDICTED__STRUCT_H_
