// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/PosCentMass.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/pos_cent_mass.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__POS_CENT_MASS__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__POS_CENT_MASS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__PosCentMass __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__PosCentMass __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PosCentMass_
{
  using Type = PosCentMass_<ContainerAllocator>;

  explicit PosCentMass_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit PosCentMass_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MIN =
    1u;
  static constexpr uint8_t MAX =
    63u;
  static constexpr uint8_t TEN_CENTIMETRES =
    1u;
  static constexpr uint8_t OUT_OF_RANGE =
    62u;
  static constexpr uint8_t UNAVAILABLE =
    63u;

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__PosCentMass
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__PosCentMass
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::PosCentMass_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PosCentMass_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const PosCentMass_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PosCentMass_

// alias to use template instance with default allocator
using PosCentMass =
  etsi_its_vam_ts_msgs::msg::PosCentMass_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PosCentMass_<ContainerAllocator>::MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PosCentMass_<ContainerAllocator>::MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PosCentMass_<ContainerAllocator>::TEN_CENTIMETRES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PosCentMass_<ContainerAllocator>::OUT_OF_RANGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PosCentMass_<ContainerAllocator>::UNAVAILABLE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__POS_CENT_MASS__STRUCT_HPP_
