﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/RoadType.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/road_type.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__ROAD_TYPE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__ROAD_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'URBAN_NO_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES'.
enum
{
  etsi_its_vam_ts_msgs__msg__RoadType__URBAN_NO_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 0
};

/// Constant 'URBAN_WITH_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES'.
enum
{
  etsi_its_vam_ts_msgs__msg__RoadType__URBAN_WITH_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 1
};

/// Constant 'NON_URBAN_NO_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES'.
enum
{
  etsi_its_vam_ts_msgs__msg__RoadType__NON_URBAN_NO_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 2
};

/// Constant 'NON_URBAN_WITH_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES'.
enum
{
  etsi_its_vam_ts_msgs__msg__RoadType__NON_URBAN_WITH_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 3
};

/// Struct defined in msg/RoadType in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__RoadType
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// RoadType ::= ENUMERATED {
  ///     urban-NoStructuralSeparationToOppositeLanes      (0),
  ///     urban-WithStructuralSeparationToOppositeLanes    (1),
  ///     nonUrban-NoStructuralSeparationToOppositeLanes   (2),
  ///     nonUrban-WithStructuralSeparationToOppositeLanes (3)
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE indicates the type of a road segment.
  /// *
  /// * The value shall be set to:
  /// * - 0 `urban-NoStructuralSeparationToOppositeLanes`       - for an urban road with no structural separation between lanes carrying traffic in opposite directions,
  /// * - 1 `urban-WithStructuralSeparationToOppositeLanes`     - for an urban road with structural separation between lanes carrying traffic in opposite directions,
  /// * - 2 `nonUrban-NoStructuralSeparationToOppositeLanes`    - for an non urban road with no structural separation between lanes carrying traffic in opposite directions,
  /// * - 3 `nonUrban-WithStructuralSeparationToOppositeLanes`  - for an non urban road with structural separation between lanes carrying traffic in opposite directions.
  /// *
  /// * @category: Road Topology Information
  /// * @revision: Editorial update in V2.1.1
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__RoadType;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__RoadType.
typedef struct etsi_its_vam_ts_msgs__msg__RoadType__Sequence
{
  etsi_its_vam_ts_msgs__msg__RoadType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__RoadType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__ROAD_TYPE__STRUCT_H_
