// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/RoadworksSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/roadworks_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x88, 0x60, 0xa3, 0xf6, 0x7b, 0x2c, 0xab, 0xba,
      0x1e, 0x8b, 0x7a, 0x0a, 0x01, 0x12, 0x6b, 0x80,
      0xf8, 0xf2, 0xec, 0x85, 0xca, 0xfb, 0xb8, 0xda,
      0x66, 0x02, 0x16, 0xd7, 0xf5, 0xdd, 0x25, 0x12,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/RoadworksSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__TYPE_NAME, 46, 46},
      {etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# RoadworksSubCauseCode ::= INTEGER {\n"
  "#     unavailable                  (0), \n"
  "#     majorRoadworks               (1),\n"
  "#     roadMarkingWork              (2), \n"
  "#     slowMovingRoadMaintenance    (3), \n"
  "#     shortTermStationaryRoadworks (4), \n"
  "#    streetCleaning                (5), \n"
  "#    winterService                 (6)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the value of the sub cause codes of the @ref CauseCode `roadworks`.\n"
  "# * \n"
  "#The value shall be set to:\n"
  "# * - 0 `unavailable`                 - in case further detailed information on roadworks is unavailable,\n"
  "# * - 1 `majorRoadworks`              - in case a major roadworks is ongoing,\n"
  "# * - 2 `roadMarkingWork`             - in case a road marking work is ongoing,\n"
  "# * - 3 `slowMovingRoadMaintenance`   - in case slow moving road maintenance work is ongoing,\n"
  "# * - 4 `shortTermStationaryRoadworks`- in case a short term stationary roadwork is ongoing,\n"
  "# * - 5 `streetCleaning`              - in case a vehicle street cleaning work is ongoing,\n"
  "# * - 6 `winterService`               - in case winter service work is ongoing.\n"
  "# * - 7-255                           - are reserved for future usage.\n"
  "# *\n"
  "# * @category: Traffic information\n"
  "# * @revision: V1.3.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 MAJOR_ROADWORKS = 1\n"
  "uint8 ROAD_MARKING_WORK = 2\n"
  "uint8 SLOW_MOVING_ROAD_MAINTENANCE = 3\n"
  "uint8 SHORT_TERM_STATIONARY_ROADWORKS = 4\n"
  "uint8 STREET_CLEANING = 5\n"
  "uint8 WINTER_SERVICE = 6";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__TYPE_NAME, 46, 46},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3119, 3119},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__RoadworksSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
