// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/SlowVehicleSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/slow_vehicle_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x47, 0x16, 0xcc, 0x4e, 0x75, 0x7d, 0xfc, 0xac,
      0x0b, 0xa0, 0xdf, 0x4d, 0xe8, 0x7e, 0xef, 0x93,
      0xe6, 0x69, 0x99, 0x83, 0x28, 0xdb, 0xe2, 0x92,
      0x38, 0x8e, 0x2e, 0x8d, 0x2e, 0x46, 0x57, 0xdb,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/SlowVehicleSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__TYPE_NAME, 48, 48},
      {etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# SlowVehicleSubCauseCode ::= INTEGER {\n"
  "#     unavailable                     (0), \n"
  "#     maintenanceVehicle              (1), \n"
  "#     vehiclesSlowingToLookAtAccident (2), \n"
  "#     abnormalLoad                    (3), \n"
  "#     abnormalWideLoad                (4), \n"
  "#     convoy                          (5), \n"
  "#     snowplough                      (6), \n"
  "#     deicing                         (7), \n"
  "#     saltingVehicles                 (8)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the sub cause codes of the @ref CauseCode \"slowVehicle\".\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0 `unavailable`                    - in case further detailed information on slow vehicle driving event is\n"
  "# *                                        unavailable,\n"
  "# * - 1 `maintenanceVehicle`             - in case of a slow driving maintenance vehicle on the road,\n"
  "# * - 2 `vehiclesSlowingToLookAtAccident`- in case vehicle is temporally slowing down to look at accident, spot, etc.,\n"
  "# * - 3 `abnormalLoad`                   - in case an abnormal loaded vehicle is driving slowly on the road,\n"
  "# * - 4 `abnormalWideLoad`               - in case an abnormal wide load vehicle is driving slowly on the road,\n"
  "# * - 5 `convoy`                         - in case of slow driving convoy on the road,\n"
  "# * - 6 `snowplough`                     - in case of slow driving snow plough on the road,\n"
  "# * - 7 `deicing`                        - in case of slow driving de-icing vehicle on the road,\n"
  "# * - 8 `saltingVehicles`                - in case of slow driving salting vehicle on the road.\n"
  "# * - 9-255                              - are reserved for future usage.\n"
  "# * \n"
  "# * @category: Traffic information\n"
  "# * @revision: V1.3.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 MAINTENANCE_VEHICLE = 1\n"
  "uint8 VEHICLES_SLOWING_TO_LOOK_AT_ACCIDENT = 2\n"
  "uint8 ABNORMAL_LOAD = 3\n"
  "uint8 ABNORMAL_WIDE_LOAD = 4\n"
  "uint8 CONVOY = 5\n"
  "uint8 SNOWPLOUGH = 6\n"
  "uint8 DEICING = 7\n"
  "uint8 SALTING_VEHICLES = 8";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__TYPE_NAME, 48, 48},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3615, 3615},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__SlowVehicleSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
