// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/SpeedConfidence.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/speed_confidence__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__SpeedConfidence__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x5b, 0xdb, 0x1e, 0x9e, 0x0d, 0x00, 0x89, 0x44,
      0xab, 0xfd, 0x64, 0x39, 0xaa, 0x65, 0x57, 0x7c,
      0x8f, 0xd6, 0xae, 0x0d, 0x9a, 0x9b, 0xe9, 0xf4,
      0xe3, 0x80, 0x72, 0x20, 0xf1, 0x49, 0x12, 0x42,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__SpeedConfidence__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/SpeedConfidence";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__SpeedConfidence__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__SpeedConfidence__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__SpeedConfidence__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__SpeedConfidence__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__SpeedConfidence__TYPE_NAME, 40, 40},
      {etsi_its_vam_ts_msgs__msg__SpeedConfidence__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# SpeedConfidence ::= INTEGER {\n"
  "#     outOfRange  (126), \n"
  "#     unavailable (127)\n"
  "# } (1..127)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates the speed confidence value which represents the estimated absolute accuracy of a speed value with a default confidence level of 95 %.\n"
  "# * If required, the confidence level can be defined by the corresponding standards applying this DE.\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n * 0,01 m/s.\n"
  "# * - `126` if the confidence value is out of range, i.e. greater than 1,25 m/s,\n"
  "# * - `127` if the confidence value information is not available.\n"
  "# *  \n"
  "# * @note: The fact that a speed value is received with confidence value set to `unavailable(127)` can be caused by several reasons, such as:\n"
  "# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,\n"
  "# * - the sensor cannot calculate the accuracy due to lack of variables, or\n"
  "# * - there has been a vehicle bus (e.g. CAN bus) error.\n"
  "# * In all 3 cases above, the speed value may be valid and used by the application.\n"
  "# * \n"
  "# * @note: If a speed value is received and its confidence value is set to `outOfRange(126)`, it means that the speed value is not valid \n"
  "# * and therefore cannot be trusted. Such is not useful for the application.\n"
  "# *\n"
  "# * @unit: 0,01 m/s\n"
  "# * @category: Vehicle information\n"
  "# * @revision: Description revised in V2.1.1 \n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 1\n"
  "uint8 MAX = 127\n"
  "uint8 OUT_OF_RANGE = 126\n"
  "uint8 UNAVAILABLE = 127";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__SpeedConfidence__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__SpeedConfidence__TYPE_NAME, 40, 40},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3179, 3179},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__SpeedConfidence__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__SpeedConfidence__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
