// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_vam_ts_msgs:msg/StabilityChangeIndication.idl
// generated code does not contain a copyright notice
#include "etsi_its_vam_ts_msgs/msg/detail/stability_change_indication__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `loss_probability`
#include "etsi_its_vam_ts_msgs/msg/detail/stability_loss_probability__functions.h"
// Member `action_delta_time`
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_tenth_of_second__functions.h"

bool
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__init(etsi_its_vam_ts_msgs__msg__StabilityChangeIndication * msg)
{
  if (!msg) {
    return false;
  }
  // loss_probability
  if (!etsi_its_vam_ts_msgs__msg__StabilityLossProbability__init(&msg->loss_probability)) {
    etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__fini(msg);
    return false;
  }
  // action_delta_time
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__init(&msg->action_delta_time)) {
    etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__fini(etsi_its_vam_ts_msgs__msg__StabilityChangeIndication * msg)
{
  if (!msg) {
    return;
  }
  // loss_probability
  etsi_its_vam_ts_msgs__msg__StabilityLossProbability__fini(&msg->loss_probability);
  // action_delta_time
  etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__fini(&msg->action_delta_time);
}

bool
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__are_equal(const etsi_its_vam_ts_msgs__msg__StabilityChangeIndication * lhs, const etsi_its_vam_ts_msgs__msg__StabilityChangeIndication * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // loss_probability
  if (!etsi_its_vam_ts_msgs__msg__StabilityLossProbability__are_equal(
      &(lhs->loss_probability), &(rhs->loss_probability)))
  {
    return false;
  }
  // action_delta_time
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__are_equal(
      &(lhs->action_delta_time), &(rhs->action_delta_time)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__copy(
  const etsi_its_vam_ts_msgs__msg__StabilityChangeIndication * input,
  etsi_its_vam_ts_msgs__msg__StabilityChangeIndication * output)
{
  if (!input || !output) {
    return false;
  }
  // loss_probability
  if (!etsi_its_vam_ts_msgs__msg__StabilityLossProbability__copy(
      &(input->loss_probability), &(output->loss_probability)))
  {
    return false;
  }
  // action_delta_time
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__copy(
      &(input->action_delta_time), &(output->action_delta_time)))
  {
    return false;
  }
  return true;
}

etsi_its_vam_ts_msgs__msg__StabilityChangeIndication *
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__StabilityChangeIndication * msg = (etsi_its_vam_ts_msgs__msg__StabilityChangeIndication *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__StabilityChangeIndication), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_vam_ts_msgs__msg__StabilityChangeIndication));
  bool success = etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__destroy(etsi_its_vam_ts_msgs__msg__StabilityChangeIndication * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence__init(etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__StabilityChangeIndication * data = NULL;

  if (size) {
    data = (etsi_its_vam_ts_msgs__msg__StabilityChangeIndication *)allocator.zero_allocate(size, sizeof(etsi_its_vam_ts_msgs__msg__StabilityChangeIndication), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence__fini(etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence *
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence * array = (etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence__destroy(etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence__are_equal(const etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence * lhs, const etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence__copy(
  const etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence * input,
  etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_vam_ts_msgs__msg__StabilityChangeIndication);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_vam_ts_msgs__msg__StabilityChangeIndication * data =
      (etsi_its_vam_ts_msgs__msg__StabilityChangeIndication *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
