// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/StationarySince.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/stationary_since__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__StationarySince__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x14, 0xf8, 0x88, 0xd8, 0x83, 0x2d, 0xf8, 0xb9,
      0x76, 0x37, 0x93, 0x6a, 0x39, 0x1b, 0x3d, 0x0b,
      0xc1, 0x5c, 0xf8, 0x5b, 0x34, 0xd7, 0xfd, 0x54,
      0x05, 0xd4, 0xe5, 0x50, 0xff, 0x5e, 0xd8, 0x65,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__StationarySince__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/StationarySince";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__StationarySince__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__StationarySince__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__StationarySince__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__StationarySince__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__StationarySince__TYPE_NAME, 40, 40},
      {etsi_its_vam_ts_msgs__msg__StationarySince__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# StationarySince ::= ENUMERATED {\n"
  "#     lessThan1Minute         (0), \n"
  "#     lessThan2Minutes        (1), \n"
  "#     lessThan15Minutes       (2), \n"
  "#     equalOrGreater15Minutes (3)\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates the duration in minutes since which something is stationary.\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0 `lessThan1Minute`         - for being stationary since less than 1 minute, \n"
  "# * - 1 `lessThan2Minutes`        - for being stationary since less than 2 minute and for equal to or more than 1 minute,\n"
  "# * - 2 `lessThan15Minutes`       - for being stationary since less than 15 minutes and for equal to or more than 1 minute,\n"
  "# * - 3 `equalOrGreater15Minutes` - for being stationary since equal to or more than 15 minutes.\n"
  "# *\n"
  "# * @category: Kinematic information\n"
  "# * @revision: Created in V2.1.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 LESS_THAN1_MINUTE = 0\n"
  "uint8 LESS_THAN2_MINUTES = 1\n"
  "uint8 LESS_THAN15_MINUTES = 2\n"
  "uint8 EQUAL_OR_GREATER15_MINUTES = 3\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__StationarySince__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__StationarySince__TYPE_NAME, 40, 40},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2594, 2594},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__StationarySince__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__StationarySince__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
