// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/Temperature.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/temperature__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__Temperature__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x8a, 0x3b, 0x26, 0x59, 0x2a, 0x2d, 0x43, 0x01,
      0x40, 0x48, 0x2b, 0x66, 0x66, 0x03, 0xe0, 0xbc,
      0x47, 0xe4, 0x86, 0xbc, 0x05, 0xe8, 0xe3, 0x1c,
      0x5a, 0x98, 0x8c, 0xb9, 0x3c, 0x9a, 0x69, 0x58,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__Temperature__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/Temperature";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__Temperature__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__Temperature__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__Temperature__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__Temperature__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__Temperature__TYPE_NAME, 36, 36},
      {etsi_its_vam_ts_msgs__msg__Temperature__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# Temperature ::= INTEGER {\n"
  "#     equalOrSmallerThanMinus60Deg (-60), \n"
  "#     equalOrGreaterThan67Deg(67)} (-60..67)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates a temperature value.\n"
  "#\n"
  "# * The value shall be set to:\n"
  "# * - `-60` for temperature equal to or less than -60 degrees C,\n"
  "# * - `n` (`n > -60` and `n < 67`) for the actual temperature n in degrees C,\n"
  "# * - `67` for temperature equal to or greater than 67 degrees C.\n"
  "# * \n"
  "# * @unit: degrees Celsius\n"
  "# * @category: Basic information\n"
  "# * @revision: Editorial update in V2.1.1\n"
  "# \n"
  "\n"
  "int8 value\n"
  "int8 MIN = -60\n"
  "int8 MAX = 67\n"
  "int8 EQUAL_OR_SMALLER_THAN_MINUS60_DEG = -60\n"
  "int8 EQUAL_OR_GREATER_THAN67_DEG = 67";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__Temperature__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__Temperature__TYPE_NAME, 36, 36},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2287, 2287},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__Temperature__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__Temperature__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
