// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/TrafficIslandPosition.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/traffic_island_position.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__TRAFFIC_ISLAND_POSITION__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__TRAFFIC_ISLAND_POSITION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'one_side'
// Member 'other_side'
#include "etsi_its_vam_ts_msgs/msg/detail/lane_position_and_type__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__TrafficIslandPosition __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__TrafficIslandPosition __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TrafficIslandPosition_
{
  using Type = TrafficIslandPosition_<ContainerAllocator>;

  explicit TrafficIslandPosition_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : one_side(_init),
    other_side(_init)
  {
    (void)_init;
  }

  explicit TrafficIslandPosition_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : one_side(_alloc, _init),
    other_side(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _one_side_type =
    etsi_its_vam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator>;
  _one_side_type one_side;
  using _other_side_type =
    etsi_its_vam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator>;
  _other_side_type other_side;

  // setters for named parameter idiom
  Type & set__one_side(
    const etsi_its_vam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator> & _arg)
  {
    this->one_side = _arg;
    return *this;
  }
  Type & set__other_side(
    const etsi_its_vam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator> & _arg)
  {
    this->other_side = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__TrafficIslandPosition
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__TrafficIslandPosition
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrafficIslandPosition_ & other) const
  {
    if (this->one_side != other.one_side) {
      return false;
    }
    if (this->other_side != other.other_side) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrafficIslandPosition_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrafficIslandPosition_

// alias to use template instance with default allocator
using TrafficIslandPosition =
  etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__TRAFFIC_ISLAND_POSITION__STRUCT_HPP_
