// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/TrafficRule.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/traffic_rule__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__TrafficRule__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xd9, 0xd3, 0xf9, 0x60, 0xbf, 0x38, 0x43, 0x49,
      0x4d, 0x1d, 0x83, 0x9f, 0x89, 0x7f, 0x5a, 0x3e,
      0x79, 0x96, 0xd5, 0xc4, 0xd5, 0x1f, 0xaf, 0x36,
      0x38, 0x22, 0xff, 0x39, 0x89, 0xa5, 0x34, 0x67,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__TrafficRule__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/TrafficRule";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__TrafficRule__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__TrafficRule__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__TrafficRule__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__TrafficRule__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__TrafficRule__TYPE_NAME, 36, 36},
      {etsi_its_vam_ts_msgs__msg__TrafficRule__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# TrafficRule ::= ENUMERATED {\n"
  "#     noPassing          (0), \n"
  "#     noPassingForTrucks (1), \n"
  "#     passToRight        (2), \n"
  "#     passToLeft         (3), \n"
  "#  ...}\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates traffic rules that apply to vehicles at a certain position.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - `0` - if overtaking is prohibited for all vehicles,\n"
  "# * - `1` - if overtaking is prohibited for trucks,\n"
  "# * - `2` - if vehicles should pass to the right lane,\n"
  "# * - `3` - if vehicles should pass to the left lane.\n"
  "# *\n"
  "# * @category: Infrastructure information, Traffic information\n"
  "# * @revision: Editorial update in V2.1.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 NO_PASSING = 0\n"
  "uint8 NO_PASSING_FOR_TRUCKS = 1\n"
  "uint8 PASS_TO_RIGHT = 2\n"
  "uint8 PASS_TO_LEFT = 3\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__TrafficRule__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__TrafficRule__TYPE_NAME, 36, 36},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2377, 2377},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__TrafficRule__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__TrafficRule__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
