// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/TrailerPresenceInformation.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/trailer_presence_information__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x1f, 0x25, 0xf0, 0x26, 0xad, 0x71, 0x0c, 0x2f,
      0x71, 0x60, 0xf3, 0xa0, 0xb2, 0x02, 0x96, 0xf4,
      0x14, 0x68, 0xb4, 0x8f, 0x94, 0xe6, 0x6d, 0xef,
      0xfc, 0x64, 0xc0, 0x35, 0x25, 0x69, 0x5f, 0x8d,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/TrailerPresenceInformation";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__TYPE_NAME, 51, 51},
      {etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# TrailerPresenceInformation ::= ENUMERATED {\n"
  "#     noTrailerPresent                (0), \n"
  "#     trailerPresentWithKnownLength   (1), \n"
  "#     trailerPresentWithUnknownLength (2), \n"
  "#     trailerPresenceIsUnknown        (3), \n"
  "#     unavailable                     (4)\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE provides information about the presence of a trailer. \n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - 0 `noTrailerPresent`                - to indicate that no trailer is present, i.e. either the vehicle is physically not enabled to tow a trailer or it has been detected that no trailer is present.\n"
  "# * - 1 `trailerPresentWithKnownLength`   - to indicate that a trailer has been detected as present and the length is included in the vehicle length value.\n"
  "# * - 2 `trailerPresentWithUnknownLength` - to indicate that a trailer has been detected as present and the length is not included in the vehicle length value.\n"
  "# * - 3 `trailerPresenceIsUnknown`        - to indicate that information about the trailer presence is unknown, i.e. the vehicle is physically enabled to tow a trailer but the detection of trailer presence/absence is not possible.\n"
  "# * - 4 `unavailable`                     - to indicate that the information about the presence of a trailer is not available, i.e. it is neither known whether the vehicle is able to tow a trailer \n"
  "# *                                         nor the detection of trailer presence/absence is possible.\n"
  "# * \n"
  "# * @category: Vehicle information\n"
  "# * @revision: Created in V2.1.1 based on VehicleLengthConfidenceIndication\n"
  "#\n"
  "\n"
  "uint8 value\n"
  "uint8 NO_TRAILER_PRESENT = 0\n"
  "uint8 TRAILER_PRESENT_WITH_KNOWN_LENGTH = 1\n"
  "uint8 TRAILER_PRESENT_WITH_UNKNOWN_LENGTH = 2\n"
  "uint8 TRAILER_PRESENCE_IS_UNKNOWN = 3\n"
  "uint8 UNAVAILABLE = 4\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__TYPE_NAME, 51, 51},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3384, 3384},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__TrailerPresenceInformation__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
