// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VAM.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/vam.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAM__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAM__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "etsi_its_vam_ts_msgs/msg/detail/its_pdu_header_vam__struct.hpp"
// Member 'vam'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_awareness__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VAM __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VAM __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VAM_
{
  using Type = VAM_<ContainerAllocator>;

  explicit VAM_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    vam(_init)
  {
    (void)_init;
  }

  explicit VAM_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    vam(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    etsi_its_vam_ts_msgs::msg::ItsPduHeaderVam_<ContainerAllocator>;
  _header_type header;
  using _vam_type =
    etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator>;
  _vam_type vam;

  // setters for named parameter idiom
  Type & set__header(
    const etsi_its_vam_ts_msgs::msg::ItsPduHeaderVam_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__vam(
    const etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator> & _arg)
  {
    this->vam = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VAM
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VAM
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VAM_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VAM_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->vam != other.vam) {
      return false;
    }
    return true;
  }
  bool operator!=(const VAM_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VAM_

// alias to use template instance with default allocator
using VAM =
  etsi_its_vam_ts_msgs::msg::VAM_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAM__STRUCT_HPP_
