﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/VehicleRole.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/vehicle_role.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VEHICLE_ROLE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VEHICLE_ROLE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'DEFAULT'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__DEFAULT = 0
};

/// Constant 'PUBLIC_TRANSPORT'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__PUBLIC_TRANSPORT = 1
};

/// Constant 'SPECIAL_TRANSPORT'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__SPECIAL_TRANSPORT = 2
};

/// Constant 'DANGEROUS_GOODS'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__DANGEROUS_GOODS = 3
};

/// Constant 'ROAD_WORK'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__ROAD_WORK = 4
};

/// Constant 'RESCUE'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__RESCUE = 5
};

/// Constant 'EMERGENCY'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__EMERGENCY = 6
};

/// Constant 'SAFETY_CAR'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__SAFETY_CAR = 7
};

/// Constant 'AGRICULTURE'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__AGRICULTURE = 8
};

/// Constant 'COMMERCIAL'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__COMMERCIAL = 9
};

/// Constant 'MILITARY'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__MILITARY = 10
};

/// Constant 'ROAD_OPERATOR'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__ROAD_OPERATOR = 11
};

/// Constant 'TAXI'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__TAXI = 12
};

/// Constant 'RESERVED1'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__RESERVED1 = 13
};

/// Constant 'RESERVED2'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__RESERVED2 = 14
};

/// Constant 'RESERVED3'.
enum
{
  etsi_its_vam_ts_msgs__msg__VehicleRole__RESERVED3 = 15
};

/// Struct defined in msg/VehicleRole in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__VehicleRole
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// VehicleRole ::= ENUMERATED {
  ///     default         (0),
  ///     publicTransport (1),
  ///     specialTransport(2),
  ///     dangerousGoods  (3),
  ///     roadWork        (4),
  ///     rescue          (5),
  ///     emergency       (6),
  ///     safetyCar       (7),
  ///     agriculture     (8),
  ///     commercial      (9),
  ///     military        (10),
  ///     roadOperator    (11),
  ///     taxi            (12),
  ///     reserved1       (13),
  ///     reserved2       (14),
  ///     reserved3       (15)
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE indicates the role played by a vehicle at a point in time.
  /// *
  /// * The value shall be set to:
  /// * - 0 `default`          - to indicate the default vehicle role as indicated by the vehicle type,
  /// * - 1 `publicTransport`  - to indicate that the vehicle is used to operate public transport service,
  /// * - 2 `specialTransport` - to indicate that the vehicle is used for special transport purpose, e.g. oversized trucks,
  /// * - 3 `dangerousGoods`   - to indicate that the vehicle is used for dangerous goods transportation,
  /// * - 4 `roadWork`         - to indicate that the vehicle is used to realize roadwork or road maintenance mission,
  /// * - 5 `rescue`           - to indicate that the vehicle is used for rescue purpose in case of an accident, e.g. as a towing service,
  /// * - 6 `emergency`        - to indicate that the vehicle is used for emergency mission, e.g. ambulance, fire brigade,
  /// * - 7 `safetyCar`        - to indicate that the vehicle is used for public safety, e.g. patrol,
  /// * - 8 `agriculture`      - to indicate that the vehicle is used for agriculture, e.g. farm tractor,
  /// * - 9 `commercial`       - to indicate that the vehicle is used for transportation of commercial goods,
  /// * - 10 `military`        - to indicate that the vehicle is used for military purpose,
  /// * - 11 `roadOperator`    - to indicate that the vehicle is used in road operator missions,
  /// * - 12 `taxi`            - to indicate that the vehicle is used to provide an authorized taxi service.
  /// * - 13 `reserved`        - is reserved for future usage.
  /// * - 14 `reserved`        - is reserved for future usage.
  /// * - 15 `reserved`        - is reserved for future usage.
  /// *
  /// * @category: Vehicle Information
  /// * @revision: Description updated in V2.1.1 (removed reference to CEN/TS 16157-3)
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__VehicleRole;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__VehicleRole.
typedef struct etsi_its_vam_ts_msgs__msg__VehicleRole__Sequence
{
  etsi_its_vam_ts_msgs__msg__VehicleRole * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__VehicleRole__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VEHICLE_ROLE__STRUCT_H_
