// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/VelocityComponentValue.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/velocity_component_value__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__VelocityComponentValue__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x75, 0xbd, 0x52, 0x26, 0x07, 0x28, 0xd4, 0x8f,
      0x55, 0x54, 0x84, 0x62, 0x51, 0x88, 0x65, 0x9e,
      0x9b, 0x6a, 0x62, 0x1e, 0x20, 0xbb, 0xe9, 0x15,
      0xd5, 0x49, 0x3d, 0xec, 0xe3, 0xc2, 0x71, 0xcf,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__VelocityComponentValue__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/VelocityComponentValue";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__VelocityComponentValue__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__VelocityComponentValue__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__VelocityComponentValue__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__VelocityComponentValue__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__VelocityComponentValue__TYPE_NAME, 47, 47},
      {etsi_its_vam_ts_msgs__msg__VelocityComponentValue__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# VelocityComponentValue ::= INTEGER {\n"
  "#     negativeOutOfRange (-16383),\n"
  "#     positiveOutOfRange  (16382),\n"
  "#     unavailable        (16383)\n"
  "# } (-16383..16383)\n"
  "# ------------------------------------------------------------------------------\n"
  "# * \n"
  "# * This DE represents the value of a velocity component in a defined coordinate system.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - `-16 383` if the velocity is equal to or smaller than -163,83 m/s,\n"
  "# * - `n` (`n > -16 383` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,\n"
  "# * - `16 382` for velocity values equal to or greater than 163,81 m/s,\n"
  "# * - `16 383` if the velocity information is not available.\n"
  "# * \n"
  "# * @unit: 0,01 m/s\n"
  "# * @category: Kinematic information\n"
  "# * @revision: Created in V2.1.1\n"
  "#\n"
  "\n"
  "int16 value\n"
  "int16 MIN = -16383\n"
  "int16 MAX = 16383\n"
  "int16 NEGATIVE_OUT_OF_RANGE = -16383\n"
  "int16 POSITIVE_OUT_OF_RANGE = 16382\n"
  "int16 UNAVAILABLE = 16383";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__VelocityComponentValue__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__VelocityComponentValue__TYPE_NAME, 47, 47},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2532, 2532},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__VelocityComponentValue__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__VelocityComponentValue__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
