// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_vam_ts_msgs:msg/VruClusterOperationContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_vam_ts_msgs/msg/detail/vru_cluster_operation_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `cluster_join_info`
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_join_info__functions.h"
// Member `cluster_leave_info`
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_leave_info__functions.h"
// Member `cluster_breakup_info`
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_breakup_info__functions.h"
// Member `cluster_id_change_time_info`
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_quarter_second__functions.h"

bool
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__init(etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer * msg)
{
  if (!msg) {
    return false;
  }
  // cluster_join_info
  if (!etsi_its_vam_ts_msgs__msg__ClusterJoinInfo__init(&msg->cluster_join_info)) {
    etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__fini(msg);
    return false;
  }
  // cluster_join_info_is_present
  // cluster_leave_info
  if (!etsi_its_vam_ts_msgs__msg__ClusterLeaveInfo__init(&msg->cluster_leave_info)) {
    etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__fini(msg);
    return false;
  }
  // cluster_leave_info_is_present
  // cluster_breakup_info
  if (!etsi_its_vam_ts_msgs__msg__ClusterBreakupInfo__init(&msg->cluster_breakup_info)) {
    etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__fini(msg);
    return false;
  }
  // cluster_breakup_info_is_present
  // cluster_id_change_time_info
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeQuarterSecond__init(&msg->cluster_id_change_time_info)) {
    etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__fini(msg);
    return false;
  }
  // cluster_id_change_time_info_is_present
  return true;
}

void
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__fini(etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer * msg)
{
  if (!msg) {
    return;
  }
  // cluster_join_info
  etsi_its_vam_ts_msgs__msg__ClusterJoinInfo__fini(&msg->cluster_join_info);
  // cluster_join_info_is_present
  // cluster_leave_info
  etsi_its_vam_ts_msgs__msg__ClusterLeaveInfo__fini(&msg->cluster_leave_info);
  // cluster_leave_info_is_present
  // cluster_breakup_info
  etsi_its_vam_ts_msgs__msg__ClusterBreakupInfo__fini(&msg->cluster_breakup_info);
  // cluster_breakup_info_is_present
  // cluster_id_change_time_info
  etsi_its_vam_ts_msgs__msg__DeltaTimeQuarterSecond__fini(&msg->cluster_id_change_time_info);
  // cluster_id_change_time_info_is_present
}

bool
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__are_equal(const etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer * lhs, const etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // cluster_join_info
  if (!etsi_its_vam_ts_msgs__msg__ClusterJoinInfo__are_equal(
      &(lhs->cluster_join_info), &(rhs->cluster_join_info)))
  {
    return false;
  }
  // cluster_join_info_is_present
  if (lhs->cluster_join_info_is_present != rhs->cluster_join_info_is_present) {
    return false;
  }
  // cluster_leave_info
  if (!etsi_its_vam_ts_msgs__msg__ClusterLeaveInfo__are_equal(
      &(lhs->cluster_leave_info), &(rhs->cluster_leave_info)))
  {
    return false;
  }
  // cluster_leave_info_is_present
  if (lhs->cluster_leave_info_is_present != rhs->cluster_leave_info_is_present) {
    return false;
  }
  // cluster_breakup_info
  if (!etsi_its_vam_ts_msgs__msg__ClusterBreakupInfo__are_equal(
      &(lhs->cluster_breakup_info), &(rhs->cluster_breakup_info)))
  {
    return false;
  }
  // cluster_breakup_info_is_present
  if (lhs->cluster_breakup_info_is_present != rhs->cluster_breakup_info_is_present) {
    return false;
  }
  // cluster_id_change_time_info
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeQuarterSecond__are_equal(
      &(lhs->cluster_id_change_time_info), &(rhs->cluster_id_change_time_info)))
  {
    return false;
  }
  // cluster_id_change_time_info_is_present
  if (lhs->cluster_id_change_time_info_is_present != rhs->cluster_id_change_time_info_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__copy(
  const etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer * input,
  etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // cluster_join_info
  if (!etsi_its_vam_ts_msgs__msg__ClusterJoinInfo__copy(
      &(input->cluster_join_info), &(output->cluster_join_info)))
  {
    return false;
  }
  // cluster_join_info_is_present
  output->cluster_join_info_is_present = input->cluster_join_info_is_present;
  // cluster_leave_info
  if (!etsi_its_vam_ts_msgs__msg__ClusterLeaveInfo__copy(
      &(input->cluster_leave_info), &(output->cluster_leave_info)))
  {
    return false;
  }
  // cluster_leave_info_is_present
  output->cluster_leave_info_is_present = input->cluster_leave_info_is_present;
  // cluster_breakup_info
  if (!etsi_its_vam_ts_msgs__msg__ClusterBreakupInfo__copy(
      &(input->cluster_breakup_info), &(output->cluster_breakup_info)))
  {
    return false;
  }
  // cluster_breakup_info_is_present
  output->cluster_breakup_info_is_present = input->cluster_breakup_info_is_present;
  // cluster_id_change_time_info
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeQuarterSecond__copy(
      &(input->cluster_id_change_time_info), &(output->cluster_id_change_time_info)))
  {
    return false;
  }
  // cluster_id_change_time_info_is_present
  output->cluster_id_change_time_info_is_present = input->cluster_id_change_time_info_is_present;
  return true;
}

etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer *
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer * msg = (etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer));
  bool success = etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__destroy(etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence__init(etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer * data = NULL;

  if (size) {
    data = (etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer *)allocator.zero_allocate(size, sizeof(etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence__fini(etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence *
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence * array = (etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence__destroy(etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence__are_equal(const etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence * lhs, const etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence__copy(
  const etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence * input,
  etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer * data =
      (etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
