// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/VruDeviceUsage.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/vru_device_usage__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__VruDeviceUsage__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x99, 0x9e, 0xe6, 0xcb, 0xf6, 0x6c, 0x38, 0x8e,
      0xab, 0x95, 0xef, 0xf5, 0x47, 0x6c, 0xff, 0xb4,
      0xe0, 0xdc, 0x40, 0x68, 0x52, 0x78, 0x2b, 0xbe,
      0x29, 0xd8, 0xd7, 0xbf, 0x08, 0xd2, 0xa1, 0x2d,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__VruDeviceUsage__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/VruDeviceUsage";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__VruDeviceUsage__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__VruDeviceUsage__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__VruDeviceUsage__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__VruDeviceUsage__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__VruDeviceUsage__TYPE_NAME, 39, 39},
      {etsi_its_vam_ts_msgs__msg__VruDeviceUsage__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# VruDeviceUsage ::= ENUMERATED {\n"
  "#     unavailable      (0), \n"
  "#     other            (1), \n"
  "#     idle             (2), \n"
  "#     listeningToAudio (3), \n"
  "#     typing           (4), \n"
  "#     calling          (5), \n"
  "#     playingGames     (6), \n"
  "#     reading          (7), \n"
  "#     viewing          (8), \n"
  "#     max              (255)\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the possible usage conditions of the VRU device.\n"
  "#\n"
  "# * - The value shall be set to:\n"
  "# * - 0 `unavailable`      - to indicate that the usage conditions are unavailable,\n"
  "# * - 1 `other`            - to indicate that the VRU device is in a state not defined below,\n"
  "# * - 2 `idle`             - to indicate that the human is currently not interacting with the device,\n"
  "# * - 3 `listeningToAudio` - to indicate that any audio source other than calling is in use,\n"
  "# * - 4 `typing`           - to indicate that the human is texting or performaing any other manual input activity,\n"
  "# * - 5 `calling`          - to indicate that the VRU device is currently receiving a call,\n"
  "# * - 6 `playingGames`     - to indicate that the human is playing games,\n"
  "# * - 7 `reading`          - to indicate that the human is reading on the VRU device,\n"
  "# * - 8 `viewing`          - to indicate that the human is watching dynamic content, including following navigation prompts, viewing videos or other visual contents that are not static.\n"
  "# * - value 9 to 255       - are reserved for future usage. Value 255 set to \"max\" in order to bound the size of the encoded field.\n"
  "# *\n"
  "# * @category: VRU information\n"
  "# * @revision: Created in V2.1.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 OTHER = 1\n"
  "uint8 IDLE = 2\n"
  "uint8 LISTENING_TO_AUDIO = 3\n"
  "uint8 TYPING = 4\n"
  "uint8 CALLING = 5\n"
  "uint8 PLAYING_GAMES = 6\n"
  "uint8 READING = 7\n"
  "uint8 VIEWING = 8\n"
  "uint8 MAX = 255\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__VruDeviceUsage__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__VruDeviceUsage__TYPE_NAME, 39, 39},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3423, 3423},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__VruDeviceUsage__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__VruDeviceUsage__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
