﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/VruEnvironment.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/vru_environment.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_ENVIRONMENT__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_ENVIRONMENT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruEnvironment__UNAVAILABLE = 0
};

/// Constant 'INTERSECTION_CROSSING'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruEnvironment__INTERSECTION_CROSSING = 1
};

/// Constant 'ZEBRA_CROSSING'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruEnvironment__ZEBRA_CROSSING = 2
};

/// Constant 'SIDEWALK'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruEnvironment__SIDEWALK = 3
};

/// Constant 'ON_VEHICLE_ROAD'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruEnvironment__ON_VEHICLE_ROAD = 4
};

/// Constant 'PROTECTED_GEOGRAPHIC_AREA'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruEnvironment__PROTECTED_GEOGRAPHIC_AREA = 5
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruEnvironment__MAX = 255
};

/// Struct defined in msg/VruEnvironment in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__VruEnvironment
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// VruEnvironment ::= ENUMERATED {
  ///     unavailable             (0),
  ///     intersectionCrossing    (1),
  ///     zebraCrossing           (2),
  ///     sidewalk                (3),
  ///     onVehicleRoad           (4),
  ///     protectedGeographicArea (5),
  ///     max                     (255)
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the possible VRU environment conditions.
  /// *
  /// * - The value shall be set to:
  /// * - 0 `unavailable`            - to indicate that the information on the type of environment is unavailable,
  /// * - 1 `intersectionCrossing`   - to indicate that the VRU is on an intersection or crossing,
  /// * - 2 `zebraCrossing`          - to indicate that the VRU is on a  zebra crossing (crosswalk),
  /// * - 3 `sidewalk`               - to indicate that the VRU is on a sidewalk,
  /// * - 4 `onVehicleRoad`          - to indicate that the VRU is on a traffic lane,
  /// * - 5 `protectedGeographicArea`- to indicate that the VRU is in a protected area.
  /// * - value 5 to 255             - are reserved for future usage. Value 255 is set to "max" in order to bound the size of the encoded field.
  /// *
  /// * @category: VRU information
  /// * @revision: Created in V2.1.1
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__VruEnvironment;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__VruEnvironment.
typedef struct etsi_its_vam_ts_msgs__msg__VruEnvironment__Sequence
{
  etsi_its_vam_ts_msgs__msg__VruEnvironment * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__VruEnvironment__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_ENVIRONMENT__STRUCT_H_
