// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VruMotionPredictionContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/vru_motion_prediction_container.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_MOTION_PREDICTION_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_MOTION_PREDICTION_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'path_history'
#include "etsi_its_vam_ts_msgs/msg/detail/path_history__struct.hpp"
// Member 'path_prediction'
#include "etsi_its_vam_ts_msgs/msg/detail/path_predicted__struct.hpp"
// Member 'safe_distance'
#include "etsi_its_vam_ts_msgs/msg/detail/sequence_of_safe_distance_indication__struct.hpp"
// Member 'trajectory_interception_indication'
#include "etsi_its_vam_ts_msgs/msg/detail/sequence_of_trajectory_interception_indication__struct.hpp"
// Member 'acceleration_change_indication'
#include "etsi_its_vam_ts_msgs/msg/detail/acceleration_change_indication__struct.hpp"
// Member 'heading_change_indication'
#include "etsi_its_vam_ts_msgs/msg/detail/heading_change_indication__struct.hpp"
// Member 'stability_change_indication'
#include "etsi_its_vam_ts_msgs/msg/detail/stability_change_indication__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VruMotionPredictionContainer_
{
  using Type = VruMotionPredictionContainer_<ContainerAllocator>;

  explicit VruMotionPredictionContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : path_history(_init),
    path_prediction(_init),
    safe_distance(_init),
    trajectory_interception_indication(_init),
    acceleration_change_indication(_init),
    heading_change_indication(_init),
    stability_change_indication(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->path_history_is_present = false;
      this->path_prediction_is_present = false;
      this->safe_distance_is_present = false;
      this->trajectory_interception_indication_is_present = false;
      this->acceleration_change_indication_is_present = false;
      this->heading_change_indication_is_present = false;
      this->stability_change_indication_is_present = false;
    }
  }

  explicit VruMotionPredictionContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : path_history(_alloc, _init),
    path_prediction(_alloc, _init),
    safe_distance(_alloc, _init),
    trajectory_interception_indication(_alloc, _init),
    acceleration_change_indication(_alloc, _init),
    heading_change_indication(_alloc, _init),
    stability_change_indication(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->path_history_is_present = false;
      this->path_prediction_is_present = false;
      this->safe_distance_is_present = false;
      this->trajectory_interception_indication_is_present = false;
      this->acceleration_change_indication_is_present = false;
      this->heading_change_indication_is_present = false;
      this->stability_change_indication_is_present = false;
    }
  }

  // field types and members
  using _path_history_type =
    etsi_its_vam_ts_msgs::msg::PathHistory_<ContainerAllocator>;
  _path_history_type path_history;
  using _path_history_is_present_type =
    bool;
  _path_history_is_present_type path_history_is_present;
  using _path_prediction_type =
    etsi_its_vam_ts_msgs::msg::PathPredicted_<ContainerAllocator>;
  _path_prediction_type path_prediction;
  using _path_prediction_is_present_type =
    bool;
  _path_prediction_is_present_type path_prediction_is_present;
  using _safe_distance_type =
    etsi_its_vam_ts_msgs::msg::SequenceOfSafeDistanceIndication_<ContainerAllocator>;
  _safe_distance_type safe_distance;
  using _safe_distance_is_present_type =
    bool;
  _safe_distance_is_present_type safe_distance_is_present;
  using _trajectory_interception_indication_type =
    etsi_its_vam_ts_msgs::msg::SequenceOfTrajectoryInterceptionIndication_<ContainerAllocator>;
  _trajectory_interception_indication_type trajectory_interception_indication;
  using _trajectory_interception_indication_is_present_type =
    bool;
  _trajectory_interception_indication_is_present_type trajectory_interception_indication_is_present;
  using _acceleration_change_indication_type =
    etsi_its_vam_ts_msgs::msg::AccelerationChangeIndication_<ContainerAllocator>;
  _acceleration_change_indication_type acceleration_change_indication;
  using _acceleration_change_indication_is_present_type =
    bool;
  _acceleration_change_indication_is_present_type acceleration_change_indication_is_present;
  using _heading_change_indication_type =
    etsi_its_vam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator>;
  _heading_change_indication_type heading_change_indication;
  using _heading_change_indication_is_present_type =
    bool;
  _heading_change_indication_is_present_type heading_change_indication_is_present;
  using _stability_change_indication_type =
    etsi_its_vam_ts_msgs::msg::StabilityChangeIndication_<ContainerAllocator>;
  _stability_change_indication_type stability_change_indication;
  using _stability_change_indication_is_present_type =
    bool;
  _stability_change_indication_is_present_type stability_change_indication_is_present;

  // setters for named parameter idiom
  Type & set__path_history(
    const etsi_its_vam_ts_msgs::msg::PathHistory_<ContainerAllocator> & _arg)
  {
    this->path_history = _arg;
    return *this;
  }
  Type & set__path_history_is_present(
    const bool & _arg)
  {
    this->path_history_is_present = _arg;
    return *this;
  }
  Type & set__path_prediction(
    const etsi_its_vam_ts_msgs::msg::PathPredicted_<ContainerAllocator> & _arg)
  {
    this->path_prediction = _arg;
    return *this;
  }
  Type & set__path_prediction_is_present(
    const bool & _arg)
  {
    this->path_prediction_is_present = _arg;
    return *this;
  }
  Type & set__safe_distance(
    const etsi_its_vam_ts_msgs::msg::SequenceOfSafeDistanceIndication_<ContainerAllocator> & _arg)
  {
    this->safe_distance = _arg;
    return *this;
  }
  Type & set__safe_distance_is_present(
    const bool & _arg)
  {
    this->safe_distance_is_present = _arg;
    return *this;
  }
  Type & set__trajectory_interception_indication(
    const etsi_its_vam_ts_msgs::msg::SequenceOfTrajectoryInterceptionIndication_<ContainerAllocator> & _arg)
  {
    this->trajectory_interception_indication = _arg;
    return *this;
  }
  Type & set__trajectory_interception_indication_is_present(
    const bool & _arg)
  {
    this->trajectory_interception_indication_is_present = _arg;
    return *this;
  }
  Type & set__acceleration_change_indication(
    const etsi_its_vam_ts_msgs::msg::AccelerationChangeIndication_<ContainerAllocator> & _arg)
  {
    this->acceleration_change_indication = _arg;
    return *this;
  }
  Type & set__acceleration_change_indication_is_present(
    const bool & _arg)
  {
    this->acceleration_change_indication_is_present = _arg;
    return *this;
  }
  Type & set__heading_change_indication(
    const etsi_its_vam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator> & _arg)
  {
    this->heading_change_indication = _arg;
    return *this;
  }
  Type & set__heading_change_indication_is_present(
    const bool & _arg)
  {
    this->heading_change_indication_is_present = _arg;
    return *this;
  }
  Type & set__stability_change_indication(
    const etsi_its_vam_ts_msgs::msg::StabilityChangeIndication_<ContainerAllocator> & _arg)
  {
    this->stability_change_indication = _arg;
    return *this;
  }
  Type & set__stability_change_indication_is_present(
    const bool & _arg)
  {
    this->stability_change_indication_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VruMotionPredictionContainer_ & other) const
  {
    if (this->path_history != other.path_history) {
      return false;
    }
    if (this->path_history_is_present != other.path_history_is_present) {
      return false;
    }
    if (this->path_prediction != other.path_prediction) {
      return false;
    }
    if (this->path_prediction_is_present != other.path_prediction_is_present) {
      return false;
    }
    if (this->safe_distance != other.safe_distance) {
      return false;
    }
    if (this->safe_distance_is_present != other.safe_distance_is_present) {
      return false;
    }
    if (this->trajectory_interception_indication != other.trajectory_interception_indication) {
      return false;
    }
    if (this->trajectory_interception_indication_is_present != other.trajectory_interception_indication_is_present) {
      return false;
    }
    if (this->acceleration_change_indication != other.acceleration_change_indication) {
      return false;
    }
    if (this->acceleration_change_indication_is_present != other.acceleration_change_indication_is_present) {
      return false;
    }
    if (this->heading_change_indication != other.heading_change_indication) {
      return false;
    }
    if (this->heading_change_indication_is_present != other.heading_change_indication_is_present) {
      return false;
    }
    if (this->stability_change_indication != other.stability_change_indication) {
      return false;
    }
    if (this->stability_change_indication_is_present != other.stability_change_indication_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const VruMotionPredictionContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VruMotionPredictionContainer_

// alias to use template instance with default allocator
using VruMotionPredictionContainer =
  etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_MOTION_PREDICTION_CONTAINER__STRUCT_HPP_
