// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from etsi_its_vam_ts_msgs:msg/VruMovementControl.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/vru_movement_control.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_MOVEMENT_CONTROL__FUNCTIONS_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_MOVEMENT_CONTROL__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "etsi_its_vam_ts_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "etsi_its_vam_ts_msgs/msg/detail/vru_movement_control__struct.h"

/// Initialize msg/VruMovementControl message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * etsi_its_vam_ts_msgs__msg__VruMovementControl
 * )) before or use
 * etsi_its_vam_ts_msgs__msg__VruMovementControl__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
bool
etsi_its_vam_ts_msgs__msg__VruMovementControl__init(etsi_its_vam_ts_msgs__msg__VruMovementControl * msg);

/// Finalize msg/VruMovementControl message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
void
etsi_its_vam_ts_msgs__msg__VruMovementControl__fini(etsi_its_vam_ts_msgs__msg__VruMovementControl * msg);

/// Create msg/VruMovementControl message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * etsi_its_vam_ts_msgs__msg__VruMovementControl__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
etsi_its_vam_ts_msgs__msg__VruMovementControl *
etsi_its_vam_ts_msgs__msg__VruMovementControl__create(void);

/// Destroy msg/VruMovementControl message.
/**
 * It calls
 * etsi_its_vam_ts_msgs__msg__VruMovementControl__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
void
etsi_its_vam_ts_msgs__msg__VruMovementControl__destroy(etsi_its_vam_ts_msgs__msg__VruMovementControl * msg);

/// Check for msg/VruMovementControl message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
bool
etsi_its_vam_ts_msgs__msg__VruMovementControl__are_equal(const etsi_its_vam_ts_msgs__msg__VruMovementControl * lhs, const etsi_its_vam_ts_msgs__msg__VruMovementControl * rhs);

/// Copy a msg/VruMovementControl message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
bool
etsi_its_vam_ts_msgs__msg__VruMovementControl__copy(
  const etsi_its_vam_ts_msgs__msg__VruMovementControl * input,
  etsi_its_vam_ts_msgs__msg__VruMovementControl * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__VruMovementControl__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__VruMovementControl__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__VruMovementControl__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__VruMovementControl__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/VruMovementControl messages.
/**
 * It allocates the memory for the number of elements and calls
 * etsi_its_vam_ts_msgs__msg__VruMovementControl__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
bool
etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence__init(etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence * array, size_t size);

/// Finalize array of msg/VruMovementControl messages.
/**
 * It calls
 * etsi_its_vam_ts_msgs__msg__VruMovementControl__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
void
etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence__fini(etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence * array);

/// Create array of msg/VruMovementControl messages.
/**
 * It allocates the memory for the array and calls
 * etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence *
etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence__create(size_t size);

/// Destroy array of msg/VruMovementControl messages.
/**
 * It calls
 * etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
void
etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence__destroy(etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence * array);

/// Check for msg/VruMovementControl message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
bool
etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence__are_equal(const etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence * lhs, const etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence * rhs);

/// Copy an array of msg/VruMovementControl messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
bool
etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence__copy(
  const etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence * input,
  etsi_its_vam_ts_msgs__msg__VruMovementControl__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_MOVEMENT_CONTROL__FUNCTIONS_H_
