// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/VruSpecificExteriorLights.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/vru_specific_exterior_lights__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x4e, 0xb1, 0xa2, 0x8c, 0xd1, 0x86, 0x7e, 0x93,
      0xdd, 0xb7, 0x91, 0x75, 0x37, 0xc8, 0xbc, 0x8f,
      0x44, 0x1a, 0x4f, 0x7e, 0x8a, 0xbf, 0x67, 0x57,
      0x9e, 0x92, 0x8a, 0x1b, 0xc0, 0xaf, 0x7a, 0x13,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/VruSpecificExteriorLights";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__FIELD_NAME__value[] = "value";
static char etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__FIELD_NAME__bits_unused[] = "bits_unused";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__FIELD_NAME__bits_unused, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__TYPE_NAME, 50, 50},
      {etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# VruSpecificExteriorLights ::= BIT STRING {\n"
  "#     unavailable    (0),\n"
  "#     backFlashLight (1),\n"
  "#     helmetLight    (2),\n"
  "#     armLight       (3),\n"
  "#     legLight       (4),\n"
  "#     wheelLight     (5)\n"
  "# } (SIZE(8))\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE describes the status of the exterior light switches of a VRU.\n"
  "# *\n"
  "# * The value of each bit indicates the state of the switch, which commands the corresponding light. \n"
  "# * The bit corresponding to a specific light shall be set to 1, when the corresponding switch is turned on, either manually by the driver or VRU \n"
  "# * or automatically by a vehicle or VRU system: \n"
  "# * - 0 `unavailable`     - indicates no information available, \n"
  "# * - 1 `backFlashLight ` - indicates the status of the back flash light,\n"
  "# * - 2 `helmetLight`     - indicates the status of the helmet light,\n"
  "# * - 3 `armLight`        - indicates the status of the arm light,\n"
  "# * - 4 `legLight`        - indicates the status of the leg light,\n"
  "# * - 5 `wheelLight`      - indicates the status of the wheel light. \n"
  "# * - Bits 6 to 8         - are reserved for future use. \n"
  "# * The bit values do not indicate if the corresponding lamps are alight or not.\n"
  "# * If  VRU is not equipped with a certain light or if the light switch status information is not available, the corresponding bit shall be set to 0.\n"
  "# *\n"
  "# * @category: VRU information\n"
  "# * @revision: Created in V2.1.1\n"
  "# \n"
  "\n"
  "uint8[] value\n"
  "uint8 bits_unused\n"
  "uint8 SIZE_BITS = 8\n"
  "uint8 BIT_INDEX_UNAVAILABLE = 0\n"
  "uint8 BIT_INDEX_BACK_FLASH_LIGHT = 1\n"
  "uint8 BIT_INDEX_HELMET_LIGHT = 2\n"
  "uint8 BIT_INDEX_ARM_LIGHT = 3\n"
  "uint8 BIT_INDEX_LEG_LIGHT = 4\n"
  "uint8 BIT_INDEX_WHEEL_LIGHT = 5";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__TYPE_NAME, 50, 50},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3263, 3263},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__VruSpecificExteriorLights__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
