// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/Wgs84AngleConfidence.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/wgs84_angle_confidence__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x34, 0x8d, 0x31, 0x32, 0xf6, 0x4d, 0x7c, 0xcd,
      0xeb, 0x11, 0x67, 0x4b, 0xac, 0x1a, 0x3d, 0x49,
      0xce, 0xdb, 0xa0, 0xb1, 0xbe, 0x87, 0xe0, 0x66,
      0x41, 0xbd, 0x23, 0x9b, 0x35, 0x8d, 0x8e, 0x33,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/Wgs84AngleConfidence";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__TYPE_NAME, 45, 45},
      {etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# Wgs84AngleConfidence ::= INTEGER {\n"
  "#     outOfRange  (126), \n"
  "#     unavailable (127)  \n"
  "# } (1..127)\n"
  "# ------------------------------------------------------------------------------\n"
  "# * \n"
  "# * This DE indicates the angle confidence value which represents the estimated accuracy of an angle value with a default confidence level of 95 %.\n"
  "# * If required, the confidence level can be defined by the corresponding standards applying this DE.\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - `n` (`n >= 1` and `n < 126`) if the confidence value is equal to or less than n x 0,1 degrees and more than (n-1) x 0,1 degrees,\n"
  "# * - `126` if the confidence value is out of range, i.e. greater than 12,5 degrees,\n"
  "# * - `127` if the confidence value is not available.\n"
  "# *\n"
  "# *\n"
  "# * @unit 0,1 degrees\n"
  "# * @category: GeoReference Information\n"
  "# * @revision: Created in V2.1.1\n"
  "#\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 1\n"
  "uint8 MAX = 127\n"
  "uint8 OUT_OF_RANGE = 126\n"
  "uint8 UNAVAILABLE = 127";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__TYPE_NAME, 45, 45},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2512, 2512},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__Wgs84AngleConfidence__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
