// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/WheelBaseVehicle.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/wheel_base_vehicle__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x92, 0x15, 0xa4, 0xdd, 0x6d, 0x83, 0x58, 0xe4,
      0x60, 0x7e, 0xaa, 0x4e, 0xe6, 0xda, 0x0b, 0x94,
      0x83, 0x62, 0xad, 0x61, 0x66, 0xa4, 0x20, 0xb8,
      0xe4, 0x3d, 0xc9, 0x5f, 0x1d, 0x2c, 0xcc, 0xe5,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/WheelBaseVehicle";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__TYPE_NAME, 41, 41},
      {etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# WheelBaseVehicle ::= INTEGER {\n"
  "#     outOfRange  (126),\n"
  "#     unavailable (127)\n"
  "# } (1..127)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates the perpendicular distance between front and rear axle of the wheel base of vehicle.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - `n` (`n >= 1` and `n < 126`) if the value is equal to or less than n x 0,1 metre  and more than (n-1) x 0,1 metre,\n"
  "# * - `126` indicates that the wheel base distance is equal to or greater than 12,5 metres,\n"
  "# * - `127` indicates that the information is unavailable.\n"
  "# *\n"
  "# * @unit 0,1 metre\n"
  "# * @category: Vehicle information\n"
  "# * @revision: Created in V2.1.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 1\n"
  "uint8 MAX = 127\n"
  "uint8 OUT_OF_RANGE = 126\n"
  "uint8 UNAVAILABLE = 127";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__TYPE_NAME, 41, 41},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2348, 2348},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__WheelBaseVehicle__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
