﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/AdverseWeatherConditionPrecipitationSubCauseCode.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/adverse_weather_condition_precipitation_sub_cause_code.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__ADVERSE_WEATHER_CONDITION_PRECIPITATION_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__ADVERSE_WEATHER_CONDITION_PRECIPITATION_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'HEAVY_RAIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode__HEAVY_RAIN = 1
};

/// Constant 'HEAVY_SNOWFALL'.
enum
{
  etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode__HEAVY_SNOWFALL = 2
};

/// Constant 'SOFT_HAIL'.
enum
{
  etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode__SOFT_HAIL = 3
};

/// Struct defined in msg/AdverseWeatherConditionPrecipitationSubCauseCode in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// AdverseWeatherCondition-PrecipitationSubCauseCode ::= INTEGER {
  ///     unavailable   (0),
  ///     heavyRain     (1),
  ///     heavySnowfall (2),
  ///     softHail      (3)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the value of the sub cause codes of the @ref CauseCode `adverseWeatherCondition-Precipitation`.
  /// *
  /// * The value shall be set to:
  /// * - 0 - `unavailable`   - in case information on the type of precipitation is unavailable,
  /// * - 1 - `heavyRain`     - in case the type of precipitation is heavy rain,
  /// * - 2 - `heavySnowfall` - in case the type of precipitation is heavy snow fall,
  /// * - 3 - `softHail`      - in case the type of precipitation is soft hail.
  /// * - 4-255               - are reserved for future usage
  /// *
  /// * @category: Traffic information
  /// * @revision: V1.3.1
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode.
typedef struct etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode__Sequence
{
  etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__AdverseWeatherConditionPrecipitationSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__ADVERSE_WEATHER_CONDITION_PRECIPITATION_SUB_CAUSE_CODE__STRUCT_H_
