// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/AngularAccelerationConfidence.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/angular_acceleration_confidence__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x6c, 0x86, 0x1e, 0x28, 0x64, 0x48, 0xeb, 0x18,
      0x72, 0xa8, 0xe7, 0x18, 0x53, 0xea, 0xc8, 0x6b,
      0xce, 0xbe, 0xbc, 0xe5, 0x24, 0xaf, 0x72, 0x8e,
      0x28, 0x96, 0x1f, 0xd5, 0x6d, 0x49, 0xad, 0x02,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/AngularAccelerationConfidence";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__TYPE_NAME, 54, 54},
      {etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# AngularAccelerationConfidence ::= ENUMERATED {\n"
  "#     degSecSquared-01 (0), \n"
  "#     degSecSquared-02 (1), \n"
  "#     degSecSquared-05 (2),  \n"
  "#     degSecSquared-10 (3), \n"
  "#     degSecSquared-20 (4),  \n"
  "#     degSecSquared-50 (5),  \n"
  "#     outOfRange       (6),     \n"
  "#     unavailable      (7)   \n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# * \n"
  "# * This DE indicates the angular acceleration confidence value which represents the estimated accuracy of an angular acceleration value with a default confidence level of 95 %.\n"
  "# * If required, the confidence level can be defined by the corresponding standards applying this DE.\n"
  "# * For correlation computation, maximum interval levels shall be assumed.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - 0 - `degSecSquared-01` - if the accuracy is equal to or less than 1 degree/second^2,\n"
  "# * - 1 - `degSecSquared-02` - if the accuracy is equal to or less than 2 degrees/second^2 and greater than 1 degree/second^2,\n"
  "# * - 2 - `degSecSquared-05` - if the accuracy is equal to or less than 5 degrees/second^2 and greater than 1 degree/second^2,\n"
  "# * - 3 - `degSecSquared-10` - if the accuracy is equal to or less than 10 degrees/second^2 and greater than 5 degrees/second^2,\n"
  "# * - 4 - `degSecSquared-20` - if the accuracy is equal to or less than 20 degrees/second^2 and greater than 10 degrees/second^2,\n"
  "# * - 5 - `degSecSquared-50` - if the accuracy is equal to or less than 50 degrees/second^2 and greater than 20 degrees/second^2,\n"
  "# * - 6 - `outOfRange`       - if the accuracy is out of range, i.e. greater than 50 degrees/second^2,\n"
  "# * - 7 - `unavailable`      - if the accuracy information is unavailable.\n"
  "# *\n"
  "# * @category: Kinematic information\n"
  "# * @revision: Created in V2.1.1\n"
  "#\n"
  "\n"
  "uint8 value\n"
  "uint8 DEG_SEC_SQUARED_01 = 0\n"
  "uint8 DEG_SEC_SQUARED_02 = 1\n"
  "uint8 DEG_SEC_SQUARED_05 = 2\n"
  "uint8 DEG_SEC_SQUARED_10 = 3\n"
  "uint8 DEG_SEC_SQUARED_20 = 4\n"
  "uint8 DEG_SEC_SQUARED_50 = 5\n"
  "uint8 OUT_OF_RANGE = 6\n"
  "uint8 UNAVAILABLE = 7\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__TYPE_NAME, 54, 54},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3557, 3557},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__AngularAccelerationConfidence__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
