// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/ClusterBreakupInfo.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/cluster_breakup_info.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_BREAKUP_INFO__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_BREAKUP_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'cluster_breakup_reason'
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_breakup_reason__struct.hpp"
// Member 'breakup_time'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_quarter_second__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterBreakupInfo __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterBreakupInfo __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClusterBreakupInfo_
{
  using Type = ClusterBreakupInfo_<ContainerAllocator>;

  explicit ClusterBreakupInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cluster_breakup_reason(_init),
    breakup_time(_init)
  {
    (void)_init;
  }

  explicit ClusterBreakupInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cluster_breakup_reason(_alloc, _init),
    breakup_time(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _cluster_breakup_reason_type =
    etsi_its_vam_ts_msgs::msg::ClusterBreakupReason_<ContainerAllocator>;
  _cluster_breakup_reason_type cluster_breakup_reason;
  using _breakup_time_type =
    etsi_its_vam_ts_msgs::msg::DeltaTimeQuarterSecond_<ContainerAllocator>;
  _breakup_time_type breakup_time;

  // setters for named parameter idiom
  Type & set__cluster_breakup_reason(
    const etsi_its_vam_ts_msgs::msg::ClusterBreakupReason_<ContainerAllocator> & _arg)
  {
    this->cluster_breakup_reason = _arg;
    return *this;
  }
  Type & set__breakup_time(
    const etsi_its_vam_ts_msgs::msg::DeltaTimeQuarterSecond_<ContainerAllocator> & _arg)
  {
    this->breakup_time = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterBreakupInfo
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterBreakupInfo
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClusterBreakupInfo_ & other) const
  {
    if (this->cluster_breakup_reason != other.cluster_breakup_reason) {
      return false;
    }
    if (this->breakup_time != other.breakup_time) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClusterBreakupInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClusterBreakupInfo_

// alias to use template instance with default allocator
using ClusterBreakupInfo =
  etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_BREAKUP_INFO__STRUCT_HPP_
