// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/ClusterBreakupReason.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/cluster_breakup_reason__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xab, 0x09, 0x44, 0x39, 0xf2, 0xb3, 0xbc, 0xf0,
      0xd1, 0x95, 0xfe, 0x61, 0xdb, 0xf7, 0xe8, 0x22,
      0xae, 0xad, 0xa3, 0x89, 0x04, 0x66, 0x3d, 0xce,
      0xd7, 0x40, 0x0c, 0x37, 0x46, 0x9e, 0x82, 0xcd,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/ClusterBreakupReason";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__TYPE_NAME, 45, 45},
      {etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# ClusterBreakupReason ::= ENUMERATED {\n"
  "#     notProvided                        (0),\n"
  "#     clusteringPurposeCompleted         (1),\n"
  "#     leaderMovedOutOfClusterBoundingBox (2),    \n"
  "#     joiningAnotherCluster              (3),\n"
  "#     enteringLowRiskAreaBasedOnMaps     (4),\n"
  "#     receptionOfCpmContainingCluster    (5),\n"
  "#     max(15)                                                                 \n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates the reason why a cluster leader intends to break up the cluster.\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0 - `notProvided`                          - if the information is not provided,\n"
  "# * - 1 - `clusteringPurposeCompleted`           - if the cluster purpose has been completed,\n"
  "# * - 2 - `leaderMovedOutOfClusterBoundingBox`   - if the leader moved out of the cluster's bounding box,\n"
  "# * - 3 - `joiningAnotherCluster`                - if the cluster leader is about to join another cluster,\n"
  "# * - 4 - `enteringLowRiskAreaBasedOnMaps`       - if the cluster is entering an area idenrified as low risk based on the use of maps,\n"
  "# * - 5 - `receptionOfCpmContainingCluster`      - if the leader received a Collective Perception Message containing information about the same cluster. \n"
  "# * - 6 to 15                                    - are reserved for future use.                                    \n"
  "# *\n"
  "# * @category: Cluster information\n"
  "# * @revision: Created in V2.1.1\n"
  "#\n"
  "\n"
  "uint8 value\n"
  "uint8 NOT_PROVIDED = 0\n"
  "uint8 CLUSTERING_PURPOSE_COMPLETED = 1\n"
  "uint8 LEADER_MOVED_OUT_OF_CLUSTER_BOUNDING_BOX = 2\n"
  "uint8 JOINING_ANOTHER_CLUSTER = 3\n"
  "uint8 ENTERING_LOW_RISK_AREA_BASED_ON_MAPS = 4\n"
  "uint8 RECEPTION_OF_CPM_CONTAINING_CLUSTER = 5\n"
  "uint8 MAX = 15\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__TYPE_NAME, 45, 45},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3320, 3320},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__ClusterBreakupReason__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
