// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/ClusterLeaveReason.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/cluster_leave_reason.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_LEAVE_REASON__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_LEAVE_REASON__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterLeaveReason __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterLeaveReason __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClusterLeaveReason_
{
  using Type = ClusterLeaveReason_<ContainerAllocator>;

  explicit ClusterLeaveReason_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit ClusterLeaveReason_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t NOT_PROVIDED =
    0u;
  static constexpr uint8_t CLUSTER_LEADER_LOST =
    1u;
  static constexpr uint8_t CLUSTER_DISBANDED_BY_LEADER =
    2u;
  static constexpr uint8_t OUT_OF_CLUSTER_BOUNDING_BOX =
    3u;
  static constexpr uint8_t OUT_OF_CLUSTER_SPEED_RANGE =
    4u;
  static constexpr uint8_t JOINING_ANOTHER_CLUSTER =
    5u;
  static constexpr uint8_t CANCELLED_JOIN =
    6u;
  static constexpr uint8_t FAILED_JOIN =
    7u;
  static constexpr uint8_t SAFETY_CONDITION =
    8u;
  static constexpr uint8_t MAX =
    15u;

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterLeaveReason
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterLeaveReason
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClusterLeaveReason_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClusterLeaveReason_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClusterLeaveReason_

// alias to use template instance with default allocator
using ClusterLeaveReason =
  etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ClusterLeaveReason_<ContainerAllocator>::NOT_PROVIDED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ClusterLeaveReason_<ContainerAllocator>::CLUSTER_LEADER_LOST;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ClusterLeaveReason_<ContainerAllocator>::CLUSTER_DISBANDED_BY_LEADER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ClusterLeaveReason_<ContainerAllocator>::OUT_OF_CLUSTER_BOUNDING_BOX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ClusterLeaveReason_<ContainerAllocator>::OUT_OF_CLUSTER_SPEED_RANGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ClusterLeaveReason_<ContainerAllocator>::JOINING_ANOTHER_CLUSTER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ClusterLeaveReason_<ContainerAllocator>::CANCELLED_JOIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ClusterLeaveReason_<ContainerAllocator>::FAILED_JOIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ClusterLeaveReason_<ContainerAllocator>::SAFETY_CONDITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ClusterLeaveReason_<ContainerAllocator>::MAX;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_LEAVE_REASON__STRUCT_HPP_
