﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/Curvature.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/curvature.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CURVATURE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CURVATURE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'curvature_value'
#include "etsi_its_vam_ts_msgs/msg/detail/curvature_value__struct.h"
// Member 'curvature_confidence'
#include "etsi_its_vam_ts_msgs/msg/detail/curvature_confidence__struct.h"

/// Struct defined in msg/Curvature in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__Curvature
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// Curvature ::= SEQUENCE {
  ///     curvatureValue         CurvatureValue,
  ///     curvatureConfidence    CurvatureConfidence
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF represents the curvature of the vehicle trajectory and the associated confidence value.
  /// * The curvature detected by a vehicle represents the curvature of actual vehicle trajectory.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field curvatureValue: Detected curvature of the vehicle trajectory.
  /// *
  /// * @field curvatureConfidence: along with a confidence value of the curvature value with a predefined confidence level.
  /// *
  /// * @category: Vehicle information
  /// * @revision: Description revised in V2.1.1
  etsi_its_vam_ts_msgs__msg__CurvatureValue curvature_value;
  etsi_its_vam_ts_msgs__msg__CurvatureConfidence curvature_confidence;
} etsi_its_vam_ts_msgs__msg__Curvature;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__Curvature.
typedef struct etsi_its_vam_ts_msgs__msg__Curvature__Sequence
{
  etsi_its_vam_ts_msgs__msg__Curvature * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__Curvature__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CURVATURE__STRUCT_H_
