// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/CurvatureConfidence.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/curvature_confidence__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__CurvatureConfidence__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x53, 0x37, 0x8b, 0x67, 0x9e, 0xf1, 0x27, 0xb9,
      0x41, 0x6c, 0x07, 0x87, 0x16, 0x04, 0xe8, 0x2f,
      0x65, 0x8a, 0xfc, 0x96, 0x98, 0xf8, 0xe2, 0x48,
      0x04, 0x37, 0xf8, 0xca, 0xa8, 0xdf, 0x43, 0x10,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__CurvatureConfidence__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/CurvatureConfidence";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__CurvatureConfidence__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__CurvatureConfidence__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__CurvatureConfidence__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__CurvatureConfidence__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__CurvatureConfidence__TYPE_NAME, 44, 44},
      {etsi_its_vam_ts_msgs__msg__CurvatureConfidence__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# CurvatureConfidence ::= ENUMERATED {\n"
  "#     onePerMeter-0-00002 (0),\n"
  "#     onePerMeter-0-0001  (1),\n"
  "#     onePerMeter-0-0005  (2),\n"
  "#     onePerMeter-0-002   (3),\n"
  "#     onePerMeter-0-01    (4),\n"
  "#     onePerMeter-0-1     (5),\n"
  "#     outOfRange          (6),\n"
  "#     unavailable         (7)\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy range of a curvature value with a confidence level of 95 %.\n"
  "# * If required, the confidence level can be defined by the corresponding standards applying this DE.\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0 - `onePerMeter-0-00002` - if the confidence value is less than or equal to 0,00002 m-1,\n"
  "# * - 1 - `onePerMeter-0-0001`  - if the confidence value is less than or equal to 0,0001 m-1 and greater than 0,00002 m-1,\n"
  "# * - 2 - `onePerMeter-0-0005`  - if the confidence value is less than or equal to 0,0005 m-1 and greater than 0,0001 m-1,\n"
  "# * - 3 - `onePerMeter-0-002`   - if the confidence value is less than or equal to 0,002 m-1 and greater than 0,0005 m-1,\n"
  "# * - 4 - `nePerMeter-0-01`     - if the confidence value is less than or equal to 0,01 m-1 and greater than 0,002 m-1,\n"
  "# * - 5 - `nePerMeter-0-1`      - if the confidence value is less than or equal to 0,1 m-1  and greater than 0,01 m-1,\n"
  "# * - 6 - `outOfRange`          - if the confidence value is out of range, i.e. greater than 0,1 m-1,\n"
  "# * - 7 - `unavailable`         - if the confidence value is not available.\n"
  "# * \n"
  "# * @note:\\tThe fact that a curvature value is received with confidence value set to `unavailable(7)` can be caused by\n"
  "# * several reasons, such as:\n"
  "# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,\n"
  "# * - the sensor cannot calculate the accuracy due to lack of variables, or\n"
  "# * - there has been a vehicle bus (e.g. CAN bus) error.\n"
  "# * In all 3 cases above, the curvature value may be valid and used by the application.\n"
  "# * \n"
  "# * @note: If a curvature value is received and its confidence value is set to `outOfRange(6)`, it means that the curvature value is not valid \n"
  "# * and therefore cannot be trusted. Such value is not useful for the application.\n"
  "# * \n"
  "# * @category: Vehicle information\n"
  "# * @revision: Description revised in V2.1.1\n"
  "#\n"
  "\n"
  "uint8 value\n"
  "uint8 ONE_PER_METER_0_00002 = 0\n"
  "uint8 ONE_PER_METER_0_0001 = 1\n"
  "uint8 ONE_PER_METER_0_0005 = 2\n"
  "uint8 ONE_PER_METER_0_002 = 3\n"
  "uint8 ONE_PER_METER_0_01 = 4\n"
  "uint8 ONE_PER_METER_0_1 = 5\n"
  "uint8 OUT_OF_RANGE = 6\n"
  "uint8 UNAVAILABLE = 7\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__CurvatureConfidence__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__CurvatureConfidence__TYPE_NAME, 44, 44},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 4169, 4169},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__CurvatureConfidence__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__CurvatureConfidence__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
