// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/CurvatureValue.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/curvature_value__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__CurvatureValue__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xc6, 0x1c, 0xb3, 0x5c, 0x8d, 0xd5, 0xd2, 0x3e,
      0x39, 0x3e, 0x31, 0xdf, 0x6e, 0x80, 0x85, 0x54,
      0x49, 0x68, 0xae, 0xc2, 0x52, 0x1c, 0x39, 0x76,
      0xbd, 0x30, 0xa8, 0xb5, 0x06, 0xf4, 0xf1, 0x6d,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__CurvatureValue__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/CurvatureValue";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__CurvatureValue__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__CurvatureValue__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__CurvatureValue__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__CurvatureValue__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__CurvatureValue__TYPE_NAME, 39, 39},
      {etsi_its_vam_ts_msgs__msg__CurvatureValue__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# CurvatureValue ::= INTEGER {\n"
  "#     outOfRangeNegative (-1023),\n"
  "#     straight           (0),\n"
  "#     outOfRangePositive (1022), \n"
  "#     unavailable        (1023)\n"
  "# } (-1023..1023)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE describes vehicle turning curve with the following information:\n"
  "# * ```\n"
  "# *     Value = 1 / Radius * 10000\n"
  "# * ```\n"
  "# * wherein radius is the vehicle turning curve radius in metres. \n"
  "# * \n"
  "# * Positive values indicate a turning curve to the left hand side of the driver.\n"
  "# * It corresponds to the vehicle coordinate system as defined in ISO 8855 [21].\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - `-1023` for  values smaller than -1023,\n"
  "# * - `n` (`n > -1023` and `n < 0`) for negative values equal to or less than `n`, and greater than `(n-1)`,\n"
  "# * - `0` when the vehicle is moving straight,\n"
  "# * - `n` (`n > 0` and `n < 1022`) for positive values equal to or less than `n`, and greater than `(n-1)`,\n"
  "# * - `1022`, for values  greater than 1021,\n"
  "# * - `1023`, if the information is not available.\n"
  "# * \n"
  "# * @note: The present DE is limited to vehicle types as defined in ISO 8855 [21].\n"
  "# * \n"
  "# * @unit: 1 over 10 000 metres\n"
  "# * @category: Vehicle information\n"
  "# * @revision: description revised in V2.1.1 (the definition of value 1022 has changed slightly)\n"
  "# \n"
  "\n"
  "int16 value\n"
  "int16 MIN = -1023\n"
  "int16 MAX = 1023\n"
  "int16 OUT_OF_RANGE_NEGATIVE = -1023\n"
  "int16 STRAIGHT = 0\n"
  "int16 OUT_OF_RANGE_POSITIVE = 1022\n"
  "int16 UNAVAILABLE = 1023";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__CurvatureValue__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__CurvatureValue__TYPE_NAME, 39, 39},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3057, 3057},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__CurvatureValue__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__CurvatureValue__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
