﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/DeltaTimeMilliSecondPositive.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/delta_time_milli_second_positive.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__DELTA_TIME_MILLI_SECOND_POSITIVE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__DELTA_TIME_MILLI_SECOND_POSITIVE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__DeltaTimeMilliSecondPositive__MIN = 1
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__DeltaTimeMilliSecondPositive__MAX = 10000
};

/// Struct defined in msg/DeltaTimeMilliSecondPositive in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__DeltaTimeMilliSecondPositive
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// DeltaTimeMilliSecondPositive ::= INTEGER (1..10000)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents a difference in time with respect to a reference time.
  /// *
  /// * The value shall be set to:
  /// * - `n` (`n > 0` and `n < 10001`) to indicate a time value equal to or less than n x 0,001 s, and greater than (n-1) x 0,001 s,
  /// *
  /// * Example: a time interval between two consecutive message transmissions.
  /// *
  /// * @unit: 0,001 s
  /// * @category: Basic information
  /// * @revision: Created in V2.1.1 from the DE TransmissionInterval in
  uint16_t value;
} etsi_its_vam_ts_msgs__msg__DeltaTimeMilliSecondPositive;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__DeltaTimeMilliSecondPositive.
typedef struct etsi_its_vam_ts_msgs__msg__DeltaTimeMilliSecondPositive__Sequence
{
  etsi_its_vam_ts_msgs__msg__DeltaTimeMilliSecondPositive * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__DeltaTimeMilliSecondPositive__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__DELTA_TIME_MILLI_SECOND_POSITIVE__STRUCT_H_
