﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/EuVehicleCategoryCode.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/eu_vehicle_category_code.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__EU_VEHICLE_CATEGORY_CODE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__EU_VEHICLE_CATEGORY_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'CHOICE_EU_VEHICLE_CATEGORY_L'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode__CHOICE_EU_VEHICLE_CATEGORY_L = 0
};

/// Constant 'CHOICE_EU_VEHICLE_CATEGORY_M'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode__CHOICE_EU_VEHICLE_CATEGORY_M = 1
};

/// Constant 'CHOICE_EU_VEHICLE_CATEGORY_N'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode__CHOICE_EU_VEHICLE_CATEGORY_N = 2
};

/// Constant 'CHOICE_EU_VEHICLE_CATEGORY_O'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode__CHOICE_EU_VEHICLE_CATEGORY_O = 3
};

/// Constant 'CHOICE_EU_VEHICLE_CATEGORY_T'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode__CHOICE_EU_VEHICLE_CATEGORY_T = 4
};

/// Constant 'CHOICE_EU_VEHICLE_CATEGORY_G'.
enum
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode__CHOICE_EU_VEHICLE_CATEGORY_G = 5
};

// Include directives for member types
// Member 'eu_vehicle_category_l'
#include "etsi_its_vam_ts_msgs/msg/detail/eu_vehicle_category_l__struct.h"
// Member 'eu_vehicle_category_m'
#include "etsi_its_vam_ts_msgs/msg/detail/eu_vehicle_category_m__struct.h"
// Member 'eu_vehicle_category_n'
#include "etsi_its_vam_ts_msgs/msg/detail/eu_vehicle_category_n__struct.h"
// Member 'eu_vehicle_category_o'
#include "etsi_its_vam_ts_msgs/msg/detail/eu_vehicle_category_o__struct.h"

/// Struct defined in msg/EuVehicleCategoryCode in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// EuVehicleCategoryCode ::= CHOICE {
  ///  euVehicleCategoryL    EuVehicleCategoryL,
  ///  euVehicleCategoryM    EuVehicleCategoryM,
  ///  euVehicleCategoryN    EuVehicleCategoryN,
  ///  euVehicleCategoryO    EuVehicleCategoryO,
  ///  euVehicleCategoryT    NULL,
  ///  euVehicleCategoryG    NULL
  ///  }
  /// ------------------------------------------------------------------------------
  /// *
  /// *
  /// * This DF represents a vehicle category according to the UNECE/TRANS/WP.29/78/Rev.4.
  /// * The following options are available:
  /// *
  /// * @field euVehicleCategoryL: indicates a vehicle in the L category.
  /// *
  /// * @field euVehicleCategoryM: indicates a vehicle in the M category.
  /// *
  /// * @field euVehicleCategoryN: indicates a vehicle in the N category.
  /// *
  /// * @field euVehicleCategoryO: indicates a vehicle in the O category.
  /// *
  /// * @field euVehicleCategoryT: indicates a vehicle in the T category.
  /// *
  /// * @field euVehicleCategoryG: indicates a vehicle in the G category.
  /// *
  /// * @category: Vehicle information
  /// * @revision: Created in V2.1.1
  uint8_t choice;
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryL eu_vehicle_category_l;
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryM eu_vehicle_category_m;
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryN eu_vehicle_category_n;
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryO eu_vehicle_category_o;
  uint8_t eu_vehicle_category_t;
  uint8_t eu_vehicle_category_g;
} etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode.
typedef struct etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode__Sequence
{
  etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__EuVehicleCategoryCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__EU_VEHICLE_CATEGORY_CODE__STRUCT_H_
