﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/GeneralizedLanePosition.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/generalized_lane_position.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'CHOICE_TRAFFIC_LANE_POSITION'.
enum
{
  etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__CHOICE_TRAFFIC_LANE_POSITION = 0
};

/// Constant 'CHOICE_NON_TRAFFIC_LANE_POSITION'.
enum
{
  etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__CHOICE_NON_TRAFFIC_LANE_POSITION = 1
};

/// Constant 'CHOICE_TRAFFIC_ISLAND_POSITION'.
enum
{
  etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__CHOICE_TRAFFIC_ISLAND_POSITION = 2
};

/// Constant 'CHOICE_MAP_POSITION'.
enum
{
  etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__CHOICE_MAP_POSITION = 3
};

// Include directives for member types
// Member 'traffic_lane_position'
#include "etsi_its_vam_ts_msgs/msg/detail/lane_position__struct.h"
// Member 'non_traffic_lane_position'
#include "etsi_its_vam_ts_msgs/msg/detail/lane_position_and_type__struct.h"
// Member 'traffic_island_position'
#include "etsi_its_vam_ts_msgs/msg/detail/traffic_island_position__struct.h"
// Member 'map_position'
#include "etsi_its_vam_ts_msgs/msg/detail/map_position__struct.h"

/// Struct defined in msg/GeneralizedLanePosition in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// GeneralizedLanePosition::= CHOICE {
  ///     trafficLanePosition       LanePosition,
  ///     nonTrafficLanePosition    LanePositionAndType,
  ///     trafficIslandPosition     TrafficIslandPosition,
  ///     mapPosition               MapPosition,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF indicates a transversal position in relation to the different lanes of the road.
  /// * It is an extension of DE_LanePosition to cover locations (sidewalks, bicycle paths), where Vehicle ITS-S would normally not be present.
  /// *
  /// * The following options are available:
  /// *
  /// * @field trafficLanePosition: a position on a traffic lane.
  /// *
  /// * @field nonTrafficLanePosition: a position on a lane which is not a traffic lane.
  /// *
  /// * @field trafficIslandPosition: a position on a traffic island
  /// *
  /// * @field mapPosition: a position on a lane identified in a MAPEM.
  /// *
  /// * @category: Road Topology information
  /// * @revision: created in V2.1.1
  uint8_t choice;
  etsi_its_vam_ts_msgs__msg__LanePosition traffic_lane_position;
  etsi_its_vam_ts_msgs__msg__LanePositionAndType non_traffic_lane_position;
  etsi_its_vam_ts_msgs__msg__TrafficIslandPosition traffic_island_position;
  etsi_its_vam_ts_msgs__msg__MapPosition map_position;
} etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition.
typedef struct etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence
{
  etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_H_
