// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/HeadingValue.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/heading_value__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__HeadingValue__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x65, 0xbb, 0x8b, 0xaf, 0x7d, 0x02, 0x0b, 0xa7,
      0xd1, 0x21, 0x75, 0x02, 0xb7, 0x50, 0xa7, 0x82,
      0xd3, 0x7a, 0x85, 0x39, 0xac, 0x0c, 0xc3, 0x47,
      0x87, 0xac, 0x81, 0x82, 0x92, 0x24, 0x09, 0xbc,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__HeadingValue__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/HeadingValue";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__HeadingValue__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__HeadingValue__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__HeadingValue__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__HeadingValue__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__HeadingValue__TYPE_NAME, 37, 37},
      {etsi_its_vam_ts_msgs__msg__HeadingValue__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# HeadingValue ::= INTEGER { \n"
  "#     wgs84North  (0),\n"
  "#     wgs84East   (900),\n"
  "#     wgs84South  (1800),\n"
  "#     wgs84West   (2700),\n"
  "#     doNotUse    (3600),\n"
  "#     unavailable (3601)\n"
  "# } (0..3601)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.\n"
  "# * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.\n"
  "# *\n"
  "# * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead. \n"
  "# *\n"
  "# * Unit: 0,1 degree\n"
  "# * Categories: GeoReference information\n"
  "# * @revision: Description revised in V2.1.1 (usage of value 3600 specified) \n"
  "#\n"
  "\n"
  "uint16 value\n"
  "uint16 MIN = 0\n"
  "uint16 MAX = 3601\n"
  "uint16 WGS84_NORTH = 0\n"
  "uint16 WGS84_EAST = 900\n"
  "uint16 WGS84_SOUTH = 1800\n"
  "uint16 WGS84_WEST = 2700\n"
  "uint16 DO_NOT_USE = 3600\n"
  "uint16 UNAVAILABLE = 3601";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__HeadingValue__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__HeadingValue__TYPE_NAME, 37, 37},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2535, 2535},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__HeadingValue__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__HeadingValue__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
