﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/HumanPresenceOnTheRoadSubCauseCode.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/human_presence_on_the_road_sub_cause_code.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__HUMAN_PRESENCE_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__HUMAN_PRESENCE_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode__MAX = 255
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode__UNAVAILABLE = 0
};

/// Constant 'CHILDREN_ON_ROADWAY'.
enum
{
  etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode__CHILDREN_ON_ROADWAY = 1
};

/// Constant 'CYCLIST_ON_ROADWAY'.
enum
{
  etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode__CYCLIST_ON_ROADWAY = 2
};

/// Constant 'MOTORCYCLIST_ON_ROADWAY'.
enum
{
  etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode__MOTORCYCLIST_ON_ROADWAY = 3
};

/// Struct defined in msg/HumanPresenceOnTheRoadSubCauseCode in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// HumanPresenceOnTheRoadSubCauseCode ::= INTEGER {
  ///     unavailable           (0),
  ///     childrenOnRoadway     (1),
  ///     cyclistOnRoadway      (2),
  ///     motorcyclistOnRoadway (3)
  /// } (0..255)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the value of the sub cause code of the @ref CauseCode `humanPresenceOnTheRoad`.
  /// *
  /// * The value shall be set to:
  /// * - 0 - `unavailable`          - in case further detailed information on human presence on the road is unavailable,
  /// * - 1 - `childrenOnRoadway`    - in case children are detected on the road,
  /// * - 2 - `cyclistOnRoadway`     - in case cyclist presence is detected on the road,
  /// * - 3 - `motorcyclistOnRoadway`- in case motorcyclist presence is detected on the road.
  /// * - 4-255                      - are reserved for future usage.
  /// *
  /// * @category: Traffic information
  /// * @revision: editorial revision in V2.1.1
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode.
typedef struct etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode__Sequence
{
  etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__HumanPresenceOnTheRoadSubCauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__HUMAN_PRESENCE_ON_THE_ROAD_SUB_CAUSE_CODE__STRUCT_H_
