// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/InterferenceManagementChannel.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_channel__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xba, 0xe8, 0x6b, 0x5d, 0xd2, 0x69, 0xb9, 0xf4,
      0x09, 0x27, 0x84, 0x61, 0x68, 0x72, 0x0a, 0x61,
      0x22, 0x02, 0xed, 0x74, 0xde, 0x64, 0x8e, 0x75,
      0x65, 0x14, 0x87, 0xce, 0x83, 0xed, 0xe0, 0x99,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/InterferenceManagementChannel";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__FIELD_NAME__centre_frequency[] = "centre_frequency";
static char etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__FIELD_NAME__channel_width[] = "channel_width";
static char etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__FIELD_NAME__exponent[] = "exponent";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__FIELD_NAME__centre_frequency, 16, 16},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT32,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__FIELD_NAME__channel_width, 13, 13},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__FIELD_NAME__exponent, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__TYPE_NAME, 54, 54},
      {etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__FIELDS, 3, 3},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# InterferenceManagementChannel ::= SEQUENCE {\n"
  "#     centreFrequency    INTEGER (1 .. 99999),\n"
  "#     channelWidth       INTEGER (0 .. 9999),\n"
  "#     exponent           INTEGER (0 .. 15) \n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DF represents a frequency channel \n"
  "# *\n"
  "# * It shall include the following components: \n"
  "# *\n"
  "# * @field centreFrequency: the centre frequency of the channel in 10^(exp+2) Hz (where exp is exponent)\n"
  "# * \n"
  "# * @field channelWidth: width of the channel in 10^exp Hz (where exp is exponent)\n"
  "# *\n"
  "# * @field exponent: exponent of the power of 10 used in the calculation of the components above.\n"
  "# *\n"
  "# * @category: Communication information\n"
  "# * @revision: created in V2.1.1\n"
  "#\n"
  "\n"
  "uint32 centre_frequency\n"
  "uint32 CENTRE_FREQUENCY_MIN = 1\n"
  "uint32 CENTRE_FREQUENCY_MAX = 99999\n"
  "\n"
  "uint16 channel_width\n"
  "uint16 CHANNEL_WIDTH_MIN = 0\n"
  "uint16 CHANNEL_WIDTH_MAX = 9999\n"
  "\n"
  "uint8 exponent\n"
  "uint8 EXPONENT_MIN = 0\n"
  "uint8 EXPONENT_MAX = 15\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__TYPE_NAME, 54, 54},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2555, 2555},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
