// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/InterferenceManagementChannel.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/interference_management_channel.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_CHANNEL__TRAITS_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_CHANNEL__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_channel__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const InterferenceManagementChannel & msg,
  std::ostream & out)
{
  out << "{";
  // member: centre_frequency
  {
    out << "centre_frequency: ";
    rosidl_generator_traits::value_to_yaml(msg.centre_frequency, out);
    out << ", ";
  }

  // member: channel_width
  {
    out << "channel_width: ";
    rosidl_generator_traits::value_to_yaml(msg.channel_width, out);
    out << ", ";
  }

  // member: exponent
  {
    out << "exponent: ";
    rosidl_generator_traits::value_to_yaml(msg.exponent, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const InterferenceManagementChannel & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: centre_frequency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "centre_frequency: ";
    rosidl_generator_traits::value_to_yaml(msg.centre_frequency, out);
    out << "\n";
  }

  // member: channel_width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "channel_width: ";
    rosidl_generator_traits::value_to_yaml(msg.channel_width, out);
    out << "\n";
  }

  // member: exponent
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "exponent: ";
    rosidl_generator_traits::value_to_yaml(msg.exponent, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const InterferenceManagementChannel & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_vam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel & msg)
{
  return etsi_its_vam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel>()
{
  return "etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel";
}

template<>
inline const char * name<etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel>()
{
  return "etsi_its_vam_ts_msgs/msg/InterferenceManagementChannel";
}

template<>
struct has_fixed_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_CHANNEL__TRAITS_HPP_
