// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/InterferenceManagementInfoPerChannel.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/interference_management_info_per_channel.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_INFO_PER_CHANNEL__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_INFO_PER_CHANNEL__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'interference_management_channel'
#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_channel__struct.hpp"
// Member 'interference_management_zone_type'
#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_zone_type__struct.hpp"
// Member 'interference_management_mitigation_type'
#include "etsi_its_vam_ts_msgs/msg/detail/mitigation_for_technologies__struct.hpp"
// Member 'expiry_time'
#include "etsi_its_vam_ts_msgs/msg/detail/timestamp_its__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__InterferenceManagementInfoPerChannel __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__InterferenceManagementInfoPerChannel __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct InterferenceManagementInfoPerChannel_
{
  using Type = InterferenceManagementInfoPerChannel_<ContainerAllocator>;

  explicit InterferenceManagementInfoPerChannel_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : interference_management_channel(_init),
    interference_management_zone_type(_init),
    interference_management_mitigation_type(_init),
    expiry_time(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->interference_management_mitigation_type_is_present = false;
      this->expiry_time_is_present = false;
    }
  }

  explicit InterferenceManagementInfoPerChannel_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : interference_management_channel(_alloc, _init),
    interference_management_zone_type(_alloc, _init),
    interference_management_mitigation_type(_alloc, _init),
    expiry_time(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->interference_management_mitigation_type_is_present = false;
      this->expiry_time_is_present = false;
    }
  }

  // field types and members
  using _interference_management_channel_type =
    etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator>;
  _interference_management_channel_type interference_management_channel;
  using _interference_management_zone_type_type =
    etsi_its_vam_ts_msgs::msg::InterferenceManagementZoneType_<ContainerAllocator>;
  _interference_management_zone_type_type interference_management_zone_type;
  using _interference_management_mitigation_type_type =
    etsi_its_vam_ts_msgs::msg::MitigationForTechnologies_<ContainerAllocator>;
  _interference_management_mitigation_type_type interference_management_mitigation_type;
  using _interference_management_mitigation_type_is_present_type =
    bool;
  _interference_management_mitigation_type_is_present_type interference_management_mitigation_type_is_present;
  using _expiry_time_type =
    etsi_its_vam_ts_msgs::msg::TimestampIts_<ContainerAllocator>;
  _expiry_time_type expiry_time;
  using _expiry_time_is_present_type =
    bool;
  _expiry_time_is_present_type expiry_time_is_present;

  // setters for named parameter idiom
  Type & set__interference_management_channel(
    const etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel_<ContainerAllocator> & _arg)
  {
    this->interference_management_channel = _arg;
    return *this;
  }
  Type & set__interference_management_zone_type(
    const etsi_its_vam_ts_msgs::msg::InterferenceManagementZoneType_<ContainerAllocator> & _arg)
  {
    this->interference_management_zone_type = _arg;
    return *this;
  }
  Type & set__interference_management_mitigation_type(
    const etsi_its_vam_ts_msgs::msg::MitigationForTechnologies_<ContainerAllocator> & _arg)
  {
    this->interference_management_mitigation_type = _arg;
    return *this;
  }
  Type & set__interference_management_mitigation_type_is_present(
    const bool & _arg)
  {
    this->interference_management_mitigation_type_is_present = _arg;
    return *this;
  }
  Type & set__expiry_time(
    const etsi_its_vam_ts_msgs::msg::TimestampIts_<ContainerAllocator> & _arg)
  {
    this->expiry_time = _arg;
    return *this;
  }
  Type & set__expiry_time_is_present(
    const bool & _arg)
  {
    this->expiry_time_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__InterferenceManagementInfoPerChannel
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__InterferenceManagementInfoPerChannel
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const InterferenceManagementInfoPerChannel_ & other) const
  {
    if (this->interference_management_channel != other.interference_management_channel) {
      return false;
    }
    if (this->interference_management_zone_type != other.interference_management_zone_type) {
      return false;
    }
    if (this->interference_management_mitigation_type != other.interference_management_mitigation_type) {
      return false;
    }
    if (this->interference_management_mitigation_type_is_present != other.interference_management_mitigation_type_is_present) {
      return false;
    }
    if (this->expiry_time != other.expiry_time) {
      return false;
    }
    if (this->expiry_time_is_present != other.expiry_time_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const InterferenceManagementInfoPerChannel_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct InterferenceManagementInfoPerChannel_

// alias to use template instance with default allocator
using InterferenceManagementInfoPerChannel =
  etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_INFO_PER_CHANNEL__STRUCT_HPP_
