// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/InterferenceManagementInfoPerChannel.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/interference_management_info_per_channel.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_INFO_PER_CHANNEL__TRAITS_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_INFO_PER_CHANNEL__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_info_per_channel__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'interference_management_channel'
#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_channel__traits.hpp"
// Member 'interference_management_zone_type'
#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_zone_type__traits.hpp"
// Member 'interference_management_mitigation_type'
#include "etsi_its_vam_ts_msgs/msg/detail/mitigation_for_technologies__traits.hpp"
// Member 'expiry_time'
#include "etsi_its_vam_ts_msgs/msg/detail/timestamp_its__traits.hpp"

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const InterferenceManagementInfoPerChannel & msg,
  std::ostream & out)
{
  out << "{";
  // member: interference_management_channel
  {
    out << "interference_management_channel: ";
    to_flow_style_yaml(msg.interference_management_channel, out);
    out << ", ";
  }

  // member: interference_management_zone_type
  {
    out << "interference_management_zone_type: ";
    to_flow_style_yaml(msg.interference_management_zone_type, out);
    out << ", ";
  }

  // member: interference_management_mitigation_type
  {
    out << "interference_management_mitigation_type: ";
    to_flow_style_yaml(msg.interference_management_mitigation_type, out);
    out << ", ";
  }

  // member: interference_management_mitigation_type_is_present
  {
    out << "interference_management_mitigation_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.interference_management_mitigation_type_is_present, out);
    out << ", ";
  }

  // member: expiry_time
  {
    out << "expiry_time: ";
    to_flow_style_yaml(msg.expiry_time, out);
    out << ", ";
  }

  // member: expiry_time_is_present
  {
    out << "expiry_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.expiry_time_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const InterferenceManagementInfoPerChannel & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: interference_management_channel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interference_management_channel:\n";
    to_block_style_yaml(msg.interference_management_channel, out, indentation + 2);
  }

  // member: interference_management_zone_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interference_management_zone_type:\n";
    to_block_style_yaml(msg.interference_management_zone_type, out, indentation + 2);
  }

  // member: interference_management_mitigation_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interference_management_mitigation_type:\n";
    to_block_style_yaml(msg.interference_management_mitigation_type, out, indentation + 2);
  }

  // member: interference_management_mitigation_type_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interference_management_mitigation_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.interference_management_mitigation_type_is_present, out);
    out << "\n";
  }

  // member: expiry_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "expiry_time:\n";
    to_block_style_yaml(msg.expiry_time, out, indentation + 2);
  }

  // member: expiry_time_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "expiry_time_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.expiry_time_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const InterferenceManagementInfoPerChannel & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_vam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel & msg)
{
  return etsi_its_vam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel>()
{
  return "etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel";
}

template<>
inline const char * name<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel>()
{
  return "etsi_its_vam_ts_msgs/msg/InterferenceManagementInfoPerChannel";
}

template<>
struct has_fixed_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel>
  : std::integral_constant<bool, has_fixed_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementZoneType>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::MitigationForTechnologies>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::TimestampIts>::value> {};

template<>
struct has_bounded_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel>
  : std::integral_constant<bool, has_bounded_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementChannel>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementZoneType>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::MitigationForTechnologies>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::TimestampIts>::value> {};

template<>
struct is_message<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfoPerChannel>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_INFO_PER_CHANNEL__TRAITS_HPP_
