// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/InterferenceManagementZone.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/interference_management_zone.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'zone_definition'
#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_zone_definition__struct.hpp"
// Member 'management_info'
#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__InterferenceManagementZone __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__InterferenceManagementZone __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct InterferenceManagementZone_
{
  using Type = InterferenceManagementZone_<ContainerAllocator>;

  explicit InterferenceManagementZone_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : zone_definition(_init),
    management_info(_init)
  {
    (void)_init;
  }

  explicit InterferenceManagementZone_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : zone_definition(_alloc, _init),
    management_info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _zone_definition_type =
    etsi_its_vam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator>;
  _zone_definition_type zone_definition;
  using _management_info_type =
    etsi_its_vam_ts_msgs::msg::InterferenceManagementInfo_<ContainerAllocator>;
  _management_info_type management_info;

  // setters for named parameter idiom
  Type & set__zone_definition(
    const etsi_its_vam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator> & _arg)
  {
    this->zone_definition = _arg;
    return *this;
  }
  Type & set__management_info(
    const etsi_its_vam_ts_msgs::msg::InterferenceManagementInfo_<ContainerAllocator> & _arg)
  {
    this->management_info = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__InterferenceManagementZone
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__InterferenceManagementZone
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const InterferenceManagementZone_ & other) const
  {
    if (this->zone_definition != other.zone_definition) {
      return false;
    }
    if (this->management_info != other.management_info) {
      return false;
    }
    return true;
  }
  bool operator!=(const InterferenceManagementZone_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct InterferenceManagementZone_

// alias to use template instance with default allocator
using InterferenceManagementZone =
  etsi_its_vam_ts_msgs::msg::InterferenceManagementZone_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE__STRUCT_HPP_
