// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/InterferenceManagementZone.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/interference_management_zone.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE__TRAITS_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_zone__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'zone_definition'
#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_zone_definition__traits.hpp"
// Member 'management_info'
#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_info__traits.hpp"

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const InterferenceManagementZone & msg,
  std::ostream & out)
{
  out << "{";
  // member: zone_definition
  {
    out << "zone_definition: ";
    to_flow_style_yaml(msg.zone_definition, out);
    out << ", ";
  }

  // member: management_info
  {
    out << "management_info: ";
    to_flow_style_yaml(msg.management_info, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const InterferenceManagementZone & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: zone_definition
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "zone_definition:\n";
    to_block_style_yaml(msg.zone_definition, out, indentation + 2);
  }

  // member: management_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "management_info:\n";
    to_block_style_yaml(msg.management_info, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const InterferenceManagementZone & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_vam_ts_msgs::msg::InterferenceManagementZone & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_vam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_vam_ts_msgs::msg::InterferenceManagementZone & msg)
{
  return etsi_its_vam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone>()
{
  return "etsi_its_vam_ts_msgs::msg::InterferenceManagementZone";
}

template<>
inline const char * name<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone>()
{
  return "etsi_its_vam_ts_msgs/msg/InterferenceManagementZone";
}

template<>
struct has_fixed_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone>
  : std::integral_constant<bool, has_fixed_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfo>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementZoneDefinition>::value> {};

template<>
struct has_bounded_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone>
  : std::integral_constant<bool, has_bounded_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementInfo>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::InterferenceManagementZoneDefinition>::value> {};

template<>
struct is_message<etsi_its_vam_ts_msgs::msg::InterferenceManagementZone>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE__TRAITS_HPP_
