// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/InterferenceManagementZoneType.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_zone_type__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xb2, 0x9a, 0x6f, 0xd7, 0xde, 0x51, 0x1c, 0xfd,
      0xb5, 0x8e, 0x8a, 0x9b, 0x49, 0x34, 0x4b, 0xc4,
      0x47, 0xa8, 0x21, 0x4e, 0x75, 0x47, 0x90, 0x8f,
      0x37, 0x8c, 0x54, 0xaf, 0x94, 0x13, 0x52, 0x76,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/InterferenceManagementZoneType";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__TYPE_NAME, 55, 55},
      {etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# InterferenceManagementZoneType ::= ENUMERATED {\n"
  "#     permanentCenDsrcTolling (0),\n"
  "#     temporaryCenDsrcTolling (1),\n"
  "#     unavailable             (2), \n"
  "#     urbanRail               (3),      \n"
  "#     satelliteStation        (4),\n"
  "#     fixedLinks              (5), \n"
  "#     ...\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# * \n"
  "# * This DE defines the type of an interference management zone, so that an ITS-S can \n"
  "# * assert the actions to do while passing by such zone (e.g. reduce the transmit power in case of a DSRC tolling station).\n"
  "# * It is an extension of the type @ref ProtectedZoneType.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - 0 - `permanentCenDsrcTolling` - as specified in ETSI TS 102 792 [14],\n"
  "# * - 1 - `temporaryCenDsrcTolling` - as specified in ETSI TS 102 792 [14],\n"
  "# * - 2 - `unavailable`             - default value. Set to 2 for backwards compatibility with DSRC tolling,\n"
  "# * - 3 - `urbanRail`               - as specified in ETSI TS 103 724 [13], clause 7,\n"
  "# * - 4 - `satelliteStation`        - as specified in ETSI TS 103 724 [13], clause 7,\n"
  "# * - 5 - `fixedLinks`              - as specified in ETSI TS 103 724 [13], clause 7.\n"
  "# *\n"
  "# * @category: Communication information\n"
  "# * @revision: Created in V2.1.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 PERMANENT_CEN_DSRC_TOLLING = 0\n"
  "uint8 TEMPORARY_CEN_DSRC_TOLLING = 1\n"
  "uint8 UNAVAILABLE = 2\n"
  "uint8 URBAN_RAIL = 3\n"
  "uint8 SATELLITE_STATION = 4\n"
  "uint8 FIXED_LINKS = 5\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__TYPE_NAME, 55, 55},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3021, 3021},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
