// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/LateralAccelerationValue.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/lateral_acceleration_value__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x1a, 0x8f, 0xc1, 0x1c, 0xc9, 0x2c, 0x28, 0x17,
      0x0f, 0x03, 0x57, 0x3c, 0x5e, 0x52, 0xff, 0xad,
      0xae, 0x2f, 0x58, 0x0d, 0x17, 0x7e, 0xa0, 0xa6,
      0x50, 0x6a, 0x60, 0xd5, 0xe2, 0x5e, 0x27, 0xd0,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/LateralAccelerationValue";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__TYPE_NAME, 49, 49},
      {etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# LateralAccelerationValue ::= INTEGER {\n"
  "#     negativeOutOfRange (-160),\n"
  "#     positiveOutOfRange (160),\n"
  "#     unavailable        (161)  \n"
  "# } (-160 .. 161)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the vehicle acceleration at lateral direction in the centre of the mass of the empty vehicle.\n"
  "# * It corresponds to the vehicle coordinate system as specified in ISO 8855 [21].\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - `-160` for acceleration values equal to or less than -16 m/s^2,\n"
  "# * - `n` (`n > -160` and `n <= 0`) to indicate that the vehicle is accelerating towards the right side with regards to the vehicle orientation \n"
  "# *                            with acceleration equal to or less than n x 0,1 m/s^2 and greater than (n-1) x 0,1 m/s^2,\n"
  "# * - `n` (`n > 0` and `n < 160`) to indicate that the vehicle is accelerating towards the left hand side with regards to the vehicle orientation \n"
  "#\\t\\t\\t\\t\\t\\t     with acceleration equal to or less than n x 0,1 m/s^2 and greater than (n-1) x 0,1 m/s^2,\n"
  "# * - `160` for acceleration values greater than 15,9 m/s^2,\n"
  "# * - `161` when the data is unavailable.\n"
  "# *\n"
  "# * @note: the empty load vehicle is defined in ISO 1176 [8], clause 4.6.\n"
  "# * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref AccelerationValue instead.\n"
  "# *  \n"
  "# * @unit: 0,1 m/s^2\n"
  "# * @category: Vehicle information\n"
  "# * @revision: Description updated in V2.1.1 (the meaning of 160 has changed slightly). \n"
  "# \n"
  "\n"
  "int16 value\n"
  "int16 MIN = -160\n"
  "int16 MAX = 161\n"
  "int16 NEGATIVE_OUT_OF_RANGE = -160\n"
  "int16 POSITIVE_OUT_OF_RANGE = 160\n"
  "int16 UNAVAILABLE = 161";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__TYPE_NAME, 49, 49},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3229, 3229},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__LateralAccelerationValue__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
