// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/LongitudinalAccelerationValue.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/longitudinal_acceleration_value__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x7a, 0x1d, 0xe8, 0x73, 0xc9, 0xbd, 0x1c, 0x2f,
      0x8d, 0x0c, 0x90, 0xac, 0x65, 0x5e, 0x3c, 0x2f,
      0xff, 0xd2, 0x85, 0x77, 0xe6, 0xa1, 0xbe, 0xf9,
      0x12, 0x05, 0x12, 0xdd, 0x1b, 0x8a, 0x50, 0x47,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/LongitudinalAccelerationValue";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__TYPE_NAME, 54, 54},
      {etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# LongitudinalAccelerationValue::= INTEGER {\n"
  "#     negativeOutOfRange (-160),\n"
  "#     positiveOutOfRange (160),\n"
  "#     unavailable        (161)  \n"
  "# } (-160 .. 161)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the vehicle acceleration at longitudinal direction in the centre of the mass of the empty vehicle.\n"
  "# * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - `-160` for acceleration values equal to or less than -16 m/s^2,\n"
  "# * - `n` (`n > -160` and `n <= 0`) to indicate that the vehicle is braking with acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2\n"
  "# * - `n` (`n > 0` and `n < 160`) to indicate that the vehicle is accelerating with acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,\n"
  "# * - `160` for acceleration values greater than 15,9 m/s^2,\n"
  "# * - `161` when the data is unavailable. \n"
  "# * \n"
  "# * This acceleration is along the tangent plane of the road surface and does not include gravity components.\n"
  "# * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref AccelerationValue instead.\n"
  "# * \n"
  "# * @note: The empty load vehicle is defined in ISO 1176 [8], clause 4.6.\n"
  "# * @unit: 0,1 m/s^2\n"
  "# * @category: Vehicle information\n"
  "# * @revision: description revised in V2.1.1 (the meaning of 160 has changed slightly). T\n"
  "# \n"
  "\n"
  "int16 value\n"
  "int16 MIN = -160\n"
  "int16 MAX = 161\n"
  "int16 NEGATIVE_OUT_OF_RANGE = -160\n"
  "int16 POSITIVE_OUT_OF_RANGE = 160\n"
  "int16 UNAVAILABLE = 161";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__TYPE_NAME, 54, 54},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3195, 3195},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
