// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_vam_ts_msgs:msg/MitigationPerTechnologyClass.idl
// generated code does not contain a copyright notice
#include "etsi_its_vam_ts_msgs/msg/detail/mitigation_per_technology_class__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `access_technology_class`
#include "etsi_its_vam_ts_msgs/msg/detail/access_technology_class__functions.h"

bool
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__init(etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass * msg)
{
  if (!msg) {
    return false;
  }
  // access_technology_class
  if (!etsi_its_vam_ts_msgs__msg__AccessTechnologyClass__init(&msg->access_technology_class)) {
    etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__fini(msg);
    return false;
  }
  // low_duty_cycle
  // low_duty_cycle_is_present
  // power_reduction
  // power_reduction_is_present
  // dmc_toff_limit
  // dmc_toff_limit_is_present
  // dmc_ton_limit
  // dmc_ton_limit_is_present
  return true;
}

void
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__fini(etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass * msg)
{
  if (!msg) {
    return;
  }
  // access_technology_class
  etsi_its_vam_ts_msgs__msg__AccessTechnologyClass__fini(&msg->access_technology_class);
  // low_duty_cycle
  // low_duty_cycle_is_present
  // power_reduction
  // power_reduction_is_present
  // dmc_toff_limit
  // dmc_toff_limit_is_present
  // dmc_ton_limit
  // dmc_ton_limit_is_present
}

bool
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__are_equal(const etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass * lhs, const etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // access_technology_class
  if (!etsi_its_vam_ts_msgs__msg__AccessTechnologyClass__are_equal(
      &(lhs->access_technology_class), &(rhs->access_technology_class)))
  {
    return false;
  }
  // low_duty_cycle
  if (lhs->low_duty_cycle != rhs->low_duty_cycle) {
    return false;
  }
  // low_duty_cycle_is_present
  if (lhs->low_duty_cycle_is_present != rhs->low_duty_cycle_is_present) {
    return false;
  }
  // power_reduction
  if (lhs->power_reduction != rhs->power_reduction) {
    return false;
  }
  // power_reduction_is_present
  if (lhs->power_reduction_is_present != rhs->power_reduction_is_present) {
    return false;
  }
  // dmc_toff_limit
  if (lhs->dmc_toff_limit != rhs->dmc_toff_limit) {
    return false;
  }
  // dmc_toff_limit_is_present
  if (lhs->dmc_toff_limit_is_present != rhs->dmc_toff_limit_is_present) {
    return false;
  }
  // dmc_ton_limit
  if (lhs->dmc_ton_limit != rhs->dmc_ton_limit) {
    return false;
  }
  // dmc_ton_limit_is_present
  if (lhs->dmc_ton_limit_is_present != rhs->dmc_ton_limit_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__copy(
  const etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass * input,
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass * output)
{
  if (!input || !output) {
    return false;
  }
  // access_technology_class
  if (!etsi_its_vam_ts_msgs__msg__AccessTechnologyClass__copy(
      &(input->access_technology_class), &(output->access_technology_class)))
  {
    return false;
  }
  // low_duty_cycle
  output->low_duty_cycle = input->low_duty_cycle;
  // low_duty_cycle_is_present
  output->low_duty_cycle_is_present = input->low_duty_cycle_is_present;
  // power_reduction
  output->power_reduction = input->power_reduction;
  // power_reduction_is_present
  output->power_reduction_is_present = input->power_reduction_is_present;
  // dmc_toff_limit
  output->dmc_toff_limit = input->dmc_toff_limit;
  // dmc_toff_limit_is_present
  output->dmc_toff_limit_is_present = input->dmc_toff_limit_is_present;
  // dmc_ton_limit
  output->dmc_ton_limit = input->dmc_ton_limit;
  // dmc_ton_limit_is_present
  output->dmc_ton_limit_is_present = input->dmc_ton_limit_is_present;
  return true;
}

etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass *
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass * msg = (etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass));
  bool success = etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__destroy(etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence__init(etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass * data = NULL;

  if (size) {
    data = (etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass *)allocator.zero_allocate(size, sizeof(etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence__fini(etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence *
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence * array = (etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence__destroy(etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence__are_equal(const etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence * lhs, const etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence__copy(
  const etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence * input,
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass * data =
      (etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
