// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/ObjectFace.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/object_face__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__ObjectFace__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x01, 0xac, 0x41, 0x61, 0x6d, 0x06, 0xe0, 0xe7,
      0xb9, 0xb2, 0x3f, 0x2d, 0x75, 0x02, 0x8f, 0xcc,
      0xb2, 0xea, 0x30, 0xa1, 0xbf, 0xec, 0x8f, 0xb0,
      0x0e, 0x88, 0x92, 0x6a, 0x0a, 0x31, 0x78, 0x43,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__ObjectFace__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/ObjectFace";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__ObjectFace__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__ObjectFace__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__ObjectFace__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__ObjectFace__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__ObjectFace__TYPE_NAME, 35, 35},
      {etsi_its_vam_ts_msgs__msg__ObjectFace__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# ObjectFace ::= ENUMERATED {\n"
  "#     front          (0), \n"
  "#     sideLeftFront  (1), \n"
  "#     sideLeftBack   (2), \n"
  "#     sideRightFront (3), \n"
  "#     sideRightBack  (4),\n"
  "#     back           (5)   \n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates the face or part of a face of a solid object.\n"
  "# *\n"
  "# * The object is modelled  as a rectangular prism that has a length that is greater than its width, with the faces of the object being defined as:\n"
  "# * - front: the face defined by the prism's width and height, and which is the first face in direction of longitudinal movement of the object,\n"
  "# * - back: the face defined by the prism's width and height, and which is the last face in direction of longitudinal movement of the object,\n"
  "# * - side: the faces defined by the prism\\'s length and height with \"left\" and \"right\" defined by looking at the front face and \"front\" and \"back\" defined w.r.t to the front and back faces. \n"
  "# *\n"
  "# * Note: It is permissible to derive the required object dimensions and orientation from models to provide a best guess.\n"
  "# * \n"
  "# * @category: Basic information\n"
  "# * @revision: V2.1.1\n"
  "#\n"
  "\n"
  "uint8 value\n"
  "uint8 FRONT = 0\n"
  "uint8 SIDE_LEFT_FRONT = 1\n"
  "uint8 SIDE_LEFT_BACK = 2\n"
  "uint8 SIDE_RIGHT_FRONT = 3\n"
  "uint8 SIDE_RIGHT_BACK = 4\n"
  "uint8 BACK = 5\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__ObjectFace__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__ObjectFace__TYPE_NAME, 35, 35},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2882, 2882},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__ObjectFace__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__ObjectFace__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
