﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/PathDeltaTime.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/path_delta_time.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__PATH_DELTA_TIME__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__PATH_DELTA_TIME__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__PathDeltaTime__MIN = 1ll
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__PathDeltaTime__MAX = 65535ll
};

/// Struct defined in msg/PathDeltaTime in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__PathDeltaTime
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// PathDeltaTime ::= INTEGER (1..65535, ...)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the recorded or estimated travel time between a position and a predefined reference position.
  /// *
  /// * @unit 0,01 second
  /// * @category: GeoReference information
  /// * @revision: V1.3.1
  int64_t value;
} etsi_its_vam_ts_msgs__msg__PathDeltaTime;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__PathDeltaTime.
typedef struct etsi_its_vam_ts_msgs__msg__PathDeltaTime__Sequence
{
  etsi_its_vam_ts_msgs__msg__PathDeltaTime * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__PathDeltaTime__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__PATH_DELTA_TIME__STRUCT_H_
