// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/PrecipitationIntensity.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/precipitation_intensity__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xa3, 0xbc, 0x9f, 0x46, 0x52, 0x91, 0xc3, 0x10,
      0xaf, 0xb7, 0xc3, 0xed, 0xcc, 0x05, 0xb0, 0xfa,
      0xaf, 0xa6, 0x45, 0x90, 0x83, 0xab, 0x1e, 0x4f,
      0x83, 0xcb, 0x28, 0x04, 0xff, 0x4a, 0x41, 0xd2,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/PrecipitationIntensity";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__TYPE_NAME, 47, 47},
      {etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# PrecipitationIntensity ::= INTEGER {\n"
  "# \\toutOfRange\\t\\t\\t\\t\\t\\t\\t\\t(2000), \n"
  "# \\tunavailable\\t\\t\\t\\t\\t\\t\\t\\t(2001) \n"
  "# } (1..2001)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "#* This DE represent the total amount of rain falling during one hour. It is measured in mm per hour at an area of 1 square metre.  \n"
  "#* \n"
  "#* The following values are specified:\n"
  "#* - `n` (`n > 0` and `n < 2000`) if the amount of rain falling is equal to or less than n x 0,1 mm/h and greater than (n-1) x 0,1 mm/h,\n"
  "#* - `2000` if the amount of rain falling is greater than 199.9 mm/h, \n"
  "#* - `2001` if the information is not available.\n"
  "#*\n"
  "#* @unit: 0,1 mm/h \n"
  "#* @category: Basic Information\n"
  "#* @revision: created in V2.1.1\n"
  "#\n"
  "\n"
  "uint16 value\n"
  "uint16 MIN = 1\n"
  "uint16 MAX = 2001\n"
  "uint16 OUT_OF_RANGE = 2000\n"
  "uint16 UNAVAILABLE = 2001";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__TYPE_NAME, 47, 47},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2387, 2387},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
