﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/PrecipitationIntensity.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/precipitation_intensity.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__PRECIPITATION_INTENSITY__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__PRECIPITATION_INTENSITY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__MIN = 1
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__MAX = 2001
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__OUT_OF_RANGE = 2000
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__UNAVAILABLE = 2001
};

/// Struct defined in msg/PrecipitationIntensity in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__PrecipitationIntensity
{
  ///  --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  ///  --- ASN.1 Definition ---------------------------------------------------------
  ///  PrecipitationIntensity ::= INTEGER {
  ///   outOfRange        (2000),
  ///   unavailable        (2001)
  ///  } (1..2001)
  ///  ------------------------------------------------------------------------------
  ///  *
  /// * This DE represent the total amount of rain falling during one hour. It is measured in mm per hour at an area of 1 square metre.
  /// *
  /// * The following values are specified:
  /// * - `n` (`n > 0` and `n < 2000`) if the amount of rain falling is equal to or less than n x 0,1 mm/h and greater than (n-1) x 0,1 mm/h,
  /// * - `2000` if the amount of rain falling is greater than 199.9 mm/h,
  /// * - `2001` if the information is not available.
  /// *
  /// * @unit: 0,1 mm/h
  /// * @category: Basic Information
  /// * @revision: created in V2.1.1
  uint16_t value;
} etsi_its_vam_ts_msgs__msg__PrecipitationIntensity;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__PrecipitationIntensity.
typedef struct etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__Sequence
{
  etsi_its_vam_ts_msgs__msg__PrecipitationIntensity * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__PrecipitationIntensity__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__PRECIPITATION_INTENSITY__STRUCT_H_
