// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/RailwayLevelCrossingSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/railway_level_crossing_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xb5, 0x4b, 0x72, 0xc1, 0x55, 0xad, 0xb2, 0xaf,
      0x3d, 0x17, 0xc2, 0x81, 0x8b, 0xeb, 0x77, 0x9c,
      0xf6, 0xca, 0xaa, 0x20, 0x0a, 0x24, 0xfa, 0x6b,
      0x5a, 0x4e, 0x8b, 0x51, 0xf1, 0x26, 0xd0, 0x03,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/RailwayLevelCrossingSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__TYPE_NAME, 57, 57},
      {etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# RailwayLevelCrossingSubCauseCode ::= INTEGER {\n"
  "#     unavailable                 (0), \n"
  "#     doNotCrossAbnormalSituation (1), \n"
  "#     closed                      (2), \n"
  "#     unguarded                   (3), \n"
  "#     nominal                     (4)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the value of the sub cause codes of the @ref CauseCode `railwayLevelCrossing` .\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0 `unavailable`                   - in case no further detailed information on the railway level crossing status is available,\n"
  "# * - 1 `doNotCrossAbnormalSituation`   - in case when something wrong is detected by equation or sensors of the railway level crossing, \n"
  "#                                         including level crossing is closed for too long (e.g. more than 10 minutes long ; default value),\n"
  "# * - 2 `closed`                        - in case the crossing is closed (barriers down),\n"
  "# * - 3 `unguarded`                     - in case the level crossing is unguarded (i.e a Saint Andrew cross level crossing without detection of train),\n"
  "# * - 4 `nominal`                       - in case the barriers are up and lights are off.\n"
  "# * - 5-255: reserved for future usage.\n"
  "# *\n"
  "# * @category: Traffic information\n"
  "# * @revision: V1.3.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 DO_NOT_CROSS_ABNORMAL_SITUATION = 1\n"
  "uint8 CLOSED = 2\n"
  "uint8 UNGUARDED = 3\n"
  "uint8 NOMINAL = 4";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__TYPE_NAME, 57, 57},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3060, 3060},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__RailwayLevelCrossingSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
