﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/ReferencePositionWithConfidence.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/reference_position_with_confidence.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__REFERENCE_POSITION_WITH_CONFIDENCE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__REFERENCE_POSITION_WITH_CONFIDENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'latitude'
#include "etsi_its_vam_ts_msgs/msg/detail/latitude__struct.h"
// Member 'longitude'
#include "etsi_its_vam_ts_msgs/msg/detail/longitude__struct.h"
// Member 'position_confidence_ellipse'
#include "etsi_its_vam_ts_msgs/msg/detail/position_confidence_ellipse__struct.h"
// Member 'altitude'
#include "etsi_its_vam_ts_msgs/msg/detail/altitude__struct.h"

/// Struct defined in msg/ReferencePositionWithConfidence in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__ReferencePositionWithConfidence
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// ReferencePositionWithConfidence ::= SEQUENCE {
  ///     latitude                     Latitude,
  ///     longitude                    Longitude,
  ///     positionConfidenceEllipse    PositionConfidenceEllipse,
  ///     altitude                     Altitude
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * A position within a geographic coordinate system together with a confidence ellipse.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field latitude: the latitude of the geographical point.
  /// *
  /// * @field longitude: the longitude of the geographical point.
  /// *
  /// * @field positionConfidenceEllipse: the confidence ellipse associated to the geographical position.
  /// *
  /// * @field altitude: the altitude and an altitude accuracy of the geographical point.
  /// *
  /// * @category: GeoReference information
  /// * @revision: created in V2.1.1 based on @ref ReferencePosition but using @ref PositionConfidenceEllipse.
  etsi_its_vam_ts_msgs__msg__Latitude latitude;
  etsi_its_vam_ts_msgs__msg__Longitude longitude;
  etsi_its_vam_ts_msgs__msg__PositionConfidenceEllipse position_confidence_ellipse;
  etsi_its_vam_ts_msgs__msg__Altitude altitude;
} etsi_its_vam_ts_msgs__msg__ReferencePositionWithConfidence;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__ReferencePositionWithConfidence.
typedef struct etsi_its_vam_ts_msgs__msg__ReferencePositionWithConfidence__Sequence
{
  etsi_its_vam_ts_msgs__msg__ReferencePositionWithConfidence * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__ReferencePositionWithConfidence__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__REFERENCE_POSITION_WITH_CONFIDENCE__STRUCT_H_
