// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/RelevanceDistance.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/relevance_distance__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__RelevanceDistance__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xb3, 0x68, 0x66, 0x02, 0x5c, 0x9b, 0x77, 0x91,
      0xbc, 0x12, 0xc3, 0x05, 0xb2, 0xef, 0xf1, 0x90,
      0x70, 0xda, 0xe0, 0x87, 0xa2, 0x3f, 0x0f, 0x81,
      0x7d, 0xba, 0xdb, 0x1a, 0x62, 0x61, 0x2a, 0xd3,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__RelevanceDistance__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/RelevanceDistance";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__RelevanceDistance__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__RelevanceDistance__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__RelevanceDistance__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__RelevanceDistance__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__RelevanceDistance__TYPE_NAME, 42, 42},
      {etsi_its_vam_ts_msgs__msg__RelevanceDistance__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# RelevanceDistance ::= ENUMERATED {\n"
  "#     lessThan50m(0), \n"
  "#     lessThan100m(1), \n"
  "#     lessThan200m(2), \n"
  "#     lessThan500m(3), \n"
  "#     lessThan1000m(4), \n"
  "#     lessThan5km(5), \n"
  "#     lessThan10km(6), \n"
  "#     over10km(7)\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE describes a distance of relevance for information indicated in a message.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - 0 `lessThan50m`   - for distances below 50 m,\n"
  "# * - 1 `lessThan100m`  - for distances below 100 m, \n"
  "# * - 2 `lessThan200m`  - for distances below 200 m, \n"
  "# * - 3 `lessThan500m`  - for distances below 300 m, \n"
  "# * - 4 `lessThan1000m` - for distances below 1 000 m, \n"
  "# * - 5 `lessThan5km`   - for distances below 5 000 m, \n"
  "# * - 6 `lessThan10km`  - for distances below 10 000 m, \n"
  "# * - 7 `over10km`      - for distances over 10 000 m. \n"
  "# * \n"
  "# * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref StandardLength3b instead. \n"
  "# *\n"
  "# * @category: GeoReference information\n"
  "# * @revision: Editorial update in V2.1.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 LESS_THAN50M = 0\n"
  "uint8 LESS_THAN100M = 1\n"
  "uint8 LESS_THAN200M = 2\n"
  "uint8 LESS_THAN500M = 3\n"
  "uint8 LESS_THAN1000M = 4\n"
  "uint8 LESS_THAN5KM = 5\n"
  "uint8 LESS_THAN10KM = 6\n"
  "uint8 OVER10KM = 7\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__RelevanceDistance__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__RelevanceDistance__TYPE_NAME, 42, 42},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2862, 2862},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__RelevanceDistance__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__RelevanceDistance__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
