// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_vam_ts_msgs:msg/SafeDistanceIndication.idl
// generated code does not contain a copyright notice
#include "etsi_its_vam_ts_msgs/msg/detail/safe_distance_indication__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `subject_station`
#include "etsi_its_vam_ts_msgs/msg/detail/station_id__functions.h"
// Member `safe_distance_indicator`
#include "etsi_its_vam_ts_msgs/msg/detail/safe_distance_indicator__functions.h"
// Member `time_to_collision`
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_tenth_of_second__functions.h"

bool
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__init(etsi_its_vam_ts_msgs__msg__SafeDistanceIndication * msg)
{
  if (!msg) {
    return false;
  }
  // subject_station
  if (!etsi_its_vam_ts_msgs__msg__StationId__init(&msg->subject_station)) {
    etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__fini(msg);
    return false;
  }
  // subject_station_is_present
  // safe_distance_indicator
  if (!etsi_its_vam_ts_msgs__msg__SafeDistanceIndicator__init(&msg->safe_distance_indicator)) {
    etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__fini(msg);
    return false;
  }
  // time_to_collision
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__init(&msg->time_to_collision)) {
    etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__fini(msg);
    return false;
  }
  // time_to_collision_is_present
  return true;
}

void
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__fini(etsi_its_vam_ts_msgs__msg__SafeDistanceIndication * msg)
{
  if (!msg) {
    return;
  }
  // subject_station
  etsi_its_vam_ts_msgs__msg__StationId__fini(&msg->subject_station);
  // subject_station_is_present
  // safe_distance_indicator
  etsi_its_vam_ts_msgs__msg__SafeDistanceIndicator__fini(&msg->safe_distance_indicator);
  // time_to_collision
  etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__fini(&msg->time_to_collision);
  // time_to_collision_is_present
}

bool
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__are_equal(const etsi_its_vam_ts_msgs__msg__SafeDistanceIndication * lhs, const etsi_its_vam_ts_msgs__msg__SafeDistanceIndication * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // subject_station
  if (!etsi_its_vam_ts_msgs__msg__StationId__are_equal(
      &(lhs->subject_station), &(rhs->subject_station)))
  {
    return false;
  }
  // subject_station_is_present
  if (lhs->subject_station_is_present != rhs->subject_station_is_present) {
    return false;
  }
  // safe_distance_indicator
  if (!etsi_its_vam_ts_msgs__msg__SafeDistanceIndicator__are_equal(
      &(lhs->safe_distance_indicator), &(rhs->safe_distance_indicator)))
  {
    return false;
  }
  // time_to_collision
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__are_equal(
      &(lhs->time_to_collision), &(rhs->time_to_collision)))
  {
    return false;
  }
  // time_to_collision_is_present
  if (lhs->time_to_collision_is_present != rhs->time_to_collision_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__copy(
  const etsi_its_vam_ts_msgs__msg__SafeDistanceIndication * input,
  etsi_its_vam_ts_msgs__msg__SafeDistanceIndication * output)
{
  if (!input || !output) {
    return false;
  }
  // subject_station
  if (!etsi_its_vam_ts_msgs__msg__StationId__copy(
      &(input->subject_station), &(output->subject_station)))
  {
    return false;
  }
  // subject_station_is_present
  output->subject_station_is_present = input->subject_station_is_present;
  // safe_distance_indicator
  if (!etsi_its_vam_ts_msgs__msg__SafeDistanceIndicator__copy(
      &(input->safe_distance_indicator), &(output->safe_distance_indicator)))
  {
    return false;
  }
  // time_to_collision
  if (!etsi_its_vam_ts_msgs__msg__DeltaTimeTenthOfSecond__copy(
      &(input->time_to_collision), &(output->time_to_collision)))
  {
    return false;
  }
  // time_to_collision_is_present
  output->time_to_collision_is_present = input->time_to_collision_is_present;
  return true;
}

etsi_its_vam_ts_msgs__msg__SafeDistanceIndication *
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__SafeDistanceIndication * msg = (etsi_its_vam_ts_msgs__msg__SafeDistanceIndication *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__SafeDistanceIndication), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_vam_ts_msgs__msg__SafeDistanceIndication));
  bool success = etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__destroy(etsi_its_vam_ts_msgs__msg__SafeDistanceIndication * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence__init(etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__SafeDistanceIndication * data = NULL;

  if (size) {
    data = (etsi_its_vam_ts_msgs__msg__SafeDistanceIndication *)allocator.zero_allocate(size, sizeof(etsi_its_vam_ts_msgs__msg__SafeDistanceIndication), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence__fini(etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence *
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence * array = (etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence__destroy(etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence__are_equal(const etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence * lhs, const etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence__copy(
  const etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence * input,
  etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_vam_ts_msgs__msg__SafeDistanceIndication);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_vam_ts_msgs__msg__SafeDistanceIndication * data =
      (etsi_its_vam_ts_msgs__msg__SafeDistanceIndication *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__SafeDistanceIndication__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
