// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/SensorType.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/sensor_type__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__SensorType__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xeb, 0x15, 0x69, 0xd7, 0x09, 0x5f, 0x61, 0x0a,
      0x97, 0x37, 0x01, 0x4c, 0xa6, 0x46, 0xa0, 0x78,
      0xeb, 0x48, 0x8a, 0x6b, 0x90, 0x71, 0xdb, 0x65,
      0x81, 0x74, 0x7e, 0xe3, 0x15, 0x80, 0x91, 0x85,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__SensorType__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/SensorType";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__SensorType__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__SensorType__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__SensorType__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__SensorType__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__SensorType__TYPE_NAME, 35, 35},
      {etsi_its_vam_ts_msgs__msg__SensorType__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# SensorType ::= INTEGER {\n"
  "#     undefined         (0),\n"
  "#     radar             (1),\n"
  "#     lidar             (2),\n"
  "#     monovideo         (3),\n"
  "#     stereovision      (4),\n"
  "#     nightvision       (5),\n"
  "#     ultrasonic        (6),\n"
  "#     pmd               (7),\n"
  "#     inductionLoop     (8),\n"
  "#     sphericalCamera   (9),\n"
  "#     uwb               (10),\n"
  "#     acoustic          (11),\n"
  "#     localAggregation  (12),\n"
  "#     itsAggregation    (13)\n"
  "# } (0..31)\n"
  "# ------------------------------------------------------------------------------\n"
  "# * \n"
  "# * This DE indicates the type of sensor.\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0  `undefined`         - in case the sensor type is undefined. \n"
  "# * - 1  `radar`             - in case the sensor is a radar,\n"
  "# * - 2  `lidar`             - in case the sensor is a lidar,\n"
  "# * - 3  `monovideo`         - in case the sensor is mono video,\n"
  "# * - 4  `stereovision`      - in case the sensor is stereo vision,\n"
  "# * - 5  `nightvision`       - in case the sensor is night vision,\n"
  "# * - 6  `ultrasonic`        - in case the sensor is ultrasonic,\n"
  "# * - 7  `pmd`               - in case the sensor is photonic mixing device,\n"
  "# * - 8  `inductionLoop`     - in case the sensor is an induction loop,\n"
  "# * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,\n"
  "# * - 10 `uwb`               - in case the sensor is ultra wide band,\n"
  "# * - 11 `acoustic`          - in case the sensor is acoustic,\n"
  "# * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,\n"
  "# * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.\n"
  "# * - 14-31                  - are reserved for future usage.\n"
  "# *\n"
  "# * @category: Sensing Information\n"
  "# * @revision: created in V2.1.1\n"
  "#\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 31\n"
  "uint8 UNDEFINED = 0\n"
  "uint8 RADAR = 1\n"
  "uint8 LIDAR = 2\n"
  "uint8 MONOVIDEO = 3\n"
  "uint8 STEREOVISION = 4\n"
  "uint8 NIGHTVISION = 5\n"
  "uint8 ULTRASONIC = 6\n"
  "uint8 PMD = 7\n"
  "uint8 INDUCTION_LOOP = 8\n"
  "uint8 SPHERICAL_CAMERA = 9\n"
  "uint8 UWB = 10\n"
  "uint8 ACOUSTIC = 11\n"
  "uint8 LOCAL_AGGREGATION = 12\n"
  "uint8 ITS_AGGREGATION = 13";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__SensorType__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__SensorType__TYPE_NAME, 35, 35},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3776, 3776},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__SensorType__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__SensorType__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
