// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/SpecialTransportType.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/special_transport_type__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__SpecialTransportType__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xc9, 0xc1, 0x90, 0xea, 0x0a, 0x40, 0x61, 0xc2,
      0xe6, 0x9b, 0x80, 0x50, 0xc4, 0x58, 0x7b, 0xf3,
      0xdb, 0xd8, 0x2a, 0x07, 0x6c, 0x90, 0x31, 0x18,
      0xac, 0x30, 0xcd, 0x42, 0x1d, 0x3d, 0xbe, 0x40,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__SpecialTransportType__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/SpecialTransportType";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__SpecialTransportType__FIELD_NAME__value[] = "value";
static char etsi_its_vam_ts_msgs__msg__SpecialTransportType__FIELD_NAME__bits_unused[] = "bits_unused";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__SpecialTransportType__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__SpecialTransportType__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {etsi_its_vam_ts_msgs__msg__SpecialTransportType__FIELD_NAME__bits_unused, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__SpecialTransportType__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__SpecialTransportType__TYPE_NAME, 45, 45},
      {etsi_its_vam_ts_msgs__msg__SpecialTransportType__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# SpecialTransportType ::= BIT STRING {\n"
  "#     heavyLoad    (0),\n"
  "#     excessWidth  (1), \n"
  "#     excessLength (2), \n"
  "#     excessHeight (3)\n"
  "# } (SIZE(4))\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * The DE indicates if a vehicle is carrying goods in the special transport conditions.\n"
  "# *\n"
  "# * The corresponding bit shall be set to 1 under the following conditions:\n"
  "# * - 0 `heavyLoad`        - the vehicle is carrying goods with heavy load,\n"
  "# * - 1 `excessWidth`      - the vehicle is carrying goods in excess of width,\n"
  "# * - 2 `excessLength`     - the vehicle is carrying goods in excess of length,\n"
  "# * - 3 `excessHeight`     - the vehicle is carrying goods in excess of height.\n"
  "# *\n"
  "# * Otherwise, the corresponding bit shall be set to 0.\n"
  "# * @category Vehicle information\n"
  "# * @revision: Description revised in V2.1.1\n"
  "# \n"
  "\n"
  "uint8[] value\n"
  "uint8 bits_unused\n"
  "uint8 SIZE_BITS = 4\n"
  "uint8 BIT_INDEX_HEAVY_LOAD = 0\n"
  "uint8 BIT_INDEX_EXCESS_WIDTH = 1\n"
  "uint8 BIT_INDEX_EXCESS_LENGTH = 2\n"
  "uint8 BIT_INDEX_EXCESS_HEIGHT = 3";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__SpecialTransportType__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__SpecialTransportType__TYPE_NAME, 45, 45},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2614, 2614},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__SpecialTransportType__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__SpecialTransportType__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
