// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/StabilityLossProbability.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/stability_loss_probability__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__StabilityLossProbability__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x02, 0xe0, 0xdd, 0x93, 0x31, 0x78, 0x79, 0xb7,
      0x98, 0xa7, 0xb2, 0x87, 0xc2, 0x3b, 0x4d, 0x28,
      0x2e, 0x04, 0x08, 0x52, 0x1f, 0x4d, 0xec, 0xcf,
      0xb5, 0xb5, 0xca, 0x36, 0xec, 0x84, 0x5f, 0x17,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__StabilityLossProbability__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/StabilityLossProbability";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__StabilityLossProbability__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__StabilityLossProbability__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__StabilityLossProbability__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__StabilityLossProbability__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__StabilityLossProbability__TYPE_NAME, 49, 49},
      {etsi_its_vam_ts_msgs__msg__StabilityLossProbability__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# StabilityLossProbability ::= INTEGER {\n"
  "#     stable                  (0), \n"
  "#     totalLossOfStability   (50), \n"
  "#     unavailable            (63) \n"
  "# } (0..63) \n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates the estimated probability of a stability level and conversely also the probability of a stability loss.\n"
  "# *\n"
  "# * The value shall be set to:\n"
  "# * - `0` to indicate an estimated probability of a loss of stability of 0 %, i.e. \"stable\", \n"
  "# * - `n` (`n > 0` and `n < 50`) to indicate the actual stability level,\n"
  "# * - `50` to indicate a estimated probability of a loss of stability of 100 %, i.e. \"total loss of stability\",\n"
  "# * - the values between 51 and 62 are reserved for future use,\n"
  "# * - `63`: this value indicates that the information is unavailable.\n"
  "# *\n"
  "# * @unit: 2 %\n"
  "# * @category: Kinematic information\n"
  "# * @revision: Created in V2.1.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 63\n"
  "uint8 STABLE = 0\n"
  "uint8 TOTAL_LOSS_OF_STABILITY = 50\n"
  "uint8 UNAVAILABLE = 63";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__StabilityLossProbability__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__StabilityLossProbability__TYPE_NAME, 49, 49},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2596, 2596},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__StabilityLossProbability__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__StabilityLossProbability__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
