// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/StationType.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/station_type__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__StationType__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xa8, 0x5f, 0x81, 0x57, 0x3c, 0xf9, 0xdc, 0xd8,
      0x0f, 0xa3, 0x63, 0x42, 0xd6, 0xc1, 0x4a, 0x3a,
      0x40, 0x2d, 0x72, 0xe9, 0x4c, 0xb7, 0xff, 0x10,
      0x44, 0xbd, 0x29, 0x02, 0xcb, 0x5a, 0x09, 0xec,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__StationType__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/StationType";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__StationType__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__StationType__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__StationType__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__StationType__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__StationType__TYPE_NAME, 36, 36},
      {etsi_its_vam_ts_msgs__msg__StationType__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# StationType ::= INTEGER {\n"
  "#     unknown         (0), \n"
  "#     pedestrian      (1), \n"
  "#     cyclist         (2), \n"
  "#     moped           (3), \n"
  "#     motorcycle      (4), \n"
  "#     passengerCar    (5), \n"
  "#     bus             (6), \n"
  "#     lightTruck      (7), \n"
  "#     heavyTruck      (8), \n"
  "#     trailer         (9), \n"
  "#     specialVehicle  (10), \n"
  "#     tram            (11), \n"
  "#     lightVruVehicle (12), \n"
  "#     animal          (13), \n"
  "#     roadSideUnit    (15)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the type of technical context the ITS-S is integrated in.\n"
  "# * The station type depends on the integration environment of ITS-S into vehicle, mobile devices or at infrastructure.\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0 `unknown`          - information about the ITS-S context is not provided,\n"
  "# * - 1 `pedestrian`       - ITS-S carried by human being not using a mechanical device for their trip (VRU profile 1),\n"
  "# * - 2 `cyclist`          - ITS-S mounted on non-motorized unicycles, bicycles , tricycles, quadracycles (VRU profile 2),\n"
  "# * - 3 `moped`            - ITS-S mounted on light motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] \n"
  "#                            class L1, L2 (VRU Profile 3),\n"
  "# * - 4 `motorcycles`      - ITS-S mounted on motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] \n"
  "#                            class L3, L4, L5, L6, L7 (VRU Profile 3),\n"
  "# * - 5 `passengerCar`     - ITS-S mounted on small passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M1,\n"
  "# * - 6 `bus`              - ITS-S mounted on large passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M2, M3,\n"
  "# * - 7 `lightTruck`       - ITS-S mounted on light Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N1,\n"
  "# * - 8 `heavyTruck`       - ITS-S mounted on Heavy Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N2 and N3,\n"
  "# * - 9 `trailer`          - ITS-S mounted on an unpowered vehicle that is intended to be towed by a powered vehicle as defined in \n"
  "#                            UNECE/TRANS/WP.29/78/Rev.4 [16] class O,\n"
  "# * - 10 `specialVehicles` - ITS-S mounted on vehicles which have special purposes other than the above (e.g. moving road works vehicle),\n"
  "# * - 11 `tram`            - ITS-S mounted on a vehicle which runs on tracks along public streets,\n"
  "# * - 12 `lightVruVehicle` - ITS-S carried by a human being traveling on light vehicle , incl. possible use of roller skates or skateboards (VRU profile 2),\n"
  "# * - 13 `animal`          - ITS-S carried by an animal presenting a safety risk to other road users e.g. domesticated dog in a city or horse (VRU Profile 4),\n"
  "# * - 14                   - reserved for future usage,\n"
  "# * - 15 `roadSideUnit`    - ITS-S mounted on an infrastructure typically positioned outside of the drivable roadway (e.g. on a gantry, on a pole, \n"
  "#                            on a stationary road works trailer); the infrastructure is static during the entire operation period of the ITS-S (e.g. no stop and go activity),\n"
  "# * - 16-255               - are reserved for future usage.\n"
  "# * \n"
  "# * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref TrafficParticipantType instead.\n"
  "# * @category: Communication information.\n"
  "# * @revision: revised in V2.1.1 (named values 12 and 13 added and note to value 9 deleted)\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNKNOWN = 0\n"
  "uint8 PEDESTRIAN = 1\n"
  "uint8 CYCLIST = 2\n"
  "uint8 MOPED = 3\n"
  "uint8 MOTORCYCLE = 4\n"
  "uint8 PASSENGER_CAR = 5\n"
  "uint8 BUS = 6\n"
  "uint8 LIGHT_TRUCK = 7\n"
  "uint8 HEAVY_TRUCK = 8\n"
  "uint8 TRAILER = 9\n"
  "uint8 SPECIAL_VEHICLE = 10\n"
  "uint8 TRAM = 11\n"
  "uint8 LIGHT_VRU_VEHICLE = 12\n"
  "uint8 ANIMAL = 13\n"
  "uint8 ROAD_SIDE_UNIT = 15";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__StationType__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__StationType__TYPE_NAME, 36, 36},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 5419, 5419},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__StationType__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__StationType__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
