// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/TimestampIts.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/timestamp_its__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__TimestampIts__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x3c, 0x35, 0xec, 0xdd, 0x20, 0x4a, 0x7e, 0xb8,
      0xc1, 0x74, 0x2e, 0x4c, 0xe7, 0xab, 0xe0, 0xa5,
      0x54, 0x22, 0xdd, 0x12, 0xc8, 0xd1, 0xba, 0x49,
      0x0a, 0xd3, 0xf8, 0x31, 0x20, 0x3c, 0xfc, 0x82,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__TimestampIts__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/TimestampIts";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__TimestampIts__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__TimestampIts__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__TimestampIts__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT64,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__TimestampIts__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__TimestampIts__TYPE_NAME, 37, 37},
      {etsi_its_vam_ts_msgs__msg__TimestampIts__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# TimestampIts ::= INTEGER (0..4398046511103)\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE represents the number of elapsed (TAI) milliseconds since the ITS Epoch. \n"
  "# * The ITS epoch is `00:00:00.000 UTC, 1 January 2004`.\n"
  "# * \"Elapsed\" means that the true number of milliseconds is continuously counted without interruption,\n"
  "# *  i.e. it is not altered by leap seconds, which occur in UTC.\n"
  "# * \n"
  "# * @note: International Atomic Time (TAI) is the time reference coordinate on the basis of the readings of atomic clocks, \n"
  "# * operated in accordance with the definition of the second, the unit of time of the International System of Units. \n"
  "# * TAI is a continuous time scale. UTC has discontinuities, as it is occasionally adjusted by leap seconds. \n"
  "# * As of 1 January, 2022, TimestampIts is 5 seconds ahead of UTC, because since the ITS epoch on 1 January 2004 00:00:00.000 UTC, \n"
  "# * further 5 leap seconds have been inserted in UTC.\n"
  "# * \n"
  "# * EXAMPLE: The value for TimestampIts for 1 January 2007 00:00:00.000 UTC is `94 694 401 000` milliseconds,\n"
  "# * which includes one leap second insertion since the ITS epoch.\n"
  "# * @unit: 0,001 s\n"
  "# * @category: Basic information\n"
  "# * @revision: Description revised in in V2.1.1\n"
  "# \n"
  "\n"
  "uint64 value\n"
  "uint64 MIN = 0\n"
  "uint64 MAX = 4398046511103\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__TimestampIts__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__TimestampIts__TYPE_NAME, 37, 37},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2893, 2893},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__TimestampIts__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__TimestampIts__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
