// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/TrafficDirection.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/traffic_direction__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__TrafficDirection__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xd1, 0xcc, 0x5b, 0xa0, 0x83, 0xe8, 0xb9, 0x0b,
      0x63, 0x0b, 0x6e, 0x7f, 0x43, 0x21, 0x4b, 0x6c,
      0xf9, 0xdf, 0x54, 0x61, 0xff, 0x34, 0x7b, 0x63,
      0x33, 0xe9, 0x41, 0xdf, 0xc0, 0x41, 0xeb, 0x33,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__TrafficDirection__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/TrafficDirection";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__TrafficDirection__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__TrafficDirection__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__TrafficDirection__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__TrafficDirection__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__TrafficDirection__TYPE_NAME, 41, 41},
      {etsi_its_vam_ts_msgs__msg__TrafficDirection__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# TrafficDirection ::= ENUMERATED {\n"
  "#     allTrafficDirections (0), \n"
  "#     upstreamTraffic      (1), \n"
  "#     downstreamTraffic    (2), \n"
  "#     oppositeTraffic      (3)\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates a traffic direction that is relevant to information indicated in a message.\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - 0 `allTrafficDirections` - for all traffic directions, \n"
  "# * - 1 `upstreamTraffic`      - for upstream traffic, \n"
  "# * - 2 `downstreamTraffic`    - for downstream traffic, \n"
  "# * - 3 `oppositeTraffic`      - for traffic in the opposite direction. \n"
  "# *\n"
  "# * The terms `upstream`, `downstream` and `oppositeTraffic` are relative to the event position.\n"
  "# *\n"
  "# * @note: Upstream traffic corresponds to the incoming traffic towards the event position,\n"
  "# * and downstream traffic to the departing traffic away from the event position.\n"
  "# *\n"
  "# * @category: GeoReference information\n"
  "# * @revision: Created in V2.1.1 from RelevanceTrafficDirection\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 ALL_TRAFFIC_DIRECTIONS = 0\n"
  "uint8 UPSTREAM_TRAFFIC = 1\n"
  "uint8 DOWNSTREAM_TRAFFIC = 2\n"
  "uint8 OPPOSITE_TRAFFIC = 3\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__TrafficDirection__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__TrafficDirection__TYPE_NAME, 41, 41},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2725, 2725},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__TrafficDirection__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__TrafficDirection__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
