﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/VarLengthNumber.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/var_length_number.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAR_LENGTH_NUMBER__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAR_LENGTH_NUMBER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'CHOICE_CONTENT'.
enum
{
  etsi_its_vam_ts_msgs__msg__VarLengthNumber__CHOICE_CONTENT = 0
};

/// Constant 'CHOICE_EXTENSION'.
enum
{
  etsi_its_vam_ts_msgs__msg__VarLengthNumber__CHOICE_EXTENSION = 1
};

// Include directives for member types
// Member 'extension'
#include "etsi_its_vam_ts_msgs/msg/detail/ext1__struct.h"

/// Struct defined in msg/VarLengthNumber in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__VarLengthNumber
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// VarLengthNumber::=CHOICE{
  ///  content     [0] INTEGER(0..127), -- one octet length
  ///  extension [1] Ext1
  ///  }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF together with its sub DFs Ext1, Ext2 and the DE Ext3 provides the custom (i.e. not ASN.1 standard) definition of an integer with variable lenght, that can be used for example to encode the ITS-AID.
  /// *
  /// * @category: Basic information
  /// * @revision: Created in V2.1.1
  uint8_t choice;
  uint8_t content;
  etsi_its_vam_ts_msgs__msg__Ext1 extension;
} etsi_its_vam_ts_msgs__msg__VarLengthNumber;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__VarLengthNumber.
typedef struct etsi_its_vam_ts_msgs__msg__VarLengthNumber__Sequence
{
  etsi_its_vam_ts_msgs__msg__VarLengthNumber * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__VarLengthNumber__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAR_LENGTH_NUMBER__STRUCT_H_
