// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_vam_ts_msgs:msg/VruAwareness.idl
// generated code does not contain a copyright notice
#include "etsi_its_vam_ts_msgs/msg/detail/vru_awareness__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `generation_delta_time`
#include "etsi_its_vam_ts_msgs/msg/detail/generation_delta_time__functions.h"
// Member `vam_parameters`
#include "etsi_its_vam_ts_msgs/msg/detail/vam_parameters__functions.h"

bool
etsi_its_vam_ts_msgs__msg__VruAwareness__init(etsi_its_vam_ts_msgs__msg__VruAwareness * msg)
{
  if (!msg) {
    return false;
  }
  // generation_delta_time
  if (!etsi_its_vam_ts_msgs__msg__GenerationDeltaTime__init(&msg->generation_delta_time)) {
    etsi_its_vam_ts_msgs__msg__VruAwareness__fini(msg);
    return false;
  }
  // vam_parameters
  if (!etsi_its_vam_ts_msgs__msg__VamParameters__init(&msg->vam_parameters)) {
    etsi_its_vam_ts_msgs__msg__VruAwareness__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_vam_ts_msgs__msg__VruAwareness__fini(etsi_its_vam_ts_msgs__msg__VruAwareness * msg)
{
  if (!msg) {
    return;
  }
  // generation_delta_time
  etsi_its_vam_ts_msgs__msg__GenerationDeltaTime__fini(&msg->generation_delta_time);
  // vam_parameters
  etsi_its_vam_ts_msgs__msg__VamParameters__fini(&msg->vam_parameters);
}

bool
etsi_its_vam_ts_msgs__msg__VruAwareness__are_equal(const etsi_its_vam_ts_msgs__msg__VruAwareness * lhs, const etsi_its_vam_ts_msgs__msg__VruAwareness * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // generation_delta_time
  if (!etsi_its_vam_ts_msgs__msg__GenerationDeltaTime__are_equal(
      &(lhs->generation_delta_time), &(rhs->generation_delta_time)))
  {
    return false;
  }
  // vam_parameters
  if (!etsi_its_vam_ts_msgs__msg__VamParameters__are_equal(
      &(lhs->vam_parameters), &(rhs->vam_parameters)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__VruAwareness__copy(
  const etsi_its_vam_ts_msgs__msg__VruAwareness * input,
  etsi_its_vam_ts_msgs__msg__VruAwareness * output)
{
  if (!input || !output) {
    return false;
  }
  // generation_delta_time
  if (!etsi_its_vam_ts_msgs__msg__GenerationDeltaTime__copy(
      &(input->generation_delta_time), &(output->generation_delta_time)))
  {
    return false;
  }
  // vam_parameters
  if (!etsi_its_vam_ts_msgs__msg__VamParameters__copy(
      &(input->vam_parameters), &(output->vam_parameters)))
  {
    return false;
  }
  return true;
}

etsi_its_vam_ts_msgs__msg__VruAwareness *
etsi_its_vam_ts_msgs__msg__VruAwareness__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VruAwareness * msg = (etsi_its_vam_ts_msgs__msg__VruAwareness *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__VruAwareness), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_vam_ts_msgs__msg__VruAwareness));
  bool success = etsi_its_vam_ts_msgs__msg__VruAwareness__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_vam_ts_msgs__msg__VruAwareness__destroy(etsi_its_vam_ts_msgs__msg__VruAwareness * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_vam_ts_msgs__msg__VruAwareness__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence__init(etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VruAwareness * data = NULL;

  if (size) {
    data = (etsi_its_vam_ts_msgs__msg__VruAwareness *)allocator.zero_allocate(size, sizeof(etsi_its_vam_ts_msgs__msg__VruAwareness), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_vam_ts_msgs__msg__VruAwareness__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_vam_ts_msgs__msg__VruAwareness__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence__fini(etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_vam_ts_msgs__msg__VruAwareness__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence *
etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence * array = (etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence__destroy(etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence__are_equal(const etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence * lhs, const etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__VruAwareness__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence__copy(
  const etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence * input,
  etsi_its_vam_ts_msgs__msg__VruAwareness__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_vam_ts_msgs__msg__VruAwareness);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_vam_ts_msgs__msg__VruAwareness * data =
      (etsi_its_vam_ts_msgs__msg__VruAwareness *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_vam_ts_msgs__msg__VruAwareness__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_vam_ts_msgs__msg__VruAwareness__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__VruAwareness__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
