// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VruAwareness.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/vru_awareness.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_AWARENESS__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_AWARENESS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'generation_delta_time'
#include "etsi_its_vam_ts_msgs/msg/detail/generation_delta_time__struct.hpp"
// Member 'vam_parameters'
#include "etsi_its_vam_ts_msgs/msg/detail/vam_parameters__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruAwareness __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruAwareness __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VruAwareness_
{
  using Type = VruAwareness_<ContainerAllocator>;

  explicit VruAwareness_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : generation_delta_time(_init),
    vam_parameters(_init)
  {
    (void)_init;
  }

  explicit VruAwareness_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : generation_delta_time(_alloc, _init),
    vam_parameters(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _generation_delta_time_type =
    etsi_its_vam_ts_msgs::msg::GenerationDeltaTime_<ContainerAllocator>;
  _generation_delta_time_type generation_delta_time;
  using _vam_parameters_type =
    etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator>;
  _vam_parameters_type vam_parameters;

  // setters for named parameter idiom
  Type & set__generation_delta_time(
    const etsi_its_vam_ts_msgs::msg::GenerationDeltaTime_<ContainerAllocator> & _arg)
  {
    this->generation_delta_time = _arg;
    return *this;
  }
  Type & set__vam_parameters(
    const etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator> & _arg)
  {
    this->vam_parameters = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruAwareness
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruAwareness
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruAwareness_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VruAwareness_ & other) const
  {
    if (this->generation_delta_time != other.generation_delta_time) {
      return false;
    }
    if (this->vam_parameters != other.vam_parameters) {
      return false;
    }
    return true;
  }
  bool operator!=(const VruAwareness_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VruAwareness_

// alias to use template instance with default allocator
using VruAwareness =
  etsi_its_vam_ts_msgs::msg::VruAwareness_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_AWARENESS__STRUCT_HPP_
