// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VruClusterOperationContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/vru_cluster_operation_container.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_OPERATION_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_OPERATION_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_vam_ts_msgs/msg/detail/vru_cluster_operation_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'cluster_join_info'
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_join_info__traits.hpp"
// Member 'cluster_leave_info'
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_leave_info__traits.hpp"
// Member 'cluster_breakup_info'
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_breakup_info__traits.hpp"
// Member 'cluster_id_change_time_info'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_quarter_second__traits.hpp"

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VruClusterOperationContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: cluster_join_info
  {
    out << "cluster_join_info: ";
    to_flow_style_yaml(msg.cluster_join_info, out);
    out << ", ";
  }

  // member: cluster_join_info_is_present
  {
    out << "cluster_join_info_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_join_info_is_present, out);
    out << ", ";
  }

  // member: cluster_leave_info
  {
    out << "cluster_leave_info: ";
    to_flow_style_yaml(msg.cluster_leave_info, out);
    out << ", ";
  }

  // member: cluster_leave_info_is_present
  {
    out << "cluster_leave_info_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_leave_info_is_present, out);
    out << ", ";
  }

  // member: cluster_breakup_info
  {
    out << "cluster_breakup_info: ";
    to_flow_style_yaml(msg.cluster_breakup_info, out);
    out << ", ";
  }

  // member: cluster_breakup_info_is_present
  {
    out << "cluster_breakup_info_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_breakup_info_is_present, out);
    out << ", ";
  }

  // member: cluster_id_change_time_info
  {
    out << "cluster_id_change_time_info: ";
    to_flow_style_yaml(msg.cluster_id_change_time_info, out);
    out << ", ";
  }

  // member: cluster_id_change_time_info_is_present
  {
    out << "cluster_id_change_time_info_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_id_change_time_info_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VruClusterOperationContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: cluster_join_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_join_info:\n";
    to_block_style_yaml(msg.cluster_join_info, out, indentation + 2);
  }

  // member: cluster_join_info_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_join_info_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_join_info_is_present, out);
    out << "\n";
  }

  // member: cluster_leave_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_leave_info:\n";
    to_block_style_yaml(msg.cluster_leave_info, out, indentation + 2);
  }

  // member: cluster_leave_info_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_leave_info_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_leave_info_is_present, out);
    out << "\n";
  }

  // member: cluster_breakup_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_breakup_info:\n";
    to_block_style_yaml(msg.cluster_breakup_info, out, indentation + 2);
  }

  // member: cluster_breakup_info_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_breakup_info_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_breakup_info_is_present, out);
    out << "\n";
  }

  // member: cluster_id_change_time_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_id_change_time_info:\n";
    to_block_style_yaml(msg.cluster_id_change_time_info, out, indentation + 2);
  }

  // member: cluster_id_change_time_info_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_id_change_time_info_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_id_change_time_info_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VruClusterOperationContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_vam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer & msg)
{
  return etsi_its_vam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer>()
{
  return "etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer";
}

template<>
inline const char * name<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer>()
{
  return "etsi_its_vam_ts_msgs/msg/VruClusterOperationContainer";
}

template<>
struct has_fixed_size<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::ClusterJoinInfo>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::DeltaTimeQuarterSecond>::value> {};

template<>
struct has_bounded_size<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_vam_ts_msgs::msg::ClusterBreakupInfo>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::ClusterJoinInfo>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::DeltaTimeQuarterSecond>::value> {};

template<>
struct is_message<etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_OPERATION_CONTAINER__TRAITS_HPP_
