// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VruHighFrequencyContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/vru_high_frequency_container.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_HIGH_FREQUENCY_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_HIGH_FREQUENCY_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_vam_ts_msgs/msg/detail/vru_high_frequency_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'heading'
// Member 'orientation'
#include "etsi_its_vam_ts_msgs/msg/detail/wgs84_angle__traits.hpp"
// Member 'speed'
#include "etsi_its_vam_ts_msgs/msg/detail/speed__traits.hpp"
// Member 'longitudinal_acceleration'
#include "etsi_its_vam_ts_msgs/msg/detail/longitudinal_acceleration__traits.hpp"
// Member 'curvature'
#include "etsi_its_vam_ts_msgs/msg/detail/curvature__traits.hpp"
// Member 'curvature_calculation_mode'
#include "etsi_its_vam_ts_msgs/msg/detail/curvature_calculation_mode__traits.hpp"
// Member 'yaw_rate'
#include "etsi_its_vam_ts_msgs/msg/detail/yaw_rate__traits.hpp"
// Member 'lateral_acceleration'
#include "etsi_its_vam_ts_msgs/msg/detail/lateral_acceleration__traits.hpp"
// Member 'vertical_acceleration'
#include "etsi_its_vam_ts_msgs/msg/detail/vertical_acceleration__traits.hpp"
// Member 'vru_lane_position'
#include "etsi_its_vam_ts_msgs/msg/detail/generalized_lane_position__traits.hpp"
// Member 'environment'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_environment__traits.hpp"
// Member 'movement_control'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_movement_control__traits.hpp"
// Member 'roll_angle'
#include "etsi_its_vam_ts_msgs/msg/detail/cartesian_angle__traits.hpp"
// Member 'device_usage'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_device_usage__traits.hpp"

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VruHighFrequencyContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: heading
  {
    out << "heading: ";
    to_flow_style_yaml(msg.heading, out);
    out << ", ";
  }

  // member: speed
  {
    out << "speed: ";
    to_flow_style_yaml(msg.speed, out);
    out << ", ";
  }

  // member: longitudinal_acceleration
  {
    out << "longitudinal_acceleration: ";
    to_flow_style_yaml(msg.longitudinal_acceleration, out);
    out << ", ";
  }

  // member: curvature
  {
    out << "curvature: ";
    to_flow_style_yaml(msg.curvature, out);
    out << ", ";
  }

  // member: curvature_is_present
  {
    out << "curvature_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.curvature_is_present, out);
    out << ", ";
  }

  // member: curvature_calculation_mode
  {
    out << "curvature_calculation_mode: ";
    to_flow_style_yaml(msg.curvature_calculation_mode, out);
    out << ", ";
  }

  // member: curvature_calculation_mode_is_present
  {
    out << "curvature_calculation_mode_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.curvature_calculation_mode_is_present, out);
    out << ", ";
  }

  // member: yaw_rate
  {
    out << "yaw_rate: ";
    to_flow_style_yaml(msg.yaw_rate, out);
    out << ", ";
  }

  // member: yaw_rate_is_present
  {
    out << "yaw_rate_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw_rate_is_present, out);
    out << ", ";
  }

  // member: lateral_acceleration
  {
    out << "lateral_acceleration: ";
    to_flow_style_yaml(msg.lateral_acceleration, out);
    out << ", ";
  }

  // member: lateral_acceleration_is_present
  {
    out << "lateral_acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lateral_acceleration_is_present, out);
    out << ", ";
  }

  // member: vertical_acceleration
  {
    out << "vertical_acceleration: ";
    to_flow_style_yaml(msg.vertical_acceleration, out);
    out << ", ";
  }

  // member: vertical_acceleration_is_present
  {
    out << "vertical_acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vertical_acceleration_is_present, out);
    out << ", ";
  }

  // member: vru_lane_position
  {
    out << "vru_lane_position: ";
    to_flow_style_yaml(msg.vru_lane_position, out);
    out << ", ";
  }

  // member: vru_lane_position_is_present
  {
    out << "vru_lane_position_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vru_lane_position_is_present, out);
    out << ", ";
  }

  // member: environment
  {
    out << "environment: ";
    to_flow_style_yaml(msg.environment, out);
    out << ", ";
  }

  // member: environment_is_present
  {
    out << "environment_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.environment_is_present, out);
    out << ", ";
  }

  // member: movement_control
  {
    out << "movement_control: ";
    to_flow_style_yaml(msg.movement_control, out);
    out << ", ";
  }

  // member: movement_control_is_present
  {
    out << "movement_control_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.movement_control_is_present, out);
    out << ", ";
  }

  // member: orientation
  {
    out << "orientation: ";
    to_flow_style_yaml(msg.orientation, out);
    out << ", ";
  }

  // member: orientation_is_present
  {
    out << "orientation_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.orientation_is_present, out);
    out << ", ";
  }

  // member: roll_angle
  {
    out << "roll_angle: ";
    to_flow_style_yaml(msg.roll_angle, out);
    out << ", ";
  }

  // member: roll_angle_is_present
  {
    out << "roll_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.roll_angle_is_present, out);
    out << ", ";
  }

  // member: device_usage
  {
    out << "device_usage: ";
    to_flow_style_yaml(msg.device_usage, out);
    out << ", ";
  }

  // member: device_usage_is_present
  {
    out << "device_usage_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.device_usage_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VruHighFrequencyContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: heading
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading:\n";
    to_block_style_yaml(msg.heading, out, indentation + 2);
  }

  // member: speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed:\n";
    to_block_style_yaml(msg.speed, out, indentation + 2);
  }

  // member: longitudinal_acceleration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "longitudinal_acceleration:\n";
    to_block_style_yaml(msg.longitudinal_acceleration, out, indentation + 2);
  }

  // member: curvature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "curvature:\n";
    to_block_style_yaml(msg.curvature, out, indentation + 2);
  }

  // member: curvature_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "curvature_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.curvature_is_present, out);
    out << "\n";
  }

  // member: curvature_calculation_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "curvature_calculation_mode:\n";
    to_block_style_yaml(msg.curvature_calculation_mode, out, indentation + 2);
  }

  // member: curvature_calculation_mode_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "curvature_calculation_mode_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.curvature_calculation_mode_is_present, out);
    out << "\n";
  }

  // member: yaw_rate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yaw_rate:\n";
    to_block_style_yaml(msg.yaw_rate, out, indentation + 2);
  }

  // member: yaw_rate_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yaw_rate_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw_rate_is_present, out);
    out << "\n";
  }

  // member: lateral_acceleration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lateral_acceleration:\n";
    to_block_style_yaml(msg.lateral_acceleration, out, indentation + 2);
  }

  // member: lateral_acceleration_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lateral_acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lateral_acceleration_is_present, out);
    out << "\n";
  }

  // member: vertical_acceleration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vertical_acceleration:\n";
    to_block_style_yaml(msg.vertical_acceleration, out, indentation + 2);
  }

  // member: vertical_acceleration_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vertical_acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vertical_acceleration_is_present, out);
    out << "\n";
  }

  // member: vru_lane_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vru_lane_position:\n";
    to_block_style_yaml(msg.vru_lane_position, out, indentation + 2);
  }

  // member: vru_lane_position_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vru_lane_position_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vru_lane_position_is_present, out);
    out << "\n";
  }

  // member: environment
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "environment:\n";
    to_block_style_yaml(msg.environment, out, indentation + 2);
  }

  // member: environment_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "environment_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.environment_is_present, out);
    out << "\n";
  }

  // member: movement_control
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "movement_control:\n";
    to_block_style_yaml(msg.movement_control, out, indentation + 2);
  }

  // member: movement_control_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "movement_control_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.movement_control_is_present, out);
    out << "\n";
  }

  // member: orientation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "orientation:\n";
    to_block_style_yaml(msg.orientation, out, indentation + 2);
  }

  // member: orientation_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "orientation_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.orientation_is_present, out);
    out << "\n";
  }

  // member: roll_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll_angle:\n";
    to_block_style_yaml(msg.roll_angle, out, indentation + 2);
  }

  // member: roll_angle_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.roll_angle_is_present, out);
    out << "\n";
  }

  // member: device_usage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "device_usage:\n";
    to_block_style_yaml(msg.device_usage, out, indentation + 2);
  }

  // member: device_usage_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "device_usage_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.device_usage_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VruHighFrequencyContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_vam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer & msg)
{
  return etsi_its_vam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer>()
{
  return "etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer";
}

template<>
inline const char * name<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer>()
{
  return "etsi_its_vam_ts_msgs/msg/VruHighFrequencyContainer";
}

template<>
struct has_fixed_size<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_vam_ts_msgs::msg::CartesianAngle>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::Curvature>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::CurvatureCalculationMode>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::LateralAcceleration>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::LongitudinalAcceleration>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::Speed>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::VerticalAcceleration>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::VruDeviceUsage>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::VruEnvironment>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::VruMovementControl>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::Wgs84Angle>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::YawRate>::value> {};

template<>
struct has_bounded_size<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_vam_ts_msgs::msg::CartesianAngle>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::Curvature>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::CurvatureCalculationMode>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::LateralAcceleration>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::LongitudinalAcceleration>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::Speed>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::VerticalAcceleration>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::VruDeviceUsage>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::VruEnvironment>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::VruMovementControl>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::Wgs84Angle>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::YawRate>::value> {};

template<>
struct is_message<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_HIGH_FREQUENCY_CONTAINER__TRAITS_HPP_
