// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VruLowFrequencyContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/vru_low_frequency_container.hpp"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_LOW_FREQUENCY_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_LOW_FREQUENCY_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_vam_ts_msgs/msg/detail/vru_low_frequency_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'profile_and_subprofile'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_profile_and_subprofile__traits.hpp"
// Member 'size_class'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_size_class__traits.hpp"
// Member 'exterior_lights'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_exterior_lights__traits.hpp"

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VruLowFrequencyContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: profile_and_subprofile
  {
    out << "profile_and_subprofile: ";
    to_flow_style_yaml(msg.profile_and_subprofile, out);
    out << ", ";
  }

  // member: size_class
  {
    out << "size_class: ";
    to_flow_style_yaml(msg.size_class, out);
    out << ", ";
  }

  // member: size_class_is_present
  {
    out << "size_class_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.size_class_is_present, out);
    out << ", ";
  }

  // member: exterior_lights
  {
    out << "exterior_lights: ";
    to_flow_style_yaml(msg.exterior_lights, out);
    out << ", ";
  }

  // member: exterior_lights_is_present
  {
    out << "exterior_lights_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.exterior_lights_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VruLowFrequencyContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: profile_and_subprofile
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "profile_and_subprofile:\n";
    to_block_style_yaml(msg.profile_and_subprofile, out, indentation + 2);
  }

  // member: size_class
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "size_class:\n";
    to_block_style_yaml(msg.size_class, out, indentation + 2);
  }

  // member: size_class_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "size_class_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.size_class_is_present, out);
    out << "\n";
  }

  // member: exterior_lights
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "exterior_lights:\n";
    to_block_style_yaml(msg.exterior_lights, out, indentation + 2);
  }

  // member: exterior_lights_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "exterior_lights_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.exterior_lights_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VruLowFrequencyContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_vam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_vam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer & msg)
{
  return etsi_its_vam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer>()
{
  return "etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer";
}

template<>
inline const char * name<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer>()
{
  return "etsi_its_vam_ts_msgs/msg/VruLowFrequencyContainer";
}

template<>
struct has_fixed_size<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_vam_ts_msgs::msg::VruExteriorLights>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::VruProfileAndSubprofile>::value && has_fixed_size<etsi_its_vam_ts_msgs::msg::VruSizeClass>::value> {};

template<>
struct has_bounded_size<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_vam_ts_msgs::msg::VruExteriorLights>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::VruProfileAndSubprofile>::value && has_bounded_size<etsi_its_vam_ts_msgs::msg::VruSizeClass>::value> {};

template<>
struct is_message<etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_LOW_FREQUENCY_CONTAINER__TRAITS_HPP_
