// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_vam_ts_msgs:msg/YawRateConfidence.idl
// generated code does not contain a copyright notice

#include "etsi_its_vam_ts_msgs/msg/detail/yaw_rate_confidence__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_vam_ts_msgs
const rosidl_type_hash_t *
etsi_its_vam_ts_msgs__msg__YawRateConfidence__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x7f, 0x08, 0x78, 0xaa, 0xb8, 0x90, 0x75, 0x1e,
      0xd6, 0x5c, 0x1b, 0xec, 0xf4, 0x0e, 0xd0, 0xb9,
      0x9d, 0xa5, 0xb4, 0x46, 0x9c, 0x55, 0xaf, 0xd4,
      0x40, 0xae, 0x4b, 0xa5, 0x94, 0x9c, 0x80, 0xde,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_vam_ts_msgs__msg__YawRateConfidence__TYPE_NAME[] = "etsi_its_vam_ts_msgs/msg/YawRateConfidence";

// Define type names, field names, and default values
static char etsi_its_vam_ts_msgs__msg__YawRateConfidence__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_vam_ts_msgs__msg__YawRateConfidence__FIELDS[] = {
  {
    {etsi_its_vam_ts_msgs__msg__YawRateConfidence__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_vam_ts_msgs__msg__YawRateConfidence__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_vam_ts_msgs__msg__YawRateConfidence__TYPE_NAME, 42, 42},
      {etsi_its_vam_ts_msgs__msg__YawRateConfidence__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "# Copyright (c) 2024 Instituto de Telecomunica\\xc3\\xa7\\xc3\\xb5es, Universidade de Aveiro\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# YawRateConfidence ::= ENUMERATED {\n"
  "#     degSec-000-01 (0),\n"
  "#     degSec-000-05 (1),\n"
  "#     degSec-000-10 (2),\n"
  "#     degSec-001-00 (3), \n"
  "#     degSec-005-00 (4),\n"
  "#     degSec-010-00 (5),\n"
  "#     degSec-100-00 (6),\n"
  "#     outOfRange    (7),\n"
  "#     unavailable   (8)\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "# *\n"
  "# * This DE indicates the yaw rate confidence value which represents the estimated accuracy for a yaw rate value with a default confidence level of 95 %.\n"
  "# * If required, the confidence level can be defined by the corresponding standards applying this DE.\n"
  "# * \n"
  "# * The value shall be set to:\n"
  "# * - `0` if the confidence value is equal to or less than 0,01 degree/second,\n"
  "# * - `1` if the confidence value is equal to or less than 0,05 degrees/second or greater than 0,01 degree/second,\n"
  "# * - `2` if the confidence value is equal to or less than 0,1 degree/second or greater than 0,05 degree/second,\n"
  "# * - `3` if the confidence value is equal to or less than 1 degree/second or greater than 0,1 degree/second,\n"
  "# * - `4` if the confidence value is equal to or less than 5 degrees/second or greater than 1 degrees/second,\n"
  "# * - `5` if the confidence value is equal to or less than 10 degrees/second or greater than 5 degrees/second,\n"
  "# * - `6` if the confidence value is equal to or less than 100 degrees/second or greater than 10 degrees/second,\n"
  "# * - `7` if the confidence value is out of range, i.e. greater than 100 degrees/second,\n"
  "# * - `8` if the confidence value is unavailable.\n"
  "# * \n"
  "# * NOTE: The fact that a yaw rate value is received with confidence value set to `unavailable(8)` can be caused by\n"
  "# * several reasons, such as:\n"
  "# * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,\n"
  "# * - the sensor cannot calculate the accuracy due to lack of variables, or\n"
  "# * - there has been a vehicle bus (e.g. CAN bus) error.\n"
  "# * In all 3 cases above, the yaw rate value may be valid and used by the application.\n"
  "# * \n"
  "# * If a yaw rate value is received and its confidence value is set to `outOfRange(7)`, it means that the \n"
  "# * yaw rate value is not valid and therefore cannot be trusted. Such value is not useful the application.\n"
  "# * \n"
  "# * @category: Vehicle information\n"
  "# * @revision: Description revised in V2.1.1\n"
  "# \n"
  "\n"
  "uint8 value\n"
  "uint8 DEG_SEC_000_01 = 0\n"
  "uint8 DEG_SEC_000_05 = 1\n"
  "uint8 DEG_SEC_000_10 = 2\n"
  "uint8 DEG_SEC_001_00 = 3\n"
  "uint8 DEG_SEC_005_00 = 4\n"
  "uint8 DEG_SEC_010_00 = 5\n"
  "uint8 DEG_SEC_100_00 = 6\n"
  "uint8 OUT_OF_RANGE = 7\n"
  "uint8 UNAVAILABLE = 8\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_vam_ts_msgs__msg__YawRateConfidence__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_vam_ts_msgs__msg__YawRateConfidence__TYPE_NAME, 42, 42},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 4121, 4121},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_vam_ts_msgs__msg__YawRateConfidence__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_vam_ts_msgs__msg__YawRateConfidence__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
